
// EditIcon.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEditIcon dialog

class CEditIcon : public CDialog
{
// Construction
public:
	CEditIcon(CWnd* pParent = NULL);   // standard constructor
	~CEditIcon();

// Dialog Data
	//{{AFX_DATA(CEditIcon)
	enum { IDD = IDD_EDIT_ICON };
	//}}AFX_DATA

	CIconBuf* m_Icon;					// buffer ikon
//	BYTE* m_Data;						// data ikony
	BYTE* m_Push;						// buffer k mezischov dat

	BYTE* m_Undo;						// undo buffer
	int m_UndoNum;						// poet obrzk v undo bufferu
	int m_UndoAkt;						// aktivn ukazatel ukldn do undo bufferu
	int m_UndoMax;						// max. velikost undo bufferu
	int m_UndoItem;						// slo ikony v undo bufferu

	int m_Item;							// slo editovan ikony (-2 = ikona sprajtu)
	int m_dWidth;						// ka zobrazen ikony
	int m_dHeight;						// vka zobrazen ikony
	int m_dLeft;						// potek X zobrazen ikony
	int m_dTop;							// potek Y zobrazen ikony
	int m_incx;							// prustek bod ve smru X
	int m_incy;							// prustek bod ve smru Y

	int m_Width;						// ka ikony
	int m_Height;						// vka ikony
	int m_WidthByte;					// dlka linky v bajtech

	BYTE* m_BufCol;						// buffer obrzku palet
	int m_ColX;							// poet barev X
	int m_ColXByte;						// ka obrzku barev v bajtech
	int	m_ColY;							// poet barev Y
	int m_cWidth;						// zobrazen ka barev
	int m_cHeight;						// zobrazen vka barev
	int m_cLeft;						// potek zobrazen barev X
	int m_cTop;							// potek zobrazen barev Y
	int m_cincx;						// prustek barev X
	int m_cincy;						// prustek barev Y

	int m_ReDisp;						// ta poadavku aktualizace strom (0 = nen)
	UINT m_Timer;						// identifiktor asovae

	int	m_EditMode;						// aktivn editan md
	int m_OldEditMode;					// editan md ped volbou kaptka

	BOOL m_Editing;						// probh editovn ry (i jinho prvku)
	BOOL m_Moving;						// je pesouvni bloku
	BOOL m_Selecting;					// je oznaen blok

	int m_OldX;							// pvodn souadnice kreslen X
	int m_OldY;							// pvodn souadnice kreslen Y

	int		m_TopX;						// poten souadnice X pi taen
	int		m_TopY;						// poten souadnice Y pi taen
	int		m_EndX;						// koncov souadnice X bloku
	int		m_EndY;						// koncov souadnice Y bloku

	int m_FirstTopX;					// vchoz poten souadnice X pi posunu bloku
	int m_FirstTopY;					// vchoz poten souadnice Y pi posunu bloku

	int m_CitRnd;						// ta nhodnho sla

	int m_X, m_Y;						// souadnice kurzoru myi v obrzku

	CBitmap m_Pozadi;					// bitmapa pozad
	CBitmap m_Pozadi2;					// bitmapa pozad2

	BYTE m_ColLeft;						// barva pro lev tlatko
	BYTE m_ColRight;					// barva pro prav tlatko
	BYTE m_ColInd;						// barva indiktoru barvy (-1 = nen)

	HCURSOR m_CurAkt;					// aktivn kurzor
	HCURSOR m_CurArrow;					// standardn kurzor
	HCURSOR m_CurPen;					// kurzor - pero
	HCURSOR m_CurPaint;					// kurzor - ttec
	HCURSOR m_CurLine;					// kurzor - ra
	HCURSOR m_CurSpray;					// kurzor - sprej
	HCURSOR m_CurFill;					// kurzor - vpl
	HCURSOR m_CurRect;					// kurzor - obdlnk
	HCURSOR m_CurRound;					// kurzor - kruh
	HCURSOR m_CurElip;					// kurzor - elipsa
	HCURSOR m_CurKapatko;				// kurzor - kaptko
	HCURSOR m_CurSelect;				// kurzor - vbr
	HCURSOR m_CurSelMove;				// kurzor - pesun vbru
	HCURSOR m_CurRuka;					// kurzor - ruka

	void OnPaintDC(CDC& dc);
	void IconPaint(CDC* dc);
	void DispCol(BYTE col);
	void DispSelCol(BYTE col, int posun);
	void SetPoint(int x, int y, BYTE col, CDC* dc);
	void SetPaint(int x, int y, BYTE col, CDC* dc);
	void SetLine(int x1, int y1, int x2, int y2, BYTE col, CDC* dc);
	void SetLinePaint(int x1, int y1, int x2, int y2, BYTE col, CDC* dc);
	void ReDisp();
	void SetEditMode(int mode);
	void EditBlok(int mode);
	void Push();
	void Pop(CDC* dc);
	void SetSpray(int x, int y, BYTE col, CDC* dc);
	void SetSpray0(int x, int y, BYTE col, CDC* dc);
	void SetFill(int x, int y, BYTE col, BYTE fil, CDC* dc);
	void SetRect(int x1, int y1, int x2, int y2, BYTE col, CDC* dc);
	void SetRound(int x1, int y1, int x2, int y2, BYTE col, CDC* dc);
	void SetElip(int x1, int y1, int x2, int y2, BYTE col, CDC* dc);
	void DispSelect(CDC* dc);
	void MoveSelect(CDC* dc);
	void PushUndo();
	void PopUndo();
	void Undo();
	void Redo();
	void SetColInd(BYTE col);


// adresa dat ikony
	BYTE* GetData();

// zahjen editace ikony
	void BegEdit(int Index);

// poskytnut barvy bodu
	inline BYTE GetPoint(int x, int y)
	{
		BYTE* data = GetData();
		return data[m_WidthByte*(m_Height-1-y) + x];
	}

// poskytnut barvy bodu ze zsobnku
	inline BYTE GetPush(int x, int y)
	{
		return m_Push[m_WidthByte*(m_Height-1-y) + x];
	}

// zobrazen obdlnku (dc = NULL nekreslit na displej)
	inline void DispPoint(RECT* rc, BYTE col, CDC* dc)
	{
		if (dc == NULL) return;							// nen vstup na displej

		CBrush brush;									// ttec
		if (col == 0)									// je pozad ?
			if ((m_incx > 12) && (m_incy > 12))
				brush.CreatePatternBrush(&m_Pozadi2);	// barva pro pozad 2
			else
				brush.CreatePatternBrush(&m_Pozadi);	// barva pro pozad
		else
			brush.CreateSolidBrush(PALETTEINDEX(col));	// pln barva
		dc->FillRect(rc, &brush);
	}

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditIcon)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEditIcon)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	void OnUpdatePen(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
};
