// EditMap.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEditMap dialog

class CEditMap : public CDialog
{
// Construction
public:
	CEditMap(CWnd* pParent = NULL);   // standard constructor
	virtual ~CEditMap();

// Dialog Data
	//{{AFX_DATA(CEditMap)
	enum { IDD = IDD_EDIT_MAP };
	CScrollBar			m_HScroll;
	CScrollBar			m_VScroll;
	//}}AFX_DATA

	CMapBuf*	m_Map;				// adresa bufferu map
	CIconBuf*	m_Icon;				// adresa bufferu ikon
	
	CIconBuf	m_SwcBuf;			// buffer obrzk pepna

	int		m_EditMode;				// editan md (0 = bn bez pepna)

// primrn parametry plochy
	int		m_Index;				// index editovan mapy
//	MAP*	m_Data;					// ukazatel na data plochy
	int		m_Width;				// ka editovan plochy (polek)
	int		m_Height;				// vka editovan plochy (polek)
	int		m_IconWidth;			// ka ikony (bod)
	int		m_IconHeight;			// vka ikony (bod)

// uivatelem nastaven potek zobrazen plochy
	int		m_tLeft;				// poten bod plochy vlevo
	int		m_tBottom;				// poten bod plochy dole

// rozmry ikony v bodech celkem
	int		m_mWidth;				// ka editovan plochy celkem (v bodech)
	int		m_mHeight;				// vka editovan plochy celkem (v bodech)

// souadnice klientsk oblasti pro plochu
	int		m_cWidth;				// ka klientsk oblasti pro editovanou plochu
	int		m_cHeight;				// vka klientsk oblasti pro editovanou plochu

// skuten zobrazen st plochy v bodech
	int		m_dWidth;				// ka zobrazen sti plochy v bodech
	int		m_dHeight;				// vka zobrazen sti plochy v bodech
	int		m_dLeft;				// lev potek zobrazen sti plochy
	int		m_dTop;					// horn potek zobrazen sti plochy

// skuten zobrazen st plochy v ikonch (okrajov ikony mohou bt zobrazeny nepln)
	int		m_iLeft;				// lev prvn zobrazen ikona (i necel)
	int		m_iBottom;				// spodn prvn zobrazen ikona (i necel)
	int		m_iRight;				// prav posledn zobrazen ikona (i necel)
	int		m_iTop;					// horn posledn zobrazen ikona (i necel)

// nepln zobrazen okrajovch ikon (rozsah 1 a m_IconWidth,m_IconHeight)
	int		m_oLeft;				// poet bod ikony vlevo
	int		m_oBottom;				// poet bod ikony dole
	int		m_oRight;				// poet bod ikony vpravo
	int		m_oTop;					// poet bod ikony nahoe

// posuvnky
	BOOL	m_HScrollDisp;			// horizontln posuvnk zapnut
	BOOL	m_VScrollDisp;			// vertikln posuvnk zapnut

	int		m_X;					// aktuln souadice kurzoru myi (v ikonch)
	int		m_Y;					// aktuln souadice kurzoru myi (v ikonch)

// obsluha taen
	BOOL	m_BegDrag;				// je mon zahjen taen
	int		m_BegX;					// poten souadnice kurzoru myi X ped taenm
	int		m_BegY;					// poten souadnice kurzoru myi Y ped taenm
	BOOL	m_Copy;					// pznak mdu kopie (prav tlatko)
	BOOL	m_Draging;				// zahjen md taen
	int		m_DragX;				// taen prvek - souadnice X
	int		m_DragY;				// taen prvek - souadnice Y
	CSize	m_HotSpot;				// bod uchycen taenho prvku
	CIconBuf	m_DragIcon;			// buffer taen ikony
	CImageList*	m_DragList;			// seznam obrzk pro taen


	HCURSOR		m_CurAkt;			// aktivn kurzor
	HCURSOR		m_CurArrow;			// standardn kurzor ipky (IDC_ARROW)
	HCURSOR		m_CurSelect;		// kurzor pro vbr
	HCURSOR		m_CurSelMove;		// kurzor - pesun vbru
	HCURSOR		m_CurCopy;			// kurzor koprovn
	HCURSOR		m_CurMove;			// kurzor pesunu
	HCURSOR		m_CurDelete;		// taen se zruenm
	HCURSOR		m_CurNoDrag;		// zkaz taen

	void BegEdit(int Index);
	void Recalc();
	void DispSirkaVyska();
	void OnSetMapSirka();
	void OnSetMapVyska();
	void SetScroll();
	void DragDrop(int item);
	void EndDrag();
	void SetEditMode(int mode);
	void UpdateEditMode(CCmdUI* pCmdUI, int mode);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditMap)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:

	// Generated message map functions
	//{{AFX_MSG(CEditMap)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	virtual BOOL OnInitDialog();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
