// EditSnd.cpp : implementation file
//

#include "stdafx.h"
#include "peter.h"
#include "SndBuf.h"
#include "EditSnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const WAVFORMAT wavstd = {
// popisova souboru
	'R', 'I', 'F', 'F',							// (4) identifikace souboru (= "RIFF")
	sizeof(WAVFORMAT) - 8,						// (4) velikost souboru bez 8 bajt (na toto zhlav)

// popisova formtu
	'W', 'A', 'V', 'E', 'f', 'm', 't', ' ',		// (8) identifikace zhlav formtu (= "WAVEfmt")
	16,											// (4) velikost nsledujcch dat popisovae formtu (= 0x10)
	1,											// (2) formt dat (1 = PCM)
	1,											// (2) poet kanl (1 = mono, 2 = stereo)
	22050,										// (4) vzorkovac kmitoet (vzork za sekundu)
	22050,										// (4) penosov rychlost (bajt za sekundu)
	1,											// (2) zarovnvn dat (bity*kanly/8)
	8,											// (2) poet bit na jeden vzorek

// popisova dat
	'd', 'a', 't', 'a',							// (4) identifikace dat "data"
	0											// (4) velikost nsledujcch dat (v bajtech)
};

/////////////////////////////////////////////////////////////////////////////
// CEditSound dialog


CEditSound::CEditSound(CWnd* pParent /*=NULL*/)
	: CDialog(CEditSound::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditSound)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_Mode = 0;
	m_Index = -1;
	m_Data = NULL;
	m_DataMax = sizeof(WAVFORMAT) + SOUNDDEFBYTES*SOUNDMAXLENGTH;
	m_DataNum = 0;
	m_hWaveIn = NULL;					// nen oteveno nahrvac zazen
	m_TimerID = 0;						// nen asova
	Aloc(m_Data, m_DataMax);
}

CEditSound::~CEditSound()
{
	Stop();
	Aloc(m_Data, 0);
}

void CEditSound::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditSound)
	DDX_Control(pDX, IDC_EDIT_SOUND_60, m_Text60);
	DDX_Control(pDX, IDC_EDIT_SOUND_50, m_Text50);
	DDX_Control(pDX, IDC_EDIT_SOUND_40, m_Text40);
	DDX_Control(pDX, IDC_EDIT_SOUND_30, m_Text30);
	DDX_Control(pDX, IDC_EDIT_SOUND_20, m_Text20);
	DDX_Control(pDX, IDC_EDIT_SOUND_10, m_Text10);
	DDX_Control(pDX, IDC_EDIT_SOUND_0, m_Text0);
	DDX_Control(pDX, IDC_EDITSOUND_PROGRES, m_Progress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditSound, CDialog)
	//{{AFX_MSG_MAP(CEditSound)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// zahjen editace

void CEditSound::BegEdit(int index)
{
	if ((index < 0) || (index >= m_Sound->GetSize()))
		return;

	Stop();

	m_Index = index;

	WAVFORMAT* data = m_Sound->Get(index);
	m_DataNum = m_Sound->SoundSize(data);
	if (m_DataNum > m_DataMax)
	{
		m_DataMax = m_DataNum;
		Aloc(m_Data, m_DataMax);
	}
	memcpy(m_Data, data, m_DataNum);

	Stop();
}

/////////////////////////////////////////////////////////////////////////////
// nahrvn

void CEditSound::Record()
{
// kontrola, zda je stav klidu
	if (m_Mode != 0) return;

// pprava struktury popisovae formtu
	m_WaveFormat.wFormatTag = WAVE_FORMAT_PCM;		// formt dat
	m_WaveFormat.nChannels = SOUNDDEFCHANNELS;		// poet kanl
	m_WaveFormat.nSamplesPerSec = SOUNDDEFRATE;		// vzorkovac kmitoet
	m_WaveFormat.nAvgBytesPerSec = SOUNDDEFBYTES;	// penosov rychlost dat
	m_WaveFormat.nBlockAlign = (SOUNDDEFBITS*SOUNDDEFCHANNELS)/8;	// zarovnvn dat
	m_WaveFormat.wBitsPerSample = SOUNDDEFBITS;		// poet bit na vzorek
	m_WaveFormat.cbSize = 0;						// doplkov data ve struktue

// oteven nahrvacho zazen
	MMRESULT mmResult = ::waveInOpen(
		&m_hWaveIn,									// handle zazen
		WAVE_MAPPER,								// vybrat nejvhodnj zazen
		&m_WaveFormat,								// popisova formtu
		NULL,										// nen CALLBACK funkce
		NULL,										// data CALLBACK
		CALLBACK_NULL);								// nen CALLBACK
	if (mmResult != MMSYSERR_NOERROR) return;

// pprava struktury popisovae dat
	m_WaveHeader.lpData = m_Data;					// adresa bufferu pro data
	m_WaveHeader.dwBufferLength = m_DataMax;		// velikost bufferu
	m_WaveHeader.dwBytesRecorded = sizeof(WAVFORMAT); // poet dat v bufferu
	m_WaveHeader.dwUser = 0;						// uivatelsk data
	m_WaveHeader.dwFlags = 0;						// parametry
	m_WaveHeader.dwLoops = 1;						// poet opakovn
	m_WaveHeader.lpNext = NULL;						// nen dal buffer
	m_WaveHeader.reserved = 0;

// pprava bufferu k nahrvn
	::waveInPrepareHeader(
		m_hWaveIn,									// handle zazen
		&m_WaveHeader,								// popisova dat
		sizeof(WAVEHDR));							// velikost popisovae dat

// pedn bufferu nahrvacmu zazen
	::waveInAddBuffer(
		m_hWaveIn,									// handle zazen
		&m_WaveHeader,								// popisova dat
		sizeof(WAVEHDR));							// velikost popisovae dat

// indiktor operace
	m_DataNum = sizeof(WAVFORMAT);					// poet dat v bufferu
	m_Progress.SetRange(0,2*SOUNDMAXLENGTH);
	m_Progress.SetPos(0);

// start asovae
	m_PlayCount = 0;
	m_TimerID = SetTimer(SOUNDTIMERID, 490, NULL);

// zahjen nahrvn
	::waveInStart(m_hWaveIn);						// zahjen nahrvn

// pznak mdu nahrvn
	m_Mode = 2;										// md nahrvn
}

/////////////////////////////////////////////////////////////////////////////
// pehrvn

void CEditSound::Play()
{
// kontrola, zda je stav klidu a zda je co pehrvat
	if ((m_Mode != 0) || (m_DataNum <= sizeof(WAVFORMAT))) return;

	m_Mode = 1;										// md pehrvn

// ta asu pro pehrt
	WAVFORMAT* head = (WAVFORMAT*)m_Data;		// buffer s daty
	int sounddefbytes = head->nSamplesPerSec*head->nChannels*head->wBitsPerSample/8;

	m_PlayCount = 2*(m_DataNum - sizeof(WAVFORMAT) + (sounddefbytes/4))/sounddefbytes;
	m_PlayCount0 = m_PlayCount;

// pehrt zvuku
	PlaySound(m_Data, NULL, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);

	m_Progress.SetRange(0,2*SOUNDMAXLENGTH);
	m_Progress.SetPos(0);

// start asovae
	m_TimerID = SetTimer(SOUNDTIMERID, 490, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// zastaven

void CEditSound::Stop()
{
// ukonen nahrvn
	if (m_Mode == 2)
	{

// peruen probhajcho nahrvn
		::waveInStop(m_hWaveIn);
		::waveInReset(m_hWaveIn);

// uvolnn bufferu
		::waveInUnprepareHeader(
			m_hWaveIn,								// handle zazen
			&m_WaveHeader,							// popisova dat
			sizeof(WAVEHDR));						// velikost popisovae dat

// schova velikosti dat
		m_DataNum = m_WaveHeader.dwBytesRecorded;
		if (m_DataNum > m_DataMax)
			m_DataNum = m_DataMax;
		if (m_DataNum < sizeof(WAVFORMAT))
			m_DataNum = sizeof(WAVFORMAT);
//		m_Progress.SetPos((m_DataNum-sizeof(WAVFORMAT) + SOUNDDEFBYTES/2)/SOUNDDEFBYTES);

// uzaven nahrvacho zazen
		::waveInClose(m_hWaveIn);					// uzaven zaizen
		m_hWaveIn = NULL;							// zruen handle zazen

// nastaven zhlav v bufferu
		WAVFORMAT* head = (WAVFORMAT*)m_Data;		// buffer s daty
		*head = wavstd;								// nastaven standardnho zhlav
		head->nFileSize = m_DataNum - 8;			// velikost souboru bez zhlav
		head->nDataSize = m_DataNum - sizeof(WAVFORMAT);// velikost dat

// uloen do bufferu zvuk
		if ((m_Index >= 0) && (m_Index < m_Sound->GetSize()))
		{
			m_Sound->CopyDat(m_Index, head);
		}
	}

// ukonen pehrvn
	if (m_Mode == 1)
	{
		PlaySound(NULL, NULL, SND_SYNC);
	}

// zruen asovae
	if (m_TimerID != 0)
	{
		if (::IsWindow(m_hWnd))
		{
			KillTimer(m_TimerID);
		}
		m_TimerID = 0;
	}

	if (::IsWindow(m_Progress.m_hWnd))
	{
		m_Progress.SetRange(0,2*SOUNDMAXLENGTH);

		WAVFORMAT* head = (WAVFORMAT*)m_Data;		// buffer s daty

		if(m_DataNum > sizeof(WAVFORMAT))
		{
			int sounddefbytes = head->nSamplesPerSec*head->nChannels*head->wBitsPerSample/8;
			m_Progress.SetPos(2*(m_DataNum-sizeof(WAVFORMAT) + (4*sounddefbytes/5))/sounddefbytes);
		}
		else
		{
			m_Progress.SetPos(0);
		}
	}

	m_Mode = 0;										// pznak vypnut
}


void CEditSound::OnClose() 
{
	Stop();	
	PlaySound(NULL, NULL, SND_SYNC);
	
	CDialog::OnClose();
}

void CEditSound::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == SOUNDTIMERID)
	{
		if (m_Mode == 2)
		{
// naten nahrvan pozice
//			m_mmTime.wType = TIME_SAMPLES;
//			m_mmTime.u.sample = 0;
//			::waveInGetPosition(m_hWaveIn, &m_mmTime, sizeof(MMTIME));
//			m_DataNum = m_mmTime.u.sample*(SOUNDDEFBITS/8);
//			m_Progress.SetPos(((m_DataNum - sizeof(WAVFORMAT))/SOUNDDEFBYTES));

// zastaven nahrvn pi peteen bufferu

			m_PlayCount++;

			if (((m_WaveHeader.dwFlags & WHDR_DONE) != 0) ||
				(m_PlayCount > (2*SOUNDMAXLENGTH+4)))
			{
				Stop();
			}
			else
			{
				m_Progress.SetPos(m_PlayCount);
			}
		}

		if (m_Mode == 1)
		{
			m_PlayCount--;
			if (m_PlayCount <= 0)
			{
				Stop();
			}
			else
			{
				m_Progress.SetPos(m_PlayCount0-m_PlayCount);
			}
		}
		return;
	}

	CDialog::OnTimer(nIDEvent);
}

BOOL CEditSound::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_Progress.SetRange(0,2*SOUNDMAXLENGTH);
	m_Progress.SetPos(0);
	
	return TRUE; 
}

void CEditSound::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (::IsWindow(m_Progress.m_hWnd))
	{
		CRect rc;
		GetClientRect(&rc);

		int height = (rc.bottom + rc.right) / 70;
		if (height < 12)
			height = 12;

		rc.left += height/2;
		rc.right -= height/2;
		rc.top = (rc.bottom - 2*height)/ 2;
		rc.bottom = rc.top + height;

		m_Progress.MoveWindow(rc);

		height = (rc.right - rc.left - 6)/6;

		rc.top = rc.bottom + 4;
		rc.bottom = rc.top + 20;

		rc.right = rc.left + height;
		m_Text0.MoveWindow(rc);

		rc.left += height;
		rc.right = rc.left + height;
		m_Text10.MoveWindow(rc);

		rc.left += height;
		rc.right = rc.left + height;
		m_Text20.MoveWindow(rc);

		rc.left += height;
		rc.right = rc.left + height;
		m_Text30.MoveWindow(rc);

		rc.left += height;
		rc.right = rc.left + height;
		m_Text40.MoveWindow(rc);

		rc.left += height;
		rc.right = rc.left + height;
		m_Text50.MoveWindow(rc);

		rc.left += height;
		rc.right = rc.left + height;
		m_Text60.MoveWindow(rc);

	}	
}
