// EditSprite.cpp : implementation file
//

#include "stdafx.h"
#include "peter.h"

#include "Select.h"
#include "IconBuf.h"
#include "TextBuf.h"
#include "RealBuf.h"
#include "BoolBuf.h"
#include "MapBuf.h"
#include "SprtBuf.h"
#include "SndBuf.h"
#include "ProgBuf.h"
#include "EditDial.h"
#include "EditSprt.h"
#include "EditIcon.h"
#include "EditMap.h"
#include "EditSnd.h"
#include "Prog.h"
#include "MainFrm.h"
#include "Exec.h"
#include "SprtPar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TRACKSIRKA		16					// ka posuvnku
#define TIMERID			3612				// ID asovae

/////////////////////////////////////////////////////////////////////////////
// CEditSprite dialog

CEditSprite::CEditSprite(CWnd* pParent)
	: CDialog(CEditSprite::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditSprite)
	//}}AFX_DATA_INIT

//	m_Data = NULL;						// nejsou data
	m_Width = SPRITEDEFFAZE;			// poet fz sprajtu
	m_Height = SPRITEDEFSMER;			// poet smr sprajtu
	m_IconWidth = 32;					// ka ikony
	m_IconHeight = 32;					// vka ikony
	m_IconSize = 32*32;					// velikost ikony
	m_DragList = NULL;
	m_BegDrag = FALSE;					// nen zahjeno taen
	m_FilEdit = FALSE;					// nen plnn editanch pol
	m_TestData = NULL;					// nen testovac plocha
	m_Index = 0;

	m_tLeft = 0;						// poten bod plochy vlevo
	m_tTop = 0;						// poten bod plochy dole

	m_X = -1;
	m_Y = -1;

	m_TestMode = FALSE;					// nen testovac md

	m_Draging = FALSE;					// nen taen

	m_CurArrow = ::LoadCursor(0, MAKEINTRESOURCE(IDC_ARROW));
	ASSERT(m_CurArrow != NULL);

	m_CurSelect = ::LoadCursor(AfxGetResourceHandle(), MAKEINTRESOURCE(IDC_SELECT));
	ASSERT(m_CurSelect != NULL);

	m_CurSelMove = ::LoadCursor(AfxGetResourceHandle(), MAKEINTRESOURCE(IDC_SELECTMOVE));
	ASSERT(m_CurSelMove != NULL);

	m_CurCopy = ::LoadCursor(AfxGetResourceHandle(), MAKEINTRESOURCE(IDC_COPY));
	ASSERT(m_CurCopy != NULL);

	m_CurMove = ::LoadCursor(AfxGetResourceHandle(), MAKEINTRESOURCE(IDC_MOVE));
	ASSERT(m_CurMove != NULL);

	m_CurDelete = ::LoadCursor(AfxGetResourceHandle(), MAKEINTRESOURCE(IDC_DELETE));
	ASSERT(m_CurDelete != NULL);

	m_CurNoDrag = ::LoadCursor(AfxGetResourceHandle(), MAKEINTRESOURCE(IDC_NODRAG));
	ASSERT(m_CurNoDrag != NULL);

	m_CurCil = ::LoadCursor(AfxGetResourceHandle(), MAKEINTRESOURCE(IDC_CIL));
	ASSERT(m_CurCil != NULL);
}

CEditSprite::~CEditSprite()
{
	if (m_DragList != NULL)
		delete m_DragList;

// zruen testovac plochy
	Aloc(m_TestData, 0);
}


void CEditSprite::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditSprite)
	DDX_Control(pDX, IDC_EDITSPRITE_HSCROLL, m_HScroll);
	DDX_Control(pDX, IDC_EDITSPRITE_VSCROLL, m_VScroll);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditSprite, CDialog)
	//{{AFX_MSG_MAP(CEditSprite)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONDBLCLK()
	ON_WM_LBUTTONUP()
	ON_WM_SETCURSOR()
	ON_WM_RBUTTONUP()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// uzaven okna

void CEditSprite::OnClose() 
{
	CDialog::OnClose();

// zruen asovae
	if (m_TimerID)						// je asova ?
	{
		KillTimer(m_TimerID);			// zruen asovae
		m_TimerID = 0;
	}
}

/////////////////////////////////////////////////////////////////////////////
// nastaven ky a vky pomoc editanch pol (aktualizuje zobrazen)

void CEditSprite::OnSetSpriteFaze()
{
// lokln promnn
	CString txt;				// buffer textu
	int faze;					// naten hodnota potu fz
	CEdit* edit;				// pracovn prvek editanho pole

// pednastaven pro ppad nespchu
	faze = m_Width;

// zjitn editanho pole
	edit = (CEdit*)(MainFrame->
			m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_FAZE_EDIT));
	if (edit != NULL)
	{

// naten textu z editanho pole
		edit->GetWindowText(txt);

// naten zadanho sla
#ifdef	_UNICODE
		swscanf(txt, _T("%d"), &faze);
#else
		sscanf(txt, _T("%d"), &faze);
#endif
	}

// kontrola zadan hodnoty
	if (faze < 1) faze = m_Width;
	if (faze > MAXSPRITEFAZE) faze = MAXSPRITEFAZE;

// slo nezmnno - aktualizace zobrazen
	if (faze == m_Width)
	{
		DispFazeSmer();
	}

// nastaven novho zadanho sla
	else
	{
		m_Sprite->SetSize(m_Index, faze, m_Height);
		BegEdit(m_Index);
	}
}

void CEditSprite::OnSetSpriteSmer()
{
// lokln promnn
	CString txt;				// buffer textu
	int smer;					// naten hodnota potu smr
	CEdit* edit;				// pracovn prvek editanho pole

// pednastaven pro ppad nespchu
	smer = m_Height;

// zjitn editanho pole
	edit = (CEdit*)(MainFrame->
			m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_SMER_EDIT));
	if (edit != NULL)
	{

// naten textu z editanho pole
		edit->GetWindowText(txt);

// naten zadanho sla
#ifdef	_UNICODE
		swscanf(txt, _T("%d"), &smer);
#else
		sscanf(txt, _T("%d"), &smer);
#endif
	}

// kontrola zadan hodnoty
	if (smer < 1) smer = m_Height;
	if (smer > MAXSPRITESMER) smer = MAXSPRITESMER;

// slo nezmnno - aktualizace zobrazen
	if (smer == m_Height)
	{
		DispFazeSmer();
	}

// nastaven novho zadanho sla
	else
	{
		m_Sprite->SetSize(m_Index, m_Width, smer);
		BegEdit(m_Index);
	}
}

/////////////////////////////////////////////////////////////////////////////
// zahjen editace (i opakovan po zmn rozmr)

void CEditSprite::BegEdit(int Index)
{
	EndTest();

	if (Index < 0) Index = 0;
	m_Index = Index;

//	m_Data = m_Sprite->Get(Index);

	SPRITE* data = m_Sprite->Get(Index);

	m_Width = data->faze;
	m_Height = data->smer;
	m_IconWidth = SPRITEDEFWIDTH; //data->width;
	m_IconHeight = SPRITEDEFHEIGHT; //data->height;
	m_IconSize = m_IconWidth * m_IconHeight;

	m_mWidth = m_Width * m_IconWidth;
	m_mHeight = m_Height * m_IconHeight;

	if (m_oLeft > m_IconWidth) m_oLeft = m_IconWidth;
	if (m_oRight > m_IconWidth) m_oRight = m_IconWidth;
	if (m_oTop > m_IconHeight) m_oTop = m_IconHeight;
	if (m_oBottom > m_IconHeight) m_oBottom = m_IconHeight;

	DispFazeSmer();

	Recalc();
	SetScroll();
	Invalidate(TRUE);
}


/////////////////////////////////////////////////////////////////////////////
// zobrazen aktulnho nastaven fze a smru

void CEditSprite::DispFazeSmer()
{
	CEdit* edit;				// pracovn prvek editanho pole
	TCHAR buff[50];				// buffer k dekdovn textu sla

	m_FilEdit = TRUE;			// pznak plnn editanch pol
	SPRITE* data = m_Sprite->Get(m_Index);

// poet fz
	wsprintf(buff, _T("%d"), m_Width);
	edit = (CEdit*)(MainFrame->
			m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_FAZE_EDIT));
	if (edit != NULL)
	{
		edit->SetWindowText(buff);
	}

// poet smr
	wsprintf(buff, _T("%d"), m_Height);
	edit = (CEdit*)(MainFrame->
			m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_SMER_EDIT));
	if (edit != NULL)
	{
		edit->SetWindowText(buff);
	}

// prodleva
	wsprintf(buff, _T("%d"), data->delay);
	edit = (CEdit*)(MainFrame->
			m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_DELAY_EDIT));
	if (edit != NULL)
	{
		edit->SetWindowText(buff);
	}

// krok
	wsprintf(buff, _T("%d"), data->krok);
	edit = (CEdit*)(MainFrame->
			m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_KROK_EDIT));
	if (edit != NULL)
	{
		edit->SetWindowText(buff);
	}

	m_FilEdit = FALSE;				// konec plnn editanch pol
}


/////////////////////////////////////////////////////////////////////////////
// pepoet rozmr plochy

void CEditSprite::Recalc()
{
// lokln promnn
	CRect	rc;							// klientsk oblast celho okna

	MAP* map = m_Map->Get(0);

// rozmry klientsk oblasti pro editovanou plochu
	GetClientRect(&rc);					// naten rozmr okna
	m_cWidth = rc.right;				// ka klientsk oblasti pro plochu
	m_cHeight = rc.bottom;				// vka klientsk oblasti pro plochu

// rozmry a poloha plochy pro testovac reim
	if (m_TestMode)
	{
		m_TestWidthN = rc.right/m_IconWidth; // ka plochy v ikonch
		if (m_TestWidthN <= 0)
			m_TestWidthN = 1;				// minimln ka
		if (m_TestWidthN > map->width)
			m_TestWidthN = map->width;
		m_TestWidth = m_TestWidthN * m_IconWidth; // ka v bodech
		m_TestLeft = (rc.right - m_TestWidth)/2; // lev okraj plochy

		m_TestHeightN = rc.bottom/m_IconHeight; // vka plochy v ikonch
		if (m_TestHeightN > map->height)
			m_TestHeightN = map->height;
		if (m_TestHeightN <= 0)
			m_TestHeightN = 1;				// minimln vka
		m_TestHeight = m_TestHeightN * m_IconHeight; // vka v bodech
		m_TestTop = (rc.bottom - m_TestHeight)/2; // horn okraj plochy
	}

// zmenen vky, je-li horizontln posuvnk
	if (m_cWidth - TRACKSIRKA < m_mWidth)
	{
		m_cHeight -= TRACKSIRKA;		// snen vky klientsk oblasti
		if (m_cHeight < 1) m_cHeight = 1; // ochrana ped nesmysly
	}

// zmenen ky, je-li vertikln posuvnk
	if (m_cHeight < m_mHeight)
	{
		m_cWidth -= TRACKSIRKA;			// snen ky klientsk oblasti
		if (m_cWidth < 1) m_cWidth = 1;	// ochrana ped nesmysly
	}

// ka a vka zobrzen sti plochy
	m_dWidth = m_mWidth;				// ka celkem
	if (m_dWidth > m_cWidth) m_dWidth = m_cWidth; // omezen na klientskou plochu
	m_dHeight = m_mHeight;				// vka celkem
	if (m_dHeight > m_cHeight) m_dHeight = m_cHeight;

// lev a horn potek zobrazen plochy v okn
	m_dLeft = (m_cWidth - m_dWidth)/2;	// lev potek zobrazen sti plochy
	m_dTop = (m_cHeight - m_dHeight)/2;	// horn potek zobrazen sti plochy

// omezen potenho bodu vlevo
	if (m_tLeft < 0)					// nesm bt zporn
		m_tLeft = 0;					// minimln hodnota
	if (m_tLeft > m_mWidth - m_dWidth)	// zbv ji mn bod ?
		m_tLeft = m_mWidth - m_dWidth;	// omezen na zbyl poet bod

// omezen potenho bodu nahoe
	if (m_tTop < 0)					// nesm bt zporn
		m_tTop = 0;					// minimln hodnota
	if (m_tTop > m_mHeight - m_dHeight) // zbv ji mn bod ?
		m_tTop = m_mHeight - m_dHeight; // omezen na zbyl poet bod

// pepoet zobrazenho potku na ikony a body
	m_iLeft = m_tLeft / m_IconWidth;	// vpoet prvn zobrazen ikony vlevo (i necel)
	m_oLeft = m_IconWidth - (m_tLeft % m_IconWidth); // ka prvn zobrazen ikony vlevo
	m_iTop = m_tTop / m_IconHeight; // vpoet prvn zobrazen ikony nahoe (i necel)
	m_oTop = m_IconHeight - (m_tTop % m_IconHeight); // ka prvn zobrazen ikony nahoe

// vpoet ky ikon vpravo a dole
	m_oRight = m_IconWidth - ((m_mWidth - m_tLeft - m_dWidth) % m_IconWidth);
	m_oBottom = m_IconHeight - ((m_mHeight - m_tTop - m_dHeight) % m_IconHeight);

// vpoet posledn zobrazen ikony
	m_iRight = m_iLeft + (m_dWidth - m_oLeft + m_IconWidth - 1) / m_IconWidth;
	m_iBottom = m_iTop + (m_dHeight - m_oTop + m_IconHeight - 1) / m_IconHeight;

// pprava zapnut posuvnk
	if (m_dWidth < m_mWidth)
		m_HScrollDisp = TRUE;			// horizontln posuvnk zapnut
	else
		m_HScrollDisp = FALSE;			// horizontln posuvnk vypnut

	if (m_dHeight < m_mHeight)
		m_VScrollDisp = TRUE;			// vertikln posuvnk zapnut
	else
		m_VScrollDisp = FALSE;			// vertikln posuvnk vypnut
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace zobrazen posuvnk

void CEditSprite::SetScroll()
{
// lokln promnn
	CRect	rc;							// klientsk oblast celho okna
	CRect	rc1;						// rozmry posuvnku
	SCROLLINFO	scr;					// informace o posuvncch

// rozmry klientsk oblasti
	GetClientRect(&rc);					// naten rozmr okna

// nastaven horizontlnho posuvnku
	if (m_HScroll.m_hWnd != NULL)
	{

// naten aktulnho stavu
		m_HScroll.GetScrollInfo(&scr, SIF_ALL);
		scr.fMask = 0;					// pednastaven - nic se nemn

// minimln pozice
		if (scr.nMin != 0)
		{
			scr.nMin = 0;
			scr.fMask |= SIF_RANGE;
		}

// maximln pozice
		if (scr.nMax != m_mWidth)
		{
			scr.nMax = m_mWidth;
			scr.fMask |= SIF_RANGE;
		}

// velikost strnky
		if (scr.nPage != (UINT)m_dWidth)
		{
			scr.nPage = (UINT)m_dWidth;
			scr.fMask |= SIF_PAGE;
		}

// pozice posuvnku
		if (scr.nPos != m_tLeft)
		{
			scr.nPos = m_tLeft;
			scr.fMask |= SIF_POS;
		}

// nastaven novch parametr posuvnku
		if (scr.fMask != 0)
		{
			m_HScroll.SetScrollInfo(&scr, TRUE);
		}

// zobrazen horizontlnho posuvnku
		rc1.left = 0;
		rc1.top = rc.bottom - TRACKSIRKA;
		rc1.right = rc.right;
		rc1.bottom = rc.bottom;
		if (m_VScrollDisp) rc1.right -= TRACKSIRKA;

		m_HScroll.MoveWindow(&rc1,FALSE);
		m_HScroll.ShowWindow((m_HScrollDisp && !m_TestMode) ? SW_SHOWNA : SW_HIDE);
	}

// nastaven vertiklnho posuvnku
	if (m_VScroll.m_hWnd != NULL)
	{

// naten aktulnho stavu
		m_VScroll.GetScrollInfo(&scr, SIF_ALL);
		scr.fMask = 0;					// pednastaven - nic se nemn

// minimln pozice
		if (scr.nMin != 0)
		{
			scr.nMin = 0;
			scr.fMask |= SIF_RANGE;
		}

// maximln pozice
		if (scr.nMax != m_mHeight)
		{
			scr.nMax = m_mHeight;
			scr.fMask |= SIF_RANGE;
		}

// velikost strnky
		if (scr.nPage != (UINT)m_dHeight)
		{
			scr.nPage = m_dHeight;
			scr.fMask |= SIF_PAGE;
		}

// pozice posuvnku
		if (scr.nPos != m_tTop)
		{
			scr.nPos = m_tTop;
			scr.fMask |= SIF_POS;
		}

// nastaven novch parametr posuvnku
		if (scr.fMask != 0)
		{
			m_VScroll.SetScrollInfo(&scr, TRUE);
		}

// zobrazen vertiklnho posuvnku
		rc1.left = rc.right - TRACKSIRKA;
		rc1.top = 0;
		rc1.right = rc.right;
		rc1.bottom = rc.bottom;
		if (m_HScrollDisp) rc1.bottom -= TRACKSIRKA;

		m_VScroll.MoveWindow(&rc1,FALSE);
		m_VScroll.ShowWindow((m_VScrollDisp && !m_TestMode) ? SW_SHOWNA : SW_HIDE);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CEditSprite message handlers

void CEditSprite::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	int oldwidth = m_TestWidth;
	int oldheight = m_TestHeight;

// pepoet zobrazen plochy
	Recalc();
	SetScroll();

// zmna plochy pro data
	if (m_TestMode && ((oldwidth != m_TestWidth) || 
		(oldheight != m_TestHeight)))
	{
		Aloc(m_TestData, m_TestWidth*m_TestHeight);
		TestRepaint();
		TestPut();
		Invalidate(TRUE);
	}
}

void CEditSprite::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

// lokln promnn
	HPALETTE OldPal;			// schova pvodnch palet
	int i,j;					// pracovn tae
	int left, top, width, height; // rozmry obrzku
	int dleft, dtop;			// zobrazen potek ikony
	SPRITE* data = m_Sprite->Get(m_Index);

// nastaven vlastnch palet
	OldPal = ::SelectPalette(dc.m_hDC, StdPalette, FALSE);
	::RealizePalette(dc.m_hDC);

// vykreslen obrazovky v mdu testu
	if (m_TestMode)
	{

// vygenerovn mapy
		Aloc(m_TestData, m_TestWidth*m_TestHeight);
		TestRepaint();
		TestPut();

// nastaven parametr zhlav bitmapy
		StdBitmapInfo->bmiHeader.biWidth = m_TestWidth;
		StdBitmapInfo->bmiHeader.biHeight = m_TestHeight;

// zobrazen obrzku
		::StretchDIBits(dc.m_hDC,
			m_TestLeft,			// clov lev okraj
			m_TestTop,			// clov horn okraj
			m_TestWidth,		// clov ka ikony
			m_TestHeight,		// clov vka ikony

			0,					// zdrojov lev pozice
			0,					// zdrojov horn pozice
			m_TestWidth,		// zdrojov ka ikony
			m_TestHeight,		// zdrojov vka ikony

			m_TestData,
			StdBitmapInfo,		// zhlav bitmapy
			DIB_RGB_COLORS, SRCCOPY);
	}

// vykreslen v bnm mdu
	else
	{

// nastaven parametr zhlav bitmapy
		StdBitmapInfo->bmiHeader.biWidth = m_IconWidth;
		StdBitmapInfo->bmiHeader.biHeight = m_IconHeight;

// pprava levho potku
		left = m_IconWidth - m_oLeft;	// zdrojov lev okraj
		dleft = m_dLeft;			// clov lev okraj

// cyklus pes ikony na dku
		for (i = m_iLeft; i <= m_iRight; i++)
		{

// pprava hornho potku
			top = m_IconHeight - m_oTop; // zdrojov horn okraj
			dtop = m_dTop;		// clov horn okraj

// ka ikony k zobrazen
			width = m_IconWidth - left;	// ka
			if (i == m_iRight)
				width = m_oRight - left;

// cyklus pes vechny dky ikon
			for (j = m_iTop; j <= m_iBottom; j++)
			{	

// vka ikony k zobrazen
				height = m_IconHeight - top; // vka
				if (j == m_iBottom)
					height = m_oBottom - top;

// zobrazen obrzku
				::StretchDIBits(dc.m_hDC,
					dleft,				// clov lev okraj
					dtop,				// clov horn okraj
					width,				// clov ka ikony
					height,				// clov vka ikony

					left,				// zdrojov lev pozice
					0,					// zdrojov horn pozice
					width,				// zdrojov ka ikony
					height,				// zdrojov vka ikony

					&(data->item[(i + j*m_Width)*m_IconSize
						+ m_IconWidth*(m_IconHeight - height - top)]),
					StdBitmapInfo,		// zhlav bitmapy
					DIB_RGB_COLORS, SRCCOPY);

// nov horn potek
				dtop += height;			// clov horn okraj
				top = 0;				// zdrojov horn okraj
			}

// nov lev potek
			dleft += width;				// clov lev okraj
			left = 0;					// zdrojov lev okraj
		}
	}

// nvrat pvodnch palet
	::SelectPalette(dc.m_hDC,OldPal,TRUE);
}


void CEditSprite::OnMouseMove(UINT nFlags, CPoint point) 
{
	CDialog::OnMouseMove(nFlags, point);

	int sx,sy;					// souadnice myi pepoten na ikony
	CPoint itemPoint;			// souadnice taenho prvku
	CPoint pt2;
	CPoint	ptScreen;			// pozice taen ikony na obrazovce
	SPRITE* data = m_Sprite->Get(m_Index);

	if (m_Draging)
	{
		pt2 = point - m_HotSpot + CPoint(m_IconWidth/2, m_IconHeight/2);
	}
	else
	{
		pt2 = point;
	}

	sx = (pt2.x - m_dLeft - m_oLeft + m_IconWidth)/m_IconWidth + m_iLeft;
	sy = (pt2.y - m_dTop - m_oTop + m_IconHeight)/m_IconHeight + m_iTop;

	if ((pt2.x >= m_dLeft) && (pt2.y >= m_dTop) &&
		(!m_TestMode) &&
		(pt2.x < m_dLeft + m_dWidth) && (pt2.y < m_dTop + m_dHeight))
	{
		m_X = sx;
		m_Y = sy;
	}
	else
	{
		m_X = -1;
		m_Y = -1;
	}

// zahjen taen
	if (((nFlags & (MK_LBUTTON | MK_RBUTTON)) != 0) &&
		(!m_Draging) &&
		(!m_TestMode) &&
		(!Prog->m_Dragging) &&
		(m_BegDrag) &&
		(m_DragX != -1) &&
		(m_DragY != -1) &&
		((abs(point.x - m_BegX) > 3) ||
		(abs(point.y - m_BegY) > 3)))
	{

// nastaven pznak pro taen
		m_Draging = TRUE;

// vzdlenost kurzoru myi od potku prvku
		itemPoint.x = m_dLeft + (m_DragX*m_IconWidth - m_tLeft);
		itemPoint.y = m_dTop + (m_DragY*m_IconHeight - m_tTop);
		m_HotSpot = CPoint(m_BegX, m_BegY) - itemPoint;

// vytvoen seznamu obrzk pro taen
		m_DragIcon.RemoveAll();						// zruen ikon v bufferu
		m_DragIcon.Add(&data->item[(m_DragX + m_DragY*m_Width)*m_IconSize]);
		m_DragList = m_DragIcon.GenerList(TRUE);	// vytvoen seznamu obrzk

// zapnut zobrazen obrzku taen (bez uzamykn okna)
		m_DragList->DragShowNolock(TRUE);

// nastaven kurzoru myi
		if (m_Copy)
			::SetCursor(m_CurCopy);
		else
			::SetCursor(m_CurMove);
		
// vytvoen novho obrzku taen
		m_DragList->SetDragCursorImage(0, CPoint(m_HotSpot));

// zahjen operace taen
		m_DragList->BeginDrag(0, CPoint(0,0));

// zahjen operace taen, zkaz aktualizace okna
		m_DragList->DragEnter(NULL, point - m_HotSpot);

// petaen obrzku na aktuln pozici myi
			ptScreen = point - m_HotSpot;
			ClientToScreen(&ptScreen);
			m_DragList->DragMove(ptScreen);

// zahjen zachytvn myi
		SetCapture();
	}
	else
	{
		if (m_Draging && ((nFlags & (MK_LBUTTON | MK_RBUTTON) == 0)))
		{
			EndDrag();
		}
		else
		{
			if (m_Draging)
			{
// petaen obrzku na novou pozici
				ptScreen = point - m_HotSpot;
				ClientToScreen(&ptScreen);
				m_DragList->DragMove(ptScreen);

				if ((m_X == -1) || (m_Y == -1))
				{
					if (m_Copy)
						::SetCursor(m_CurNoDrag);
					else
						::SetCursor(m_CurDelete);
				}
				else
					if (m_Copy)
						::SetCursor(m_CurCopy);
					else
						::SetCursor(m_CurMove);
			}
		}
	}
}

void CEditSprite::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar != NULL)
	{
		if (pScrollBar->m_hWnd == m_HScroll.m_hWnd)
		{
			int pos = pScrollBar->GetScrollPos();

			switch (nSBCode)
			{
			case SB_LEFT:
				pos = 0;
				break;
			case SB_LINELEFT:
				pos -= m_IconWidth;
				break;
			case SB_LINERIGHT:
				pos += m_IconWidth;
				break;
			case SB_PAGELEFT:
				pos -= (m_dWidth/m_IconWidth-1)*m_IconWidth;
				break;
			case SB_PAGERIGHT:
				pos += (m_dWidth/m_IconWidth-1)*m_IconWidth;
				break;
			case SB_RIGHT:
				pos = m_mWidth - m_dWidth;
				break;
			case SB_THUMBPOSITION:
			case SB_THUMBTRACK:
				pos = nPos;
			}

			if (pos < 0) pos = 0;
			if (pos >= m_mWidth - m_dWidth)
				pos = m_mWidth - m_dWidth;

			if (pos != m_tLeft)
			{
				m_tLeft = pos;
				Recalc();
				SetScroll();
				Invalidate(FALSE);
			}
		}
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CEditSprite::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar != NULL)
	{
		if (pScrollBar->m_hWnd == m_VScroll.m_hWnd)
		{
			int pos = pScrollBar->GetScrollPos();

			switch (nSBCode)
			{
			case SB_TOP:
				pos = 0;
				break;
			case SB_LINEUP:
				pos -= m_IconHeight;
				break;
			case SB_LINEDOWN:
				pos += m_IconHeight;
				break;
			case SB_PAGEUP:
				pos -= (m_dHeight/m_IconHeight-1)*m_IconHeight;
				break;
			case SB_PAGEDOWN:
				pos += (m_dHeight/m_IconHeight-1)*m_IconHeight;
				break;
			case SB_BOTTOM:
				pos = m_mHeight - m_dHeight;
				break;
			case SB_THUMBPOSITION:
			case SB_THUMBTRACK:
				pos = nPos;
			}

			if (pos < 0) pos = 0;
			if (pos >= m_mHeight - m_dHeight)
				pos = m_mHeight - m_dHeight;

			if (pos != m_tTop)
			{
				m_tTop = pos;
				Recalc();
				SetScroll();
				Invalidate(FALSE);
			}
		}
	}

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CEditSprite::DragDrop(int item)
{
	SPRITE* data = m_Sprite->Get(m_Index);

	if ((item < 0) || 
		(item >= m_Icon->GetSize()) ||
		(m_X < 0) ||
		(m_X >= m_Width) ||
		(m_Y < 0) ||
		(m_Y >= m_Height))
		return;

	memcpy(&(data->item[(m_X + m_Y*m_Width)*m_IconSize]),
		m_Icon->Get(item), m_IconSize);

	Invalidate(FALSE);
}

void CEditSprite::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);

	if (m_Draging)
	{
		EndDrag();
		return;
	}

// souadnice pro testovac md
	if (m_TestMode)
	{
		int x = (point.x - m_TestLeft)/m_IconWidth;
		int y = (point.y - m_TestTop)/m_IconHeight;

		if ((point.x >= m_TestLeft) &&
			(point.y >= m_TestTop) &&
			(x < m_TestWidthN) &&
			(y < m_TestHeightN))
		{
			m_TestNextX = x;
			m_TestNextY = y;
		}
	}


	if ((m_X == -1) || (m_Y == -1)) return;

// schova souadnic ped zahjenm taen
	m_BegX = point.x;			// schova souadnice X
	m_BegY = point.y;			// schova souadnice Y
	m_BegDrag = TRUE;
	m_Copy = FALSE;				// nen md kopie
	m_DragX = m_X;
	m_DragY = m_Y;
}

void CEditSprite::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnRButtonDown(nFlags, point);

	if (m_Draging)
	{
		EndDrag();
		return;
	}

// souadnice pro testovac md
	if (m_TestMode)
	{
		int x = (point.x - m_TestLeft)/m_IconWidth;
		int y = (point.y - m_TestTop)/m_IconHeight;

		if ((point.x >= m_TestLeft) &&
			(point.y >= m_TestTop) &&
			(x < m_TestWidthN) &&
			(y < m_TestHeightN))
		{
			m_TestNextX = x;
			m_TestNextY = y;
		}
	}


	if ((m_X == -1) || (m_Y == -1)) return;

// schova souadnic ped zahjenm taen
	m_BegX = point.x;			// schova souadnice X
	m_BegY = point.y;			// schova souadnice Y
	m_BegDrag = TRUE;
	m_Copy = TRUE;				// je md kopie
	m_DragX = m_X;
	m_DragY = m_Y;
}

void CEditSprite::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDblClk(nFlags, point);

	if (m_Draging)
	{
		EndDrag();
		return;
	}

// souadnice pro testovac md
	if (m_TestMode)
	{
		int x = (point.x - m_TestLeft)/m_IconWidth;
		int y = (point.y - m_TestTop)/m_IconHeight;

		if ((point.x >= m_TestLeft) &&
			(point.y >= m_TestTop) &&
			(x < m_TestWidthN) &&
			(y < m_TestHeightN))
		{
			m_TestNextX = x;
			m_TestNextY = y;
		}
	}


	if ((m_X == -1) || (m_Y == -1)) return;

// schova souadnic ped zahjenm taen
	m_BegX = point.x;			// schova souadnice X
	m_BegY = point.y;			// schova souadnice Y
	m_BegDrag = TRUE;
	m_Copy = FALSE;				// nen md kopie
	m_DragX = m_X;
	m_DragY = m_Y;

	Prog->PushEditHist();							// schova historie editace
	Prog->m_EditItem = -2;
	Prog->SetEditMode(TYP_PIC);
	Prog->AktAllDef();
}

void CEditSprite::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	CDialog::OnRButtonDblClk(nFlags, point);

	if (m_Draging)
	{
		EndDrag();
		return;
	}

// souadnice pro testovac md
	if (m_TestMode)
	{
		int x = (point.x - m_TestLeft)/m_IconWidth;
		int y = (point.y - m_TestTop)/m_IconHeight;

		if ((point.x >= m_TestLeft) &&
			(point.y >= m_TestTop) &&
			(x < m_TestWidthN) &&
			(y < m_TestHeightN))
		{
			m_TestNextX = x;
			m_TestNextY = y;
		}
	}


	if ((m_X == -1) || (m_Y == -1)) return;

// schova souadnic ped zahjenm taen
	m_BegX = point.x;			// schova souadnice X
	m_BegY = point.y;			// schova souadnice Y
	m_BegDrag = TRUE;
	m_Copy = TRUE;				// je md kopie
	m_DragX = m_X;
	m_DragY = m_Y;

	Prog->PushEditHist();							// schova historie editace
	Prog->m_EditItem = -2;
	Prog->SetEditMode(TYP_PIC);
	Prog->AktAllDef();
}


void CEditSprite::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonUp(nFlags, point);
	SPRITE* data = m_Sprite->Get(m_Index);

	if (m_Draging)
	{
		BYTE* srcitem = &data->item[(m_DragX + m_DragY*m_Width)*m_IconSize];
		BYTE* dstitem = &data->item[(m_X + m_Y*m_Width)*m_IconSize];
		BYTE* data = new BYTE[m_IconSize];

		memcpy(data, srcitem, m_IconSize);

		if (!m_Copy)
		{
			if ((m_X != -1) && (m_Y != -1))
			{
				memcpy(srcitem, dstitem, m_IconSize);
			}
			else
			{
				memset(srcitem, 0, m_IconSize);
			}
		}

		if ((m_X != -1) && (m_Y != -1))
		{
			memcpy(dstitem, data, m_IconSize);
		}

		Invalidate(FALSE);

		delete[] data;
	}

	EndDrag();
}


void CEditSprite::OnRButtonUp(UINT nFlags, CPoint point) 
{
	CDialog::OnRButtonUp(nFlags, point);
	SPRITE* data = m_Sprite->Get(m_Index);

	if (m_Draging)
	{
		BYTE* srcitem = &data->item[(m_DragX + m_DragY*m_Width)*m_IconSize];
		BYTE* dstitem = &data->item[(m_X + m_Y*m_Width)*m_IconSize];
		BYTE* data = new BYTE[m_IconSize];

		memcpy(data, srcitem, m_IconSize);

		if (!m_Copy)
		{
			if ((m_X != -1) && (m_Y != -1))
			{
				memcpy(srcitem, dstitem, m_IconSize);
			}
			else
			{
				memset(srcitem, 0, m_IconSize);
			}
		}

		if ((m_X != -1) && (m_Y != -1))
		{
			memcpy(dstitem, data, m_IconSize);
		}

		Invalidate(FALSE);

		delete[] data;
	}

	EndDrag();
}


BOOL CEditSprite::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{

// naten pozice myi
	POINT pt;
	::GetCursorPos(&pt);				// naten pozice myi
	ScreenToClient(&pt);				// pevod na souadnice okna

// implicitn kurzor
	m_CurAkt = m_CurArrow;				// implicitn kurzor ipky

// test, zda je editan pole
	if (m_Draging)
	{
		if (m_Copy)
			m_CurAkt = m_CurCopy;
		else
			m_CurAkt = m_CurMove;

		if ((m_X == -1) || (m_Y == -1))
		{
			if (m_Copy)
				m_CurAkt = m_CurNoDrag;
			else
				m_CurAkt = m_CurDelete;
		}

	}

// testovac md
	if (m_TestMode && 
		(pt.x >= m_TestLeft) &&
		(pt.x < m_TestLeft + m_TestWidth) &&
		(pt.y >= m_TestTop) &&
		(pt.y < m_TestTop + m_TestHeight))
	{
		m_CurAkt = m_CurCil;
	}

// zobrazen novho kurzoru myi
	::SetCursor(m_CurAkt);				// zobrazen kurzoru myi

	return TRUE;						// pznak, e se nem pokraovat
}


void CEditSprite::EndDrag()
{
	m_BegDrag = FALSE;

	if (m_Draging)
	{
		m_Draging = FALSE;

// pozastaven taen
		m_DragList->DragLeave(NULL);

// ukonen taen
		m_DragList->EndDrag();

		if (m_DragList != NULL)
		{
			delete m_DragList;
			m_DragList = NULL;
		}

// uvolnn zachytvn myi
		ReleaseCapture();

		::SetCursor(m_CurArrow);

		m_DragIcon.RemoveAll();
	}
}

/////////////////////////////////////////////////////////////////////////////
// obsluha testovacho mdu

void CEditSprite::EndTest()
{
// kontrola, zda je testovac md ji vypnut
	if (m_TestMode == FALSE)			// je testovac md ji vypnut ?
		return;

// zruen asovae
	KillTimer(m_TimerID);				// zruen asovae
	m_TimerID = 0;						// asova neplatn

// zruen pznaku testovacho mdu
	m_TestMode = FALSE;					// konec testovacho mdu

// zruen bufferu
	Aloc(m_TestData, 0);

// pekreslen obrazovky
	Invalidate(TRUE);
}

void CEditSprite::BegTest()
{
// kontrola, zda je testovac md ji zapnut
	if (m_TestMode)						// je testovac md zapnut ?
		return;

// adresa mapy
	MAP* map = m_Map->Get(0);			// adresa mapy 0

// rozmry a poloha plochy
	CRect rc;							// klientsk souadnice
	GetClientRect(&rc);					// naten klientskch souadnic

	m_TestWidthN = rc.right/m_IconWidth; // ka plochy v ikonch
	if (m_TestWidthN > map->width)
		m_TestWidthN = map->width;
	if (m_TestWidthN <= 0)
		m_TestWidthN = 1;				// minimln ka
	m_TestWidth = m_TestWidthN * m_IconWidth; // ka v bodech
	m_TestLeft = (rc.right - m_TestWidth)/2; // lev okraj plochy

	m_TestHeightN = rc.bottom/m_IconHeight; // vka plochy v ikonch
	if (m_TestHeightN > map->height)
		m_TestHeightN = map->height;
	if (m_TestHeightN <= 0)
		m_TestHeightN = 1;				// minimln vka
	m_TestHeight = m_TestHeightN * m_IconHeight; // vka v bodech
	m_TestTop = (rc.bottom - m_TestHeight)/2; // horn okraj plochy

// inicializace souadnic
	m_TestSrcX = 0;
	m_TestSrcY = m_TestHeightN - 1;
	m_TestDstX = 0;
	m_TestDstY = m_TestSrcY;
	m_TestNextX = 0;
	m_TestNextY = m_TestSrcY;

	m_TestMove = FALSE;
	m_TestX = 0;
	m_TestY = m_TestSrcY*m_IconHeight;
	m_TestDX = 0;
	m_TestDY = 0;
	m_TestFaze = 0;
	m_TestSmer = 0;
	m_TestKrok = 0;

// vytvoen plochy pro data
	Aloc(m_TestData, m_TestWidth*m_TestHeight);

// nastaven pznaku testovacho mdu
	m_TestMode = TRUE;					// zahjen testovacho mdu

// pekreslen obsahu plochy
	TestRepaint();
	TestPut();

// konstanta asovae
	m_Timer = 1;					// minimln hodnota asovae

// zapnut asovae
	m_TimerID = SetTimer(TIMERID, TimerConst,NULL /*CallbackTimer*/); // sputn asovae

// pekreslen obrazovky
	Invalidate(TRUE);
}

void CEditSprite::TestRepaint()
{
	int x, y, z;
	BYTE* dst = m_TestData;
	BYTE* src;
	MAP* map = m_Map->Get(0);

//	if (dst == NULL) return;

	for (x = m_TestWidthN-1; x >= 0; x--)
	{
		for (y = m_TestHeightN-1; y >= 0; y--)
		{
			dst = &m_TestData[(x + y*m_IconHeight*m_TestWidthN)*m_IconWidth];
			src = m_Icon->Get(map->item[x + y*map->width].icon);

			for (z = m_IconHeight-1; z >= 0; z--)
			{
				memcpy(dst, src, m_IconWidth);
				dst += m_IconWidth*m_TestWidthN;
				src += m_IconWidth;
			}
		}
	}
}

// vloen sprajtu na novou pozici
void CEditSprite::TestPut()
{
	SPRITE* data = m_Sprite->Get(m_Index);

	int x = (int)(m_TestX+0.5);
	if (x < 0)
		x = 0;
	if (x > m_TestWidth - m_IconWidth)
		x = m_TestWidth - m_IconWidth;

	int y = (int)(m_TestY+0.5);
	if (y < 0)
		y = 0;
	if (y > m_TestHeight - m_IconHeight)
		y = m_TestHeight - m_IconHeight;

//	if (m_TestData == NULL)
//		return;

	BYTE* dst = &m_TestData[x + (m_TestHeight - y - m_IconHeight)*m_TestWidth];
	BYTE* src = &data->item[(m_TestFaze + 
		m_TestSmer*data->faze)*m_IconSize];

	for (y = m_IconHeight-1; y >= 0; y--)
	{
		for (x = m_IconWidth-1; x >= 0; x--)
		{
			if (src[0] != 0) 
				dst[0] = src[0];
			src++;
			dst++;
		}
		dst += m_TestWidth - m_IconWidth;
	}
}

//void CALLBACK EXPORT CallbackTimer(HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime)
//{
//	if (nIDEvent != TIMERID) return;

//	CEditSprite* edit = (CEditSprite*) CWnd().FromHandle(hWnd);

//	edit->OnTimer(nIDEvent);
//}

void CEditSprite::OnTimer(UINT nIDEvent) 
{
	int	left, top, right, bottom;			// rozmry pro zobrazen
	SPRITE* data = m_Sprite->Get(m_Index);

// tn asovae
	m_Timer--;								// tn asovae
	if ((m_Timer <= 0) && (nIDEvent == TIMERID)) // je dosaeno asu ?
	{	

// obsluha testovacho mdu
		if (m_TestMode)						// je testovac md ?
		{

// souadnice k vykreslen
			left = (int)(m_TestX+0.5);
			top = (int)(m_TestY+0.5);
			right = left + m_IconWidth;
			bottom = top + m_IconHeight;

// vymazn sprajtu
			TestRepaint();

// dal fze pohybu
			if (m_TestKrok)
			{
				m_TestKrok--;
				m_TestFaze++;
				if (m_TestFaze >= data->faze)
					m_TestFaze = 1;
				if (data->faze == 1)
					m_TestFaze = 0;
				m_TestX += m_TestDX;
				m_TestY += m_TestDY;
			}
			else
			{

// dosaeno clov pozice
					m_TestSrcX = m_TestDstX;
					m_TestSrcY = m_TestDstY;
					m_TestX = m_TestSrcX * m_IconWidth;
					m_TestY = m_TestSrcY * m_IconHeight;

// nov clov polko
					m_TestDstX = m_TestNextX;
					m_TestDstY = m_TestNextY;

// nov pohyb
				if ((m_TestSrcX != m_TestDstX) ||
					(m_TestSrcY != m_TestDstY))
				{
					int dx = m_TestDstX - m_TestSrcX;
					int dy = m_TestDstY - m_TestSrcY;
					double uhel = atan2(-(double)dy, (double)dx);
					if (uhel < 0)
						uhel += pi2;

					m_TestSmer = (int)(uhel * data->smer / pi2 + 0.5);
					if (m_TestSmer >= data->smer)
						m_TestSmer -= 4;
					if (m_TestSmer < 0)
						m_TestSmer = 0;
					if (m_TestSmer >= data->smer)
						m_TestSmer = data->smer - 1;
	
					m_TestKrok = (int)(sqrt((double)(dx*dx + dy*dy))*data->krok);

					m_TestDX = (double)(dx*m_IconWidth)/m_TestKrok;
					m_TestDY = (double)(dy*m_IconHeight)/m_TestKrok;

					m_TestFaze++;
					if (m_TestFaze >= data->faze)
						m_TestFaze = 1;
					if (data->faze == 1)
						m_TestFaze = 0;

					m_TestMove = TRUE;
				}

// zastaven
				else
				{
					m_TestMove = FALSE;
					m_TestFaze = 0;
				}
			}

// poloen sprajtu na novou pozici
			TestPut();

// korekce souadnic k vykreslen
			if ((int)(m_TestX+0.5) < left)
				left = (int)(m_TestX+0.5);
			if ((int)(m_TestY+0.5) < top)
				top = (int)(m_TestY+0.5);
			if ((int)(m_TestX + m_IconWidth + 0.5) > right)
				right = (int)(m_TestX + m_IconWidth + 0.5);
			if ((int)(m_TestY + m_IconHeight + 0.5) > bottom)
				bottom = (int)(m_TestY + m_IconHeight + 0.5);

// zobrazen obrzku
		CDC* dc = GetDC();
		HPALETTE OldPal = ::SelectPalette(dc->m_hDC, StdPalette, FALSE);
		::RealizePalette(dc->m_hDC);
		right -= left;
		bottom -= top;

		StdBitmapInfo->bmiHeader.biWidth = m_TestWidth;
		StdBitmapInfo->bmiHeader.biHeight = bottom;

		::StretchDIBits(dc->m_hDC,
			m_TestLeft+left,	// clov lev okraj
			m_TestTop+top,		// clov horn okraj
			right,				// clov ka ikony
			bottom,				// clov vka ikony

			left,				// zdrojov lev pozice
			0,					// zdrojov horn pozice
			right,				// zdrojov ka ikony
			bottom,				// zdrojov vka ikony

			&m_TestData[(m_TestHeight - top - bottom)*m_TestWidth],
			StdBitmapInfo,		// zhlav bitmapy
			DIB_RGB_COLORS, SRCCOPY);

		::SelectPalette(dc->m_hDC,OldPal,TRUE);
		ReleaseDC(dc);

//			Invalidate(FALSE);
		}

// nov konstanta asovae
		if (m_TestMove)
		{
			m_Timer = (data->delay + 26)/55;	// konstanta asovae
		}
		if (m_Timer <= 0)
			m_Timer = 1;					// minimln hodnota asovae
	}

// pvodn obsluha asovae
	CDialog::OnTimer(nIDEvent);
}

// nastaven vlastnost sprajtu
void CEditSprite::SetSpriteParam()
{
	CSpritePar dial(NULL);

	SPRITE* data = m_Sprite->Get(m_Index);
	
	dial.m_Faze = data->faze;
	dial.m_Klid = 1;
	dial.m_Smer = data->smer;
	dial.m_Delay = data->delay;
	dial.m_Krok = data->krok;
	dial.m_Level = 5;

	if (dial.DoModal() == IDOK)
	{
		data->krok = (long)dial.m_Krok;
		data->delay = dial.m_Delay;
		m_Sprite->SetSize(m_Index, dial.m_Faze, dial.m_Smer);
		BegEdit(m_Index);
	}
}
