
//class CExec;

/////////////////////////////////////////////////////////////////////////////
// definice promnn sprajtu
typedef struct tSPRITEVAR {
	BOOL	visible;		// pznak viditelnosti sprajtu
	BOOL	move;			// pznak pohybu sprajtu
	BOOL	disp;			// pznak poadavku pekreslen

	int		timer;			// ta hodin pro dal fzi
	int		krok;			// ta fz pro cel pohyb
	int		faze;			// aktuln fze - index v obrazu sprajtu

	double	cilx;			// clov souadnice X v polkch (=aktuln kdy stoj)
	double	posx;			// aktuln souadnice X v polkch
	double	x;				// aktuln souadnice X v bodech
	int		xN;				// aktuln souadnice X v bodech
	double	dx;				// prustek souadnice X pi pohybu

	double	cily;			// clov souadnice Y v polkch (= aktuln kdy stoj)
	double	posy;			// aktuln souadnice Y v polkch
	double	y;				// aktuln souadnice Y v bodech
	int		yN;				// aktuln souadnice Y v bodech
	double	dy;				// prustek souadnice Y pi pohybu

	double	smer;			// aktuln smr v hlov me
	int		smerN;			// aktuln smr - index v obrazu sprajtu

	SPRITE*	sprite;			// adresa obrazu sprajtu
}SPRITEVAR;

//typedef struct tagSPRITE {
//	long		faze;			// poet fz
//	long		smer;			// poet smr
//	long		delay;			// prodleva mezi dvma fzemi v [ms]
//	long		krok;			// poet fz na krok
////	double		krok;			// poet fz na krok
////	long		hladina;		// hladina k zobrazen
//	BYTE		item[1];		// obrzky sprajtu (poad: fze, smry)
//} SPRITE;

//typedef struct tagMAPITEM {
//	long			icon;	// index ikony polka
//	long			param;	// parametry polka - hodnota a pznaky
//} MAPITEM;

//typedef struct tagMAP {
//	long		width;		// ka plochy
//	long		height;		// vka ikony
//	MAPITEM	item[1];		// poloky mapy
//} MAP;


// bity pro peruen (m_Break)
#define BREAKPROG	0x1		// pln peruen programu od jinho procesu
#define BREAKFUNC	0x2		// peruen funkce
#define BREAKWHILE	0x4		// peruen cyklu

#define MAXHLOUBKA	1000	// maximln hloubka vnoen voln funkc

#define MAXLISTSIZE	1000000	// maximln velikost seznamu

/////////////////////////////////////////////////////////////////////////////
// poloka bufferu programu

typedef void (_fastcall *PROCCOMMAND) (CExec*);
typedef	double (_fastcall *PROCREAL) (CExec*);
typedef	int (_fastcall *PROCINT) (CExec*);
typedef	SPRITE* (_fastcall *PROCSPRITE) (CExec*);
typedef CString (_fastcall *PROCTEXT) (CExec*);

typedef struct tEXECITEM {
	union {
		PROCCOMMAND	execv;	// pkaz
		PROCREAL	execd;	// seln hodnota
		PROCINT		execi;	// index v bufferu
		PROCSPRITE	execs;	// promnn sprajtu
		PROCTEXT	exect;	// textov promnn
	};

	int			data;			// data
} EXECITEM;

enum ICONTYP {
	IconTypIcon = 0,		// pouze ikona bez pozad
	IconTypMixed,			// ikona mixovan s pozadm
	IconTypBack,			// pouze pozad (przdn ikona)
};

/////////////////////////////////////////////////////////////////////////////
// tabulka pekladu pkaz

typedef BOOL (*PROCCOMPCOM) (CExec*, PROGITEM*, int);

extern const PROCCOMPCOM CompComTab[];	// tabulka pro peklad pkaz
extern const int CompComTabSize;		// poet poloek v tabulce

extern const PROCCOMPCOM CompNumTab[];	// tabulka pro peklad selnch vraz
extern const int CompNumTabSize;		// poet poloek v tabulce

extern const PROCCOMPCOM CompBoolTab[];	// tabulka pro peklad logickch vraz
extern const int CompBoolTabSize;		// poet poloek v tabulce

/////////////////////////////////////////////////////////////////////////////

#define KEYBUFSIZE		20		// velikost bufferu klves
#define KEYBUFTIMEOUT	18		// timeout pro zruen klvesy
#define KEYMAPSIZE		256		// velikost mapy stisknutch klves

class CExec : public CDialog
{

// Construction
public:
	CExec();					// konstruktor pro pechodn okno
	CExec(CProg* prog); 
	~CExec();

//	CStatusBar  m_StatusBar;
	CString		m_StatusText;	// text stavovho dku
	BOOL		m_StatusAkt;	// poadavek aktualizace stavovho dku
	CString		m_CaptionText;	// text nadpisu okna
	BOOL		m_CaptionAkt;	// poadavek aktualizace nadpisu okna

// zdrojov buffery
	CProg*		m_ProgSrc;		// okno programu (NULL = okno EXEC je jen pechodn)
	CProgBuf*	m_BufSrc;		// zdrojov buffery
	CProgBuf*	m_BufIntSrc;	// zdrojov buffer internch funkc
	CProgBuf*	m_BufClsSrc;	// zdrojov buffer td
	CProgBuf*	m_BufObjSrc;	// zdrojov buffer globlnch objekt
	CProgBuf*	m_BufLocSrc;	// zdrojov buffer loklnch objekt
	CProgBuf*	m_BufEdiSrc;	// zdrojov buffer editoru
	CProgBuf*	m_BufStrSrc;	// zdrojov buffer struktur

	CRealBuf*	m_RealSrc;		// zdrojov buffer sel
	CTextBuf*	m_TextSrc;		// zdrojov buffer text
	CBoolBuf*	m_BoolSrc;		// zdrojov buffer logickch hodnot
	CMapBuf*	m_MapSrc;		// zdrojov buffer ploch
	CIconBuf*	m_IconSrc;		// zdrojov buffer ikon
	CSpriteBuf*	m_SpriteSrc;	// zdrojov buffer sprajt
	CSoundBuf*	m_SoundSrc;		// zdrojov buffer zvuk

// buffer promnnch sel (promnn jsou pmo poloky v bufferu)
	CRealBuf	m_Real;			// buffer sel
	int			m_RealNum;		// poet sel v bufferu pro lokln promnn

// buffer promnnch text (promnn jsou pmo poloky v bufferu)
	CTextBuf	m_Text;			// buffer text
	int			m_TextNum;		// poet sel v bufferu pro lokln promnn

// buffer logickch hodnot (promnn jsou pmo poloky v bufferu)
	CBoolBuf	m_Bool;			// buffer logickch hodnot
	int			m_BoolNum;		// poet promnnch v bufferu pro lokln promnn

// buffer sprajt (po inicializaci s bufferem nehbat - odkazy pomoc ukazatel !)
	CSpriteBuf	m_Sprite;		// buffer zobrazen sprajt

	int			m_SpriteNum;	// poet sprajt v bufferu pro lokln promnn

	SPRITEVAR*	m_SpriteVar;	// buffer promnnch sprajt
	int			m_SpriteVarN;	// poet promnnch sprajt
	int			m_SpriteVarM;	// velikost bufferu promnnch sprajt (poloek)

	int*		m_SpriteVis;	// indexy viditelnch sprajt
	int			m_SpriteVisN;	// poet viditelnch sprajt
	int			m_SpriteVisM;	// velikost bufferu viditelnch sprajt

	int*		m_SpriteMove;	// indexy pohybujcch se sprajt
	int			m_SpriteMoveN;	// poet pohybujcch se sprajt
	int			m_SpriteMoveM;	// velikost bufferu pohybujcch se sprajt

	int*		m_SpriteDisp;	// indexy sprajt vyadujcch pekreslen
	int			m_SpriteDispN;	// poet sprajt vyadujcch pekreslen
	int			m_SpriteDispM;	// velikost bufferu sprajt k pekreslen

// buffer promnnch ikon (promnn jsou ukazatele do nemnnho bufferu ikon)
	CIconBuf	m_Icon;			// buffer ikon

	int			m_IconNum;		// poet ikon v bufferu pro lokln promnn

	BYTE*		m_IconTyp;		// buffer typ ikon ICONTYPE
	int*		m_IconMap;		// buffer namapovn ikon pro plochy (-1 = zatm nen)

	int*		m_IconVar;		// promnn ikon
	int			m_IconVarN;		// poet promnnch ikon
	int			m_IconVarM;		// velikost bufferu promnnch ikon

// buffer promnnch ploch (promnn jsou pmo poloky v bufferu,
// pi operacch se modifikuj pmo data v bufferu vetn zmny velikosti)
// jedinou operac s promnnmi je kopie jedn mapy do druh, proto se
// ve vrazech pedv index mapy, a koncov pkaz provede kopii dat;
// mapa 0 je vdy aktuln vstupn mapa pro zobrazen !
	CMapBuf		m_Map;			// buffer map
	int			m_MapNum;		// poet map v bufferu pro lokln promnn

// buffer zvuk
	CSoundBuf	m_Sound;		// buffer zvuk
	int			m_SoundNum;		// poet zvuk v bufferu pro lokln promnn
	int*		m_SoundVar;		// promnn zvuk
	int			m_SoundVarN;	// poet promnnch zvuk
	int			m_SoundVarM;	// velikost bufferu promnnch zvuk

// buffer provdnho programu
	EXECITEM*	m_Prog;			// buffer programu
	int			m_ProgNum;		// poet poloek programu
	int			m_ProgMax;		// velikost bufferu programu
	EXECITEM*	m_ExecItem;		// ukazatel provdn programu (NULL = neprovd se)

// buffer index seznam
// U globlnch promnnch jsou promnn v seznamu vytvoeny ji pi mapovn,
// u loklnch promnnch je uloena pouze vzorov promnn a seznam se vytv a pi bhu programu
	int*		m_ListIndex;	// buffer aktulnch index seznam (pit se k indexu promnn)
	int*		m_ListSize;		// buffer velikost seznam (pro kontrolu peteen indexu)
	int*		m_ListAuto;		// buffer pro automatickou inkrementaci indexu
	int			m_ListIndexN;	// poet index v bufferu index seznam
	int			m_ListIndexM;	// velikost bufferu index seznam

	int			m_ListNum;		// poet seznam pro lokln promnn

// mapovvac tabulky objekt pi pekladu (-1 = zatm nemapovno)
// u funkc se uchovv index do mapovac tabulky funkc
// u zhlav seznam se uchovv index do tabulky index seznam (-1 = jet nen)
// u promnnch se uchovv tak index do tabulky index seznam, -1 = nem seznam
// promnn v globlnm seznamu se vytvej ji pi pekladu programu
	int*		m_mapObj;		// mapovvac tabulka globlnch objekt
	int*		m_mapObjList;	// mapovac tabulka index globlnch seznam (-1 = nen seznam)

// mapovac tabulka loklnch definic funkc, poloky ukazuj bu do
// tabulek objekt (jako vzory) nebo do mapovac tabulky funkc
// zhlav lokln definice funkce ukazuje do tabulky mapovn funkc
// stejn jako deklarace v globlnch objektech
// u zhlav seznam se uchovv index do tabulky index seznam (-1 = jet nen)
// u promnnch se uchovv tak index do tabulky index seznam, -1 = nem seznam
// promnn v loklnm seznamu se vytvej a pi provdn programu (podle vzoru)
	int*		m_mapLoc;		// mapovac tabulka loklnch definic funkc
	int*		m_mapLocList;	// mapovac tabulka index loklnch seznam (-1 = nen seznam)

// mapovac tabulka funkc (uchovv nejdve lokln referenci funkce,
//	pozdji index funkce v programovm bufferu)
	int*		m_mapFnc;		// mapovac tabulka funkc
	int			m_mapFncNum;	// poet poloek v mapovac tabulce funkc
	int			m_mapFncMax;	// velikost bufferu mapovac tabulky

// indexovn loklnch promnnch pi pekladu funkce od konce bufferu (posledn je vstup = 1)
	int*		m_LocVar;		// indexy loklnch promnnch (-1 = neplatn)
	int*		m_LocList;		// indexy loklnch seznam (-1 = nen seznam)
	int			m_LocBeg;		// potek lokln definice (se zhlavm)
	int			m_LocNum;		// poet poloek v loklnm bufferu
	int			m_LocResult;	// index vstupn promnn (-1 = nen)
	int			m_LocListNum;	// poet loklnch seznam
	int			m_LocRealNum;	// poet selnch promnnch
	int			m_LocBoolNum;	// poet logickch promnnch
	int			m_LocIconNum;	// poet promnnch ikon
	int			m_LocSpriteNum;	// poet promnnch sprajt
	int			m_LocMapNum;	// poet promnnch map
	int			m_LocTextNum;	// poet textovch promnnch
	int			m_LocSoundNum;	// poet zvukovch promnnch

// buffery bitmap
	BITMAPINFO* m_BitmapInfo;	// standardn zhlav BMP (s nastavenmi rozmry)
	BYTE*		m_BackData;		// data obrzku pozad
//	MAP*		m_MapData;		// aktivn mapa (ukazuje do buferu map)
	BYTE*		m_PicData;		// data sestavy (pozad + mapa)

	int			m_AktLeft;		// lev potek sestavy k zobrazen (v bodech)
	int			m_AktTop;		// horn potek sestavy k zobrazen (v bodech)
	int			m_AktRight;		// prav konec sestavy k zobrazen (v bodech)
	int			m_AktBottom;	// doln konec sestavy k zobrazen (v bodech)

	int			m_IconWidth;	// ka ikony v bodech
	int			m_IconWidthByte; // ka ikony v bajtech
	int			m_IconHeight;	// vka ikony v bodech
	int			m_IconItemSize;	// velikost ikony v bajtech
	int			m_Cols;			// ka aktivn mapy v polkch
	int			m_Rows;			// vka aktivn mapy v polkch
	int			m_Width;		// ka aktivn mapy v bodech
	int			m_Height;		// vka aktivn mapy v bodech
	int			m_WidthByte;	// dlka bodov linky v bajtech
	int			m_RowByte;		// dlka dku obrzk v bajtech

// buffer klves
	int			m_KeyBufWrite;	// ukldac index do bufferu
	int			m_KeyBufRead;	// tec index z bufferu
	int			m_KeyBuf[KEYBUFSIZE]; // buffer klvesnice
	int			m_KeyBufOut[KEYBUFSIZE]; // buffer timeout klves

// ukazatele Petka
//	int			m_PetX;			// polko X
//	int			m_PetY;			// polko Y
//	int			m_PetSmer;		// index smru (0 = vpravo)

// ukazatele Petry
//	int			m_Pet2X;		// polko X
//	int			m_Pet2Y;		// polko Y
//	int			m_Pet2Smer;		// index smru (0 = vpravo)

// buffer stisknutch klves
	BOOL		m_KeyMap[KEYMAPSIZE]; // mapa stisknutch klves

// obsluha provdn programu
	UINT		m_TimerID;		// ID asovae
//	volatile int m_TimeWait;	// ta impuls hodin pro ekn (0=neek)
	CWinThread* m_Thread;		// proces obsluhy programu
//	volatile BOOL m_Break;		// peruen procesu	
	volatile int m_Break;		// pznaky peruen (0 = nen peruen)
	volatile BOOL m_Running;	// pznak provdn programu (b proces)
	int			m_Hloubka;		// hloubka vnoen voln funkc
	volatile BOOL m_TimerReq;	// poadavek obsluhy asovae
	HANDLE		m_TimerReqEvent; // udlost poadavku obsluhy asovae
	int			m_WhileCekej;	// ta obsluhy SLEEP v cyklu

	void MapFnc(int index);
	void MapMap(int index);
	int MapList(int bufID, int index);
	
	void Comp();
	void CompOpenLoc(int index);
	void CompKorigExec(int index);
	void CompAllFunc();

	void _fastcall AktIcon(int x, int y);

	int CompAddItem(PROCCOMMAND command, int data);
	inline int CompAddItem(PROCREAL real, int data);
	inline int CompAddItem(PROCINT integer, int data);
	inline int CompAddItem(PROCSPRITE sprite, int data);
	inline int CompAddItem(PROCTEXT text, int data);

	BOOL CompCommand(int index);
	BOOL CompReal(int index);
	BOOL CompBool(int index);
	BOOL CompIcon(int index);
	BOOL CompSprite(int index);
	BOOL CompMap(int index);
	BOOL CompText(int index);
	BOOL CompSound(int index);

	void RePaint(CDC* dc);
	void ReDisp();
	void BackTimer();
	void SpritePaint(int index);
	void SpriteClear(int index);
	void SpriteMove(int index, double cilx, double cily);
	void SpriteSmer(int index, double smer);
	void SpriteVisible(int index, BOOL visible);

// Dialog Data
	//{{AFX_DATA(CExec)
	enum { IDD = IDD_EXEC };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExec)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CExec)
	afx_msg void OnClose();
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
};

inline void Aloc(EXECITEM*& adr, int size)	// velikost udna v polokch !
	{ adr = (EXECITEM*)_Aloc(adr, size*sizeof(EXECITEM)); }

inline void Aloc(SPRITEVAR*& adr, int size)	// velikost udna v polokch !
	{ adr = (SPRITEVAR*)_Aloc(adr, size*sizeof(SPRITEVAR)); }


UINT ThreadProc(LPVOID pParam);
void CALLBACK EXPORT TimerProc(HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime);

int CompTextGrp(CExec* exc, PROGITEM* item, int index);

// naten relnho vrazu (volat pouze inline funkci FReal(exc));
inline double _fastcall FReal(CExec* exc);
double _fastcall FRealVar(CExec* exc);
double _fastcall FRealLoc(CExec* exc);
double _fastcall FRealConstM1(CExec* exc);
double _fastcall FRealConst0(CExec* exc);
double _fastcall FRealConst1(CExec* exc);
double _fastcall FRealConst2(CExec* exc);
double _fastcall FRealConst3(CExec* exc);
double _fastcall FRealConst4(CExec* exc);
double _fastcall FRealConst5(CExec* exc);
double _fastcall FRealConst6(CExec* exc);
double _fastcall FRealConst7(CExec* exc);
double _fastcall FRealConst8(CExec* exc);
double _fastcall FRealConst9(CExec* exc);
double _fastcall FRealConst10(CExec* exc);
double _fastcall FRealConst(CExec* exc);
double _fastcall FRealAdd1(CExec* exc);
double _fastcall FRealAdd2(CExec* exc);
double _fastcall FRealAdd3(CExec* exc);
double _fastcall FRealAdd(CExec* exc);
double _fastcall FRealSub1(CExec* exc);
double _fastcall FRealSub2(CExec* exc);
double _fastcall FRealSub3(CExec* exc);
double _fastcall FRealSub(CExec* exc);
double _fastcall FRealMul1(CExec* exc);
double _fastcall FRealMul2(CExec* exc);
double _fastcall FRealMul3(CExec* exc);
double _fastcall FRealMul(CExec* exc);
double _fastcall FRealDiv1(CExec* exc);
double _fastcall FRealDiv2(CExec* exc);
double _fastcall FRealDiv3(CExec* exc);
double _fastcall FRealDiv(CExec* exc);
double _fastcall FRealMod1(CExec* exc);
double _fastcall FRealMod2(CExec* exc);
double _fastcall FRealMod3(CExec* exc);
double _fastcall FRealMod(CExec* exc);
double _fastcall FRealPow1(CExec* exc);
double _fastcall FRealPow2(CExec* exc);
double _fastcall FRealPow3(CExec* exc);
double _fastcall FRealPow(CExec* exc);
double _fastcall FRealUhel0(CExec* exc);
double _fastcall FRealUhel45(CExec* exc);
double _fastcall FRealUhel90(CExec* exc);
double _fastcall FRealUhel135(CExec* exc);
double _fastcall FRealUhel180(CExec* exc);
double _fastcall FRealUhel225(CExec* exc);
double _fastcall FRealUhel270(CExec* exc);
double _fastcall FRealUhel315(CExec* exc);
double _fastcall FRealPi(CExec* exc);
double _fastcall FRealEul(CExec* exc);
double _fastcall FRealRand(CExec* exc);
double _fastcall FRealSqrt(CExec* exc);
double _fastcall FRealAbs(CExec* exc);
double _fastcall FRealInt(CExec* exc);
double _fastcall FRealFra(CExec* exc);
double _fastcall FRealSin(CExec* exc);
double _fastcall FRealCos(CExec* exc);
double _fastcall FRealTg(CExec* exc);
double _fastcall FRealCoTg(CExec* exc);
double _fastcall FRealASin(CExec* exc);
double _fastcall FRealACos(CExec* exc);
double _fastcall FRealATg(CExec* exc);
double _fastcall FRealACoTg(CExec* exc);
double _fastcall FRealDegRad(CExec* exc);
double _fastcall FRealRadDeg(CExec* exc);
double _fastcall FRealLog(CExec* exc);
double _fastcall FRealLn(CExec* exc);
double _fastcall FRealExp(CExec* exc);
double _fastcall FRealFact(CExec* exc);
double _fastcall FRealVKey(CExec* exc);
double _fastcall FGetSmer(CExec* exc);
double _fastcall FGetPozX(CExec* exc);
double _fastcall FGetPozY(CExec* exc);
double _fastcall FGetSmer2(CExec* exc);
double _fastcall FGetSwcN1(CExec* exc);
double _fastcall FGetSwcN2(CExec* exc);
double _fastcall FGetSwcN3(CExec* exc);
double _fastcall FGetPozX2(CExec* exc);
double _fastcall FGetPozY2(CExec* exc);
double _fastcall FGetSwcN12(CExec* exc);
double _fastcall FGetSwcN22(CExec* exc);
double _fastcall FGetSwcN32(CExec* exc);

double _fastcall FRealFunc(CExec* exc);

// naten logickho vrazu (volat pouze inline funkci FBool(exc));
inline BOOL _fastcall FBool(CExec* exc);
BOOL _fastcall FBoolVar(CExec* exc);
BOOL _fastcall FBoolLoc(CExec* exc);
BOOL _fastcall FBoolTrue(CExec* exc);
BOOL _fastcall FBoolFalse(CExec* exc);
BOOL _fastcall FBoolAnd1(CExec* exc);
BOOL _fastcall FBoolAnd2(CExec* exc);
BOOL _fastcall FBoolAnd3(CExec* exc);
BOOL _fastcall FBoolAnd(CExec* exc);
BOOL _fastcall FBoolOr1(CExec* exc);
BOOL _fastcall FBoolOr2(CExec* exc);
BOOL _fastcall FBoolOr3(CExec* exc);
BOOL _fastcall FBoolOr(CExec* exc);
BOOL _fastcall FBoolXor1(CExec* exc);
BOOL _fastcall FBoolXor2(CExec* exc);
BOOL _fastcall FBoolXor3(CExec* exc);
BOOL _fastcall FBoolXor(CExec* exc);
BOOL _fastcall FBoolNot(CExec* exc);
BOOL _fastcall FCompEq1(CExec* exc);
BOOL _fastcall FCompEq2(CExec* exc);
BOOL _fastcall FCompEq(CExec* exc);
BOOL _fastcall FCompEqPic1(CExec* exc);
BOOL _fastcall FCompEqPic2(CExec* exc);
BOOL _fastcall FCompEqPic(CExec* exc);
BOOL _fastcall FCompNEq1(CExec* exc);
BOOL _fastcall FCompNEq2(CExec* exc);
BOOL _fastcall FCompNEq(CExec* exc);
BOOL _fastcall FCompLt1(CExec* exc);
BOOL _fastcall FCompLt2(CExec* exc);
BOOL _fastcall FCompLt(CExec* exc);
BOOL _fastcall FCompLtEq1(CExec* exc);
BOOL _fastcall FCompLtEq2(CExec* exc);
BOOL _fastcall FCompLtEq(CExec* exc);
BOOL _fastcall FCompGt1(CExec* exc);
BOOL _fastcall FCompGt2(CExec* exc);
BOOL _fastcall FCompGt(CExec* exc);
BOOL _fastcall FCompGtEq1(CExec* exc);
BOOL _fastcall FCompGtEq2(CExec* exc);
BOOL _fastcall FCompGtEq(CExec* exc);
BOOL _fastcall FKeyTest(CExec* exc);
BOOL _fastcall FBoolFunc(CExec* exc);
BOOL _fastcall FGetRychle(CExec* exc);
BOOL _fastcall FGetSwc1(CExec* exc);
BOOL _fastcall FGetSwc2(CExec* exc);
BOOL _fastcall FGetSwc3(CExec* exc);
BOOL _fastcall FGetSwc4(CExec* exc);
BOOL _fastcall FGetSwc5(CExec* exc);
BOOL _fastcall FGetRychle2(CExec* exc);
BOOL _fastcall FGetSwc12(CExec* exc);
BOOL _fastcall FGetSwc22(CExec* exc);
BOOL _fastcall FGetSwc32(CExec* exc);
BOOL _fastcall FGetSwc42(CExec* exc);
BOOL _fastcall FGetSwc52(CExec* exc);

inline int _fastcall FIcon(CExec* exc);
int _fastcall FIconVar(CExec* exc);
int _fastcall FIconLoc(CExec* exc);
int _fastcall FOkraj(CExec* exc);
int _fastcall FIconFunc(CExec* exc);
int _fastcall FPredmet(CExec* exc);
int _fastcall FPredmet2(CExec* exc);


// naten pkazu (volat pouze inline funkci FCommand(exc));
inline void _fastcall FCommand(CExec* exc);
inline void _fastcall TimeWait(CExec* exc, int count);
void _fastcall FCommandExec0(CExec* exc);
void _fastcall FCommandExec1(CExec* exc);
void _fastcall FCommandExec2(CExec* exc);
void _fastcall FCommandExec3(CExec* exc);
void _fastcall FCommandExec(CExec* exc);
void _fastcall FIf(CExec* exc);
void _fastcall FWhile(CExec* exc);
void _fastcall FRepeat(CExec* exc);
void _fastcall FCaseReal(CExec* exc);
void _fastcall FCaseBool(CExec* exc);
void _fastcall FCaseIcon(CExec* exc);
void _fastcall FJump(CExec* exc);
void _fastcall FLocalReal(CExec* exc);
void _fastcall FLocalBool(CExec* exc);
void _fastcall FLocalIcon(CExec* exc);
void _fastcall FLocalRealCopy(CExec* exc);
void _fastcall FLocalBoolCopy(CExec* exc);
void _fastcall FLocalIconCopy(CExec* exc);
void _fastcall FLocalRealOut(CExec* exc);
void _fastcall FLocalBoolOut(CExec* exc);
void _fastcall FLocalIconOut(CExec* exc);
void _fastcall FFunc(CExec* exc);
void _fastcall FFunc0(CExec* exc);
void _fastcall FSetReal(CExec* exc);
void _fastcall FSetBool(CExec* exc);
void _fastcall FSetIcon(CExec* exc);
void _fastcall FSetRealLoc(CExec* exc);
void _fastcall FSetBoolLoc(CExec* exc);
void _fastcall FSetIconLoc(CExec* exc);
void _fastcall FSetPredmet(CExec* exc);
void _fastcall FSetPredmet2(CExec* exc);
void _fastcall FBreak(CExec* exc);
void _fastcall FReturn(CExec* exc);
void _fastcall FWait1(CExec* exc);
void _fastcall FWait(CExec* exc);
void _fastcall FKrok(CExec* exc);
void _fastcall FVlevo(CExec* exc);
void _fastcall FVpravo(CExec* exc);
void _fastcall FVzad(CExec* exc);
void _fastcall FKrok2(CExec* exc);
void _fastcall FVlevo2(CExec* exc);
void _fastcall FVpravo2(CExec* exc);
void _fastcall FVzad2(CExec* exc);
void _fastcall FSetSmer(CExec* exc);
void _fastcall FSetPozX(CExec* exc);
void _fastcall FSetPozY(CExec* exc);
void _fastcall FSetSwcN1(CExec* exc);
void _fastcall FSetSwcN2(CExec* exc);
void _fastcall FSetSwcN3(CExec* exc);
void _fastcall FSetSwc1(CExec* exc);
void _fastcall FSetSwc2(CExec* exc);
void _fastcall FSetSwc3(CExec* exc);
void _fastcall FSetSwc4(CExec* exc);
void _fastcall FSetSwc5(CExec* exc);
void _fastcall FSetSmer2(CExec* exc);
void _fastcall FSetPozX2(CExec* exc);
void _fastcall FSetPozY2(CExec* exc);
void _fastcall FSetSwcN12(CExec* exc);
void _fastcall FSetSwcN22(CExec* exc);
void _fastcall FSetSwcN32(CExec* exc);
void _fastcall FSetSwc12(CExec* exc);
void _fastcall FSetSwc22(CExec* exc);
void _fastcall FSetSwc32(CExec* exc);
void _fastcall FSetSwc42(CExec* exc);
void _fastcall FSetSwc52(CExec* exc);
void _fastcall FRychle(CExec* exc);
void _fastcall FRychle2(CExec* exc);

// obsluha sprajt
inline SPRITE* _fastcall FSprite(CExec* exc);
SPRITE* _fastcall FSpriteVar(CExec* exc);
SPRITE* _fastcall FSpriteLoc(CExec* exc);
SPRITE* _fastcall FSpriteFunc(CExec* exc);

void _fastcall FSpriteX(CExec* exc);
void _fastcall FSpriteY(CExec* exc);
void _fastcall FSpriteSmer(CExec* exc);
void _fastcall FSpriteVis(CExec* exc);
void _fastcall FSpriteXLoc(CExec* exc);
void _fastcall FSpriteYLoc(CExec* exc);
void _fastcall FSpriteSmerLoc(CExec* exc);
void _fastcall FSpriteVisLoc(CExec* exc);
void _fastcall FLocalSpriteOut(CExec* exc);
void _fastcall FLocalSpriteCopy(CExec* exc);
void _fastcall FLocalSprite(CExec* exc);
void _fastcall FCaseSprite(CExec* exc);
void _fastcall FSetSprite(CExec* exc);
void _fastcall FSetSpriteLoc(CExec* exc);

BOOL _fastcall FGetSpriteVis(CExec* exc);
BOOL _fastcall FGetSpriteMove(CExec* exc);
BOOL _fastcall FGetSpriteVisLoc(CExec* exc);
BOOL _fastcall FGetSpriteMoveLoc(CExec* exc);

double _fastcall FGetSpriteX(CExec* exc);
double _fastcall FGetSpriteY(CExec* exc);
double _fastcall FGetSpriteSmer(CExec* exc);
double _fastcall FGetSpriteXLoc(CExec* exc);
double _fastcall FGetSpriteYLoc(CExec* exc);
double _fastcall FGetSpriteSmerLoc(CExec* exc);

// obsluha ploch
inline int _fastcall FMap(CExec* exc);
int _fastcall FMapVar(CExec* exc);
int _fastcall FMapLoc(CExec* exc);
int _fastcall FMapFunc(CExec* exc);

void _fastcall FCaseMap(CExec* exc);
void _fastcall FLocalMapCopy(CExec* exc);
void _fastcall FLocalMap(CExec* exc);
void _fastcall FLocalMapOut(CExec* exc);
void _fastcall FSetMap(CExec* exc);
void _fastcall FSetMapLoc(CExec* exc);
void _fastcall FSetMapDat(CExec* exc, int dst, int src);

// obsluha seznamu objekt
double _fastcall FGetList(CExec* exc);
double _fastcall FGetListLoc(CExec* exc);
double _fastcall FGetListAuto(CExec* exc);
double _fastcall FGetListAutoLoc(CExec* exc);
double _fastcall FRealVarList(CExec* exc);
double _fastcall FRealLocList(CExec* exc);
double _fastcall FGetSpriteXList(CExec* exc);
double _fastcall FGetSpriteXLocList(CExec* exc);
double _fastcall FGetSpriteYList(CExec* exc);
double _fastcall FGetSpriteYLocList(CExec* exc);
double _fastcall FGetSpriteSmerList(CExec* exc);
double _fastcall FGetSpriteSmerLocList(CExec* exc);
BOOL _fastcall FBoolVarList(CExec* exc);
BOOL _fastcall FBoolLocList(CExec* exc);
BOOL _fastcall FGetSpriteVisList(CExec* exc);
BOOL _fastcall FGetSpriteVisLocList(CExec* exc);
BOOL _fastcall FGetSpriteMoveList(CExec* exc);
BOOL _fastcall FGetSpriteMoveLocList(CExec* exc);
SPRITE* _fastcall FSpriteVarList(CExec* exc);
SPRITE* _fastcall FSpriteLocList(CExec* exc);
int _fastcall FIconVarList(CExec* exc);
int _fastcall FIconLocList(CExec* exc);
int _fastcall FMapVarList(CExec* exc);
int _fastcall FMapLocList(CExec* exc);
void _fastcall FLocalListCopy(CExec* exc);
void _fastcall FLocalRealListCopy(CExec* exc);
void _fastcall FLocalBoolListCopy(CExec* exc);
void _fastcall FLocalIconListCopy(CExec* exc);
void _fastcall FLocalSpriteListCopy(CExec* exc);
void _fastcall FLocalMapListCopy(CExec* exc);
void _fastcall FLocalListOut(CExec* exc);
void _fastcall FSetRealList(CExec* exc);
void _fastcall FSetRealLocList(CExec* exc);
void _fastcall FSetBoolList(CExec* exc);
void _fastcall FSetBoolLocList(CExec* exc);
void _fastcall FSetIconList(CExec* exc);
void _fastcall FSetIconLocList(CExec* exc);
void _fastcall FSetSpriteList(CExec* exc);
void _fastcall FSetSpriteLocList(CExec* exc);
void _fastcall FSetMapList(CExec* exc);
void _fastcall FSetMapLocList(CExec* exc);
void _fastcall FSpriteXList(CExec* exc);
void _fastcall FSpriteXLocList(CExec* exc);
void _fastcall FSpriteYList(CExec* exc);
void _fastcall FSpriteYLocList(CExec* exc);
void _fastcall FSpriteSmerList(CExec* exc);
void _fastcall FSpriteSmerLocList(CExec* exc);
void _fastcall FSpriteVisList(CExec* exc);
void _fastcall FSpriteVisLocList(CExec* exc);
void _fastcall FSetList(CExec* exc);
void _fastcall FSetListLoc(CExec* exc);
void _fastcall FSetListAuto(CExec* exc);
void _fastcall FSetListAutoLoc(CExec* exc);

// obsluha textu
inline CString _fastcall FText(CExec* exc);
CString _fastcall FTextConst(CExec* exc);
CString _fastcall FTextEmpty(CExec* exc);
CString _fastcall FTextVar(CExec* exc);
CString _fastcall FTextVarList(CExec* exc);
CString _fastcall FTextLoc(CExec* exc);
CString _fastcall FTextLocList(CExec* exc);
CString _fastcall FGetCaption(CExec* exc);
CString _fastcall FGetStatus(CExec* exc);
CString _fastcall FTextFunc(CExec* exc);
void _fastcall FLocalText(CExec* exc);
void _fastcall FLocalTextCopy(CExec* exc);
void _fastcall FLocalTextListCopy(CExec* exc);
void _fastcall FLocalTextOut(CExec* exc);
void _fastcall FSetText(CExec* exc);
void _fastcall FSetTextList(CExec* exc);
void _fastcall FSetTextLoc(CExec* exc);
void _fastcall FSetTextLocList(CExec* exc);
void _fastcall FSetCaption(CExec* exc);
void _fastcall FSetStatus(CExec* exc);
void _fastcall FCaseText(CExec* exc);
BOOL _fastcall FCompEqTxt1(CExec* exc);
BOOL _fastcall FCompEqTxt2(CExec* exc);
BOOL _fastcall FCompEqTxt(CExec* exc);
BOOL _fastcall FCompGtTxt1(CExec* exc);
BOOL _fastcall FCompGtTxt2(CExec* exc);
BOOL _fastcall FCompGtTxt(CExec* exc);

double _fastcall FTextLen(CExec* exc);
double _fastcall FTextScan(CExec* exc);
double _fastcall FTextFind(CExec* exc);
double _fastcall FTextOrd(CExec* exc);
CString _fastcall FTextLeft(CExec* exc);
CString _fastcall FTextRight(CExec* exc);
CString _fastcall FTextMid(CExec* exc);
CString _fastcall FTextAdd1(CExec* exc);
CString _fastcall FTextAdd2(CExec* exc);
CString _fastcall FTextAdd(CExec* exc);
CString _fastcall FTextFormat(CExec* exc);
CString _fastcall FTextLower(CExec* exc);
CString _fastcall FTextUpper(CExec* exc);
CString _fastcall FTextChar(CExec* exc);

// obsluha zvuku
inline int _fastcall FSound(CExec* exc);
int _fastcall FSoundVar(CExec* exc);
int _fastcall FSoundVarList(CExec* exc);
int _fastcall FSoundLoc(CExec* exc);
int _fastcall FSoundLocList(CExec* exc);
int _fastcall FSoundFunc(CExec* exc);
void _fastcall FCaseSound(CExec* exc);
void _fastcall FLocalSound(CExec* exc);
void _fastcall FLocalSoundCopy(CExec* exc);
void _fastcall FLocalSoundListCopy(CExec* exc);
void _fastcall FLocalSoundOut(CExec* exc);
void _fastcall FSetSound(CExec* exc);
void _fastcall FSetSoundList(CExec* exc);
void _fastcall FSetSoundLoc(CExec* exc);
void _fastcall FSetSoundLocList(CExec* exc);
void _fastcall FSoundPlay(CExec* exc);
void _fastcall FSoundStop(CExec* exc);
