
////////////////////////////////////////////////////////////////////
// definice poloky mapy
//
// Poloky jsou v map ukldny zleva doprava od spodnho dku nahoru

#define MAXMAPWIDTH		1000	// maximln ka mapy
#define	MAXMAPHEIGHT	1000	// maximln vka mapy
#define	MAXMAPSIZE		100000	// maximln velikost mapy

#define MAPDEFWIDTH		20		// implicitn ka mapy
#define MAPDEFHEIGHT	15		// implicitn vka mapy

typedef struct tagMAPITEM {
	long			icon;	// index ikony polka
	unsigned long	param;	// parametry polka - hodnota a pznaky
							//		bit 0 a bit 9 ........ (10 bit) hodnota 1 (0 a 1023)
							//		bit 10 a bit 19 ...... (10 bit) hodnota 2 (0 a 1023)
							//		bit 20 a bit 26 ...... (7 bit) hodnota 3 (0 a 127)
							//		bit 27 a bit 31 ...... (5 bit) pznaky 1 a 5
							
} MAPITEM;

typedef struct tagMAP {
	long		width;		// ka plochy
	long		height;		// vka ikony
	MAPITEM	item[1];		// poloky mapy
} MAP;

// parametry:
#define	MAP_VALUE1_MASK		0x000003FF		// maska hodnoty 1 polka
#define MAP_VALUE1_ROT		0				// poet rotac pro hodnotu 1 polka
#define MAP_VALUE1_MAX		1023			// maximln hodnota pro hodnotu 1 polka
#define MAP_VALUE2_MASK		0x000FFC00		// maska hodnoty 2 polka
#define MAP_VALUE2_ROT		10				// poet rotac pro hodnotu 2 polka
#define MAP_VALUE2_MAX		1023			// maximln hodnota pro hodnotu 2 polka
#define MAP_VALUE3_MASK		0x07F00000		// maska hodnoty 3 polka
#define MAP_VALUE3_ROT		20				// poet rotac pro hodnotu 3 polka
#define MAP_VALUE3_MAX		127				// maximln hodnota pro hodnotu 3 polka

#define MAP_FLAG1			0x08000000		// pznak 1
#define MAP_FLAG2			0x10000000		// pznak 2
#define MAP_FLAG3			0x20000000		// pznak 3
#define MAP_FLAG4			0x40000000		// pznak 4
#define MAP_FLAG5			0x80000000		// pznak 5

////////////////////////////////////////////////////////////////////
// tda bufferu mapy

class CMapBuf : public CObject
{
public:
	CMapBuf();				// konstruktor
	virtual ~CMapBuf();		// destruktor

	BYTE*		m_Data;		// data map
	int*		m_Index;	// indexy map

	int			m_Num;		// poet poloek v bufferu
	int			m_IndexMax;	// velikost bufferu index map (poloek)

	int			m_DataNum;	// poet bajt v bufferu dat map
	int			m_DataMax;	// velikost bufferu dat map (bajt)

	CProgBuf*	m_ProgBuf;	// adresa tabulky buffer

// vyprzdnn bufferu
	inline void RemoveAll()
	{
		m_Num = 0;
		m_DataNum = 0;
	}

// zjitn adresy poloky
	inline MAP* Get(int Index)
	{
		if ((Index <= 0) || (Index >= m_Num))
			return (MAP*) m_Data;
		else
			return (MAP*) &(m_Data[m_Index[Index]]);
	}

// zjitn ikony mapy (bez kontrol hodnot !)
//	inline int GetIcon(int Index, int x, int y)
//	{
//		MAP* map = (MAP*) &(m_Data[m_Index[Index]]);
//		return map->item[x + y*map->width].icon;
//	}

// navrcen potu poloek v bufferu
	inline int GetSize() const
		{ return m_Num; }

// pidn nov poloky do bufferu
	int Add(MAP* item);

// duplikace poloky
	int Duplik(int Index);

// vytvoen nov mapy danch rozmr (vrac index, omez velikost)
	int New(int width, int height);

// vpoet velikosti mapy v bajtech
	inline int MapSize(MAP* map)
		{ return ((map->width)*(map->height)-1)*sizeof(MAPITEM) + sizeof(MAP); }

	inline int MapSize(int Index)
		{ return MapSize(Get(Index)); }

// zruen poloky z bufferu
	void Delete(int Index);

// nastaven nov velikosti mapy (omez velikost)
	void SetSize(int Index, int width, int height);
};

