// Peter.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Peter.h"

#include "Select.h"
#include "IconBuf.h"
#include "TextBuf.h"
#include "RealBuf.h"
#include "BoolBuf.h"
#include "MapBuf.h"
#include "SprtBuf.h"
#include "SndBuf.h"
#include "ProgBuf.h"
#include "EditDial.h"
#include "EditSprt.h"
#include "EditIcon.h"
#include "EditMap.h"
#include "EditSnd.h"
#include "Prog.h"
#include "MainFrm.h"
#include "PetrDoc.h"
#include "Exec.h"

//#include "PetrView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// globln promnn

// jmno editovanho souboru
CString	Jmeno = "";			// jmno editovanho souboru (bez cesty a bez ppony)

// parametry obrazovky
int ScreenWidth;			// ka obrazovky
int ScreenHeight;			// vka obrazovky

// konfiguran promnn
int Profile = 1;			// slo profilu (z pkazovho dku)
CString ProfName;			// jmno profilu

int Scale;					// mtko pro relativn rozmry okna

int MainLeft;				// relativn pozice hlavnho okna vlevo
int MainTop;				// relativn pozice hlavnho okna nahoe
int MainWidth;				// relativn ka hlavnho okna
int MainHeight;				// relativn vka hlavnho okna

int LeftWidth;				// relativn ka levho pole (objekty)
int LeftHeight;				// relativn vka levho hornho okna (globln objekty)
int RightWidth;				// relativn ka pravho pole (tdy)
int RightHeight;			// relativn vka pravho hornho okna (struktury)

BOOL Maximized;				// pznak maximalizace okna

CString FindString = _T("");	// hledan text

// globln objekty
CMainFrame*	MainFrame = NULL;// hlavn okno aplikace
CPeterApp theApp;			// hlavn objekt aplikace
CProg* Prog = NULL;			// okno editoru programovn
CExec* Exec[MAXEXEC];		// tabulka sputnch oken Exec (NULL = voln)

// standardn palety
HPALETTE StdPalette;		// vlastn palety
BITMAPINFO* StdBitmapInfo;	// standardn zhlav BMP

// tabulka importu palet (velikost jsou hodnoty RGB 32*32*32, vstupem je index barvy)
BYTE*	StdPalImport;	// pouit: StdPalImport[red/8 + 32*green/8 + 32*32*blue/8]

BYTE KonvPal[256];			// konverzn tabulka palet

// tabulka hladin standardnch barev (0 a 256)
const int ColLevTab[] = 
{
	256,
	256*13/16, 
	256*10/16,
	256*7/16,
	256*4/16,
};

// tabulka odstn standardnch barev (0 a 255) - poad B, G, R, F,
const RGBQUAD ColColTab[] = 
{ 
	0,		0,		255,		0,			// erven
	0,		114,	255,		0,
	0,		182,	255,		0,
	0,		255,	255,		0,			// lut
	0,		255,	166,		0,
	0,		255,	0,			0,			// zelen
	138,	255,	0,			0,
	255,	255,	0,			0,			// modrozelen
	255,	186,	0,			0,
	255,	114,	0,			0,
	255,	0,		0,			0,			// modr
	255,	0,		114,		0,
	255,	0,		174,		0,
	255,	0,		255,		0,			// fialov
	138,	0,		255,		0,

	200,	174,	255,		0,
	210,	220,	255,		0,
	150,	166,	255,		0,
	150,	198,	255,		0,
	182,	255,	255,		0,
	162,	255,	162,		0,
	222,	255,	138,		0,
	255,	242,	210,		0,
	255,	210,	154,		0,
	255,	162,	198,		0,

/*
	96,		96,		255,		0,
	96,		128,	255,		0,
	96,		192,	255,		0,
	96,		255,	255,		0,
	96,		255,	192,		0,
	192,	96,		255,		0,
	192,	128,	255,		0,
	192,	192,	255,		0,
	192,	255,	255,		0,
	192,	255,	192,		0,
	255,	96,		255,		0,
	255,	128,	255,		0,
	255,	192,	255,		0,
	255,	255,	192,		0,*/
	255,	255,	255,		0,			// bl
	96,		96,		96,			0,			// ed
};


const int ColLev = sizeof(ColLevTab)/sizeof(ColLevTab[0]);	// poet hladin barev
const int ColCol = sizeof(ColColTab)/sizeof(ColColTab[0]);	// poet odstn barev
const int StdColors = 1 + ColCol*ColLev;					// poet vlastnch palet (zanaj od 0)

const long double pi  = 3.14159265358979323846;		// Ludolfovo slo
const long double pi2 = 6.28318530717958647693;		// Ludolfovo slo * 2
const long double eul = 2.71828182845904523536;		// Eulerovo slo

const long double uhel22  = 0.39269908169872415481;	// hel 22.5 stup v radinech
const long double uhel45  = 0.78539816339744830962;	// hel 45 stup v radinech
const long double uhel90  = 1.57079632679489661923;	// hel 90 stup v radinech
const long double uhel135 = 2.35619449019234492885;	// hel 135 stup v radinech
const long double uhel180 = 3.14159265358979323846;	// hel 180 stup v radinech
const long double uhel225 = 3.92699081698724154808;	// hel 225 stup v radinech
const long double uhel270 = 4.71238898038468985769;	// hel 270 stup v radinech
const long double uhel315 = 5.49778714378213816731;	// hel 315 stup v radinech

const long double degrad = 0.017453292519943295769237;	// konstanta pro pevod z DEG na RAD (pi/180)
const long double raddeg = 57.2957795130823208768;	// konstanta pro pevod z RAD na DEG (180/pi)

int TimerConst = 15;						// konstanta pro asova (pro 55 ms)

unsigned int RandomSeed;					// konstanta pro genertor nhody

/////////////////////////////////////////////////////////////////////////////
// CPeterApp

BEGIN_MESSAGE_MAP(CPeterApp, CWinApp)
	//{{AFX_MSG_MAP(CPeterApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW2, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN2, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// konstruktor a destruktor

CPeterApp::CPeterApp()
{
	StdPalette = NULL;
	StdPalImport = new BYTE[32 * 32 * 32];
	
	StdBitmapInfo = (BITMAPINFO*) new BYTE[sizeof(BITMAPINFO) + sizeof(RGBQUAD)*255];
}

CPeterApp::~CPeterApp()
{
	for (int i = 0; i < MAXEXEC; i++)
	{
		if (Exec[i] != NULL)
		{
			Exec[i]->m_Break = TRUE;
			Exec[i]->SendMessage(WM_CLOSE);
		}
	}

	if (StdPalette != NULL)
	{
		DeleteObject(StdPalette);
		StdPalette = NULL;
	}
	delete[] StdBitmapInfo;
	delete[] StdPalImport;
}


/////////////////////////////////////////////////////////////////////////////
// inicializace aplikace

BOOL CPeterApp::InitInstance()
{

// inicializace 3D vzhledu oken
#ifdef _AFXDLL
	Enable3dControls();
#else
	Enable3dControlsStatic();
#endif

// pprava parametr obrazovky
	ScreenWidth = ::GetSystemMetrics(SM_CXMAXIMIZED);
	ScreenHeight = ::GetSystemMetrics(SM_CYMAXIMIZED);

// naten konfigurace z INI
	ReadIni();

// inicializace genertoru nhory
	RandomSeed = (unsigned)time(NULL) + 486874*(unsigned)time(NULL);	// inicializace genertoru nhody

//	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	// Register document templates

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CPeterDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CSelect));
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
//	EnableShellOpen();
//	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
//	CCommandLineInfo cmdInfo;
//	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
//	if (!ProcessShellCommand(cmdInfo))
//		return FALSE;


// kontrola peteen potu barev
	ASSERT(StdColors < 256 - 32);


// naten standardnho zhlav BMP
	HRSRC hRes = ::FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_PALETY), RT_BITMAP);
	ASSERT(hRes != NULL);
	HGLOBAL hData = ::LoadResource(AfxGetResourceHandle(), hRes);
	ASSERT(hData != NULL);
	memcpy(StdBitmapInfo, ::LockResource(hData), sizeof(BITMAPINFO) + sizeof(RGBQUAD)*255);
	StdBitmapInfo->bmiHeader.biSizeImage = 0;
	StdBitmapInfo->bmiHeader.biSizeImage = 0;

// vytvoen standardnch palet
	LOGPALETTE* pStdPalette = (LOGPALETTE*) new char[sizeof(PALETTEENTRY)*(StdColors-1)+sizeof(LOGPALETTE)];
	pStdPalette->palVersion = 0x300;
	pStdPalette->palNumEntries = StdColors;





	StdBitmapInfo->bmiColors[0].rgbRed =	151;
	StdBitmapInfo->bmiColors[0].rgbGreen =	3;
	StdBitmapInfo->bmiColors[0].rgbBlue =	151;

	for (int k = 0; k < ColCol; k++)
	{
		StdBitmapInfo->bmiColors[k*ColLev+1] = ColColTab[k];

		for (int l = 1; l < ColLev; l++)
		{
			StdBitmapInfo->bmiColors[k*ColLev+1+l].rgbRed = 
				StdBitmapInfo->bmiColors[k*ColLev+1].rgbRed * ColLevTab[l] / 256;
			StdBitmapInfo->bmiColors[k*ColLev+1+l].rgbGreen = 
				StdBitmapInfo->bmiColors[k*ColLev+1].rgbGreen * ColLevTab[l] / 256;
			StdBitmapInfo->bmiColors[k*ColLev+1+l].rgbBlue = 
				StdBitmapInfo->bmiColors[k*ColLev+1].rgbBlue * ColLevTab[l] / 256;
			StdBitmapInfo->bmiColors[k*ColLev+1+l].rgbReserved = 0;
		}
	}


	k = 2*ColLev-1;
	for (int m = StdColors - 2*ColLev; m < StdColors; m++)
	{
		int n = k * 255 / (2*ColLev-1);
		StdBitmapInfo->bmiColors[m].rgbRed = n;
		StdBitmapInfo->bmiColors[m].rgbGreen = n;
		StdBitmapInfo->bmiColors[m].rgbBlue = n;
		k--;
	}

	GenPalImport();
	GenKonvPal(StdBitmapInfo);

	for (int i=0; i<StdColors; i++)
	{
		pStdPalette->palPalEntry[i].peRed = StdBitmapInfo->bmiColors[i].rgbRed;
		pStdPalette->palPalEntry[i].peGreen = StdBitmapInfo->bmiColors[i].rgbGreen; 
		pStdPalette->palPalEntry[i].peBlue = StdBitmapInfo->bmiColors[i].rgbBlue;
		pStdPalette->palPalEntry[i].peFlags = 0;
	}

	StdPalette = ::CreatePalette(pStdPalette);
	ASSERT(StdPalette != NULL);
	delete pStdPalette;


	// Enable drag/drop open
//	m_pMainWnd->DragAcceptFiles();

	OnFileNew();

	MainFrame = (CMainFrame*)m_pMainWnd;
	MainFrame->OnSelect();

//	if (m_lpCmdLine[0] != '\0')
//	{
//	}


//	CMainFrame* frm = new CMainFrame;
//	frm->LoadFrame(IDR_MAINFRAME);
//	frm->ShowWindow(TRUE);
//	frm->UpdateWindow();
//	m_pMainWnd = frm;

	for (int exec = 0; exec < MAXEXEC; exec++)
	{
		Exec[exec] = NULL;
	}


	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// ukonen aplikace

int CPeterApp::ExitInstance() 
{
	WriteIni();				// zpis konfigurace
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// vygenerovn tabulky pro import palet

//inline short _fastcall getpal(RGBQUAD* rgb, BYTE r, BYTE g, BYTE b)
//{
//	return	abs(rgb->rgbRed - r) +
//			abs(rgb->rgbGreen - g) +
//			abs(rgb->rgbBlue - b);
//	short result;
//	_asm {
//		xor	ax,ax;
//		mov al,[ecx];
//		mov [result],ax;
//
//	}
//	return result;
//}

void GenPalImport()
{
// lokln promnn
	short i;				// pracovn ta
	short min;				// vzdlenost od nalezen nejbli barvy
	short akt;				// vzdlenost od aktuln barvy
	BYTE last;				// posledn nalezen nejbli barva
	BYTE r,g,b;			// hledan barva
	short ri, gi, bi;		// tae barev
	RGBQUAD* rgb;			// ukazatel standardnch palet

// cyklus pes vechny hodnoty barev
	for (ri = 31; ri >=0; ri--)
	{
		r = ri * 8;

		for (gi = 31; gi >= 0; gi--)
		{
			g = gi * 8;

			for (bi = 31; bi >= 0; bi--)
			{
				b = bi * 8;

// pprava ukazatel
				min = 3*256;		// asi tak njak velk vzdlenost
				rgb = &(StdBitmapInfo->bmiColors[1]);	// ukazatel barev

// cyklus pes vechny standardn barvy
				for (i = 1; i < StdColors; i++)
				{

// vzdlenost od aktuln barvy
//					akt = getpal(rgb, r, g, b);
					akt =	abs(rgb->rgbRed - r) +
							abs(rgb->rgbGreen - g) +
							abs(rgb->rgbBlue - b);

// kontrola vzdlenosti od standardn barvy
					if (akt < min)
					{
						min = akt;			// nov vzdlenost
						last = (BYTE)i;		// nov index nejbli barvy
					}

// posun na dal standardn barvu
					rgb++;
				}

// konverzn hodnota
				StdPalImport[ri + 32*gi + 32*32*bi] = last;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// generovn konverzn tabulky barev obrzku

void GenKonvPal(BITMAPINFO* bmp)
{
// lokln promnn
	int i, j;				// pracovn tae
	int min;				// vzdlenost od nalezen nejbli barvy
	int akt;				// vzdlenost od aktuln barvy
	BYTE last;				// posledn nalezen nejbli barva
	BYTE r,g,b;				// hledan barva
	RGBQUAD* rgb;			// ukazatel standardnch palet

// index 0 zstane vdy nezmnn
	KonvPal[0] = 0;

// cyklus pes vechny importovan barvy
	for (i = 1; i < 256; i++)
	{

// pprava pro hledn jedn barvy
		min = 3*256;		// asi tak njak velk vzdlenost
		r = bmp->bmiColors[i].rgbRed;	// erven
		g = bmp->bmiColors[i].rgbGreen;	// zelen
		b = bmp->bmiColors[i].rgbBlue;	// modr
		rgb = &(StdBitmapInfo->bmiColors[1]);	// ukazatel barev

// cyklus pes vechny standardn barvy
		for (j = 1; j < StdColors; j++)
		{

// vzdlenost od aktuln barvy
			akt =	abs(rgb->rgbRed - r) +
					abs(rgb->rgbGreen - g) +
					abs(rgb->rgbBlue - b);

// kontrola vzdlenosti od standardn barvy
			if (akt < min)
			{
				min = akt;				// nov vzdlenost
				last = (BYTE)j;			// nov index nejbli barvy
			}

// posun na dal standardn barvu
			rgb++;
		}

// konverzn hodnota
		KonvPal[i] = last;
	}
}


/////////////////////////////////////////////////////////////////////////////
// obsluha konfigurace

// pomocn texty pro INI
CString tProfile;			// text profilu (pomocn - sestav se)
TCHAR* tProfile0	= _T("Profile%u");

TCHAR* tProfName	= _T("Name");

TCHAR* tLastFile	= _T("LastFile");

TCHAR* tScale		= _T("Scale");

TCHAR* tMainLeft	= _T("Left");
TCHAR* tMainTop		= _T("Top");
TCHAR* tMainWidth	= _T("Width");
TCHAR* tMainHeight	= _T("Height");

TCHAR* tLeftWidth	= _T("LeftWidth");
TCHAR* tLeftHeight	= _T("LeftHeight");
TCHAR* tRightWidth	= _T("RightWidth");
TCHAR* tRightHeight	= _T("RightHeight");

TCHAR* tMaximized	= _T("Maximized");

TCHAR* tFindText	= _T("FindText");

// naten konfigurace
void CPeterApp::ReadIni()
{
	tProfile.Format(tProfile0, Profile );	// sestaven jmna profilu

	ProfName = GetProfileString(tProfile, tProfName, _T("Default"));

	Jmeno = GetProfileString(tProfile, tLastFile, _T(""));

	Scale = GetProfileInt(tProfile, tScale, 10000);
	if (Scale < 100) Scale = 100;
	if (Scale > 100000) Scale = 100000;

	ReadIniInt(MainLeft,	tMainLeft,		Scale * 1/20);
	ReadIniInt(MainTop,		tMainTop,		Scale * 1/20);
	ReadIniInt(MainWidth,	tMainWidth,		Scale * 18/20);
	ReadIniInt(MainHeight,	tMainHeight,	Scale * 18/20);

	ReadIniInt(LeftWidth,	tLeftWidth,		Scale * 1/5);
	ReadIniInt(LeftHeight,	tLeftHeight,	Scale * 2/3);
	ReadIniInt(RightWidth,	tRightWidth,	Scale * 1/5);
	ReadIniInt(RightHeight,	tRightHeight,	Scale * 2/3);

	Maximized = GetProfileInt(tProfile, tMaximized, FALSE);

	FindString = GetProfileString(tProfile, tFindText);
}

// naten jednoho rozmrovho sla z konfigurace
void CPeterApp::ReadIniInt(int& result, LPCTSTR entry, int deflt)
{
	result = GetProfileInt(tProfile, entry, deflt);
	if (result < -Scale) result = -Scale;
	if (result > Scale) result = Scale;
	if (&result != &MainLeft && result < 0) result = 0;
}

// uloen konfigurace
void CPeterApp::WriteIni()
{
	tProfile.Format(tProfile0, Profile );	// sestaven jmna profilu

	WriteProfileString(tProfile, tProfName, ProfName);

	WriteProfileString(tProfile, tLastFile, Jmeno);

	WriteProfileInt(tProfile, tScale,		Scale);

	WriteProfileInt(tProfile, tMainLeft,	MainLeft);
	WriteProfileInt(tProfile, tMainTop,		MainTop);
	WriteProfileInt(tProfile, tMainWidth,	MainWidth);
	WriteProfileInt(tProfile, tMainHeight,	MainHeight);

	WriteProfileInt(tProfile, tLeftWidth,	LeftWidth);
	WriteProfileInt(tProfile, tLeftHeight,	LeftHeight);
	WriteProfileInt(tProfile, tRightWidth,	RightWidth);
	WriteProfileInt(tProfile, tRightHeight,	RightHeight);

	WriteProfileInt(tProfile, tMaximized,	Maximized);

	WriteProfileString(tProfile, tFindText,	FindString);
}

/////////////////////////////////////////////////////////////////////////////
// okno About

void CPeterApp::OnAppAbout()
{
	CDialog About(IDD_ABOUTBOX);
	About.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// alokace buffer (old = NULL vytvo nov, size = 0 zru buffer)

void* _Aloc(void* old, int size)
{
// przdn buffer se neru
	if ((old == NULL) && (size == 0))
		return NULL;

// realokace bufferu
	void* buf = realloc(old, size);

// kontrola spnosti operace
	if ((buf == NULL) && (size != 0))
	{
		::MessageBox(NULL, _T("Lituji, program bude ukonen z dvodu nedostatku pamti!"),
			_T("Nedostatek pamti"), MB_OK | MB_ICONSTOP);
		exit(-1);
	}

// nvrat nov adresy bufferu
	return buf;
}

/////////////////////////////////////////////////////////////////////////////
// genertor nhody

double Rand()
{
	RandomSeed = RandomSeed * 214013 + 2531011;
	return (double)RandomSeed / (double) 4294967296;	// vydlen rozsahem LONG INT
}
