// Peter.h : main header file for the PETER application
//

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// globln promnn

extern CString	Jmeno;				// jmno editovanho programu (bez cesty a bez ppony)

// parametry obrazovky
extern int ScreenWidth;				// ka obrazovky
extern int ScreenHeight;			// vka obrazovky

// konfiguran promnn
extern int Profile;					// slo profilu (z pkazovho dku)
extern CString ProfName;			// jmno profilu

extern int Scale;					// mtko pro relativn rozmry okna

extern int MainLeft;				// relativn pozice hlavnho okna vlevo
extern int MainTop;					// relativn pozice hlavnho okna nahoe
extern int MainWidth;				// relativn ka hlavnho okna
extern int MainHeight;				// relativn vka hlavnho okna

extern int LeftWidth;				// relativn ka levho pole (objekty)
extern int LeftHeight;				// relativn vka levho hornho okna (globln objekty)
extern int RightWidth;				// relativn ka pravho pole (tdy)
extern int RightHeight;				// relativn vka pravho hornho okna (struktury)

extern BOOL Maximized;				// pznak maximalizace okna

extern CString FindString;			// hledan text

// globln objekty
class CMainFrame;
extern	CMainFrame*	MainFrame;		// hlavn okno aplikace
class CPeterApp;
extern	CPeterApp theApp;			// hlavn objekt aplikace
class CProg;
extern CProg* Prog;					// hlavn okno programovn
#define MAXEXEC 100					// maximln sputnch oken Exec
class CExec;
extern CExec* Exec[MAXEXEC];		// tabulka sputnch oken Exec

//extern int		SelectWidth;		// ka pole pro vbr objektu a tidy
extern BITMAPINFO* StdBitmapInfo;	// standardn zhlav BMP
extern HPALETTE StdPalette;			// vlastn palety

extern BYTE KonvPal[256];			// konverzn tabulka palet
extern void GenKonvPal(BITMAPINFO* bmp); // generovn konverzn tabulky
extern void GenPalImport();			// kenerovn tabulky importu

// tabulka importu palet (velikost jsou hodnoty RGB 32*32*32, vstupem je index barvy)
extern BYTE* StdPalImport;	// pouit: StdPalImport[red/8 + 32*green/8 + 32*32*blue/8]

extern const int ColCol;			// poet barev standardnch palet
extern const int ColLev;			// poet rovn standardnch palet
extern const int StdColors;			// poet vlastnch palet (zanaj od 0)

extern const long double pi;		// Ludolfovo slo
extern const long double pi2;		// Ludolfovo slo * 2
extern const long double eul;		// Eulerovo slo
extern const long double uhel22;	// hel 22.5 stup v radinech
extern const long double uhel45;	// hel 45 stup v radinech
extern const long double uhel90;	// hel 90 stup v radinech
extern const long double uhel135;	// hel 135 stup v radinech
extern const long double uhel180;	// hel 180 stup v radinech
extern const long double uhel225;	// hel 215 stup v radinech
extern const long double uhel270;	// hel 270 stup v radinech
extern const long double uhel315;	// hel 315 stup v radinech

extern const long double degrad;	// konstanta pro pevod z DEG na RAD (pi/180)
extern const long double raddeg;	// konstanta pro pevod z RAD na DEG (180/pi)

extern int TimerConst;				// konstanta pro asova (pro 55 ms)

extern double Rand();				// genertor nhodnho sla

// konverze barev
inline void KonvCopy(BYTE* dst, BYTE* src, int num)
{
	for (; num > 0; num--)
	{
		dst[0] = KonvPal[src[0]];
		dst++;
		src++;
	}
}

// import palety
inline BYTE PalImport(BYTE red, BYTE green, BYTE blue)
{
	return StdPalImport[(int)(red/8) + 32*(int)(green/8) + 32*32*(int)(blue/8)];
}

class CBoolBuf;
class CEditIcon;
class CEditMap;
class CEditSprt;
class CIconBuf;
class CMapBuf;
class CProgBuf;
class CProg;

/////////////////////////////////////////////////////////////////////////////
// CPeterApp:
// See Peter.cpp for the implementation of this class
//

class CPeterApp : public CWinApp
{
public:
	CPeterApp();
	~CPeterApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPeterApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CPeterApp)
	afx_msg void OnAppAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void ReadIni();
	void ReadIniInt(int& result, LPCTSTR entry, int deflt);
	void WriteIni();
};


/////////////////////////////////////////////////////////////////////////////
// md editace ikony

enum EditMode
{ 
	EditModeElip,					// elipsa
	EditModeFill,					// vpl
	EditModeLine,					// ra
	EditModePaint,					// ttec
	EditModePen,					// pero
	EditModePipe,					// kaptko
	EditModeRect,					// obdlnk
	EditModeRound,					// kruh
	EditModeSelect,					// blok
	EditModeSpray,					// sprej
	EditModeXFlip,					// horizontln pevrcen
	EditModeYFlip,					// vertikln pevrcen
	EditModeRRot,					// otoen R
	EditModeLRot,					// otoen L
	EditModeXCol,					// zmna barev
};


/////////////////////////////////////////////////////////////////////////////
// realokace velkch buffer (adr = NULL vytvoen, size = 0 zruen)

void* _Aloc(void* adr, int size);

inline void Aloc(char*& adr, int size)
	{ adr = (char*)_Aloc(adr, size*sizeof(char)); }

inline void Aloc(BYTE*& adr, int size)
	{ adr = (BYTE*)_Aloc(adr, size*sizeof(BYTE)); }

inline void Aloc(BITMAPINFO*& adr, int size)
	{ adr = (BITMAPINFO*)_Aloc(adr, size); }

inline void Aloc(double*& adr, int size)
	{ adr = (double*)_Aloc(adr, size); }

inline void Aloc(int*& adr, int size)				// velikost udna v potu poloek int !
	{ adr = (int*)_Aloc(adr, size*sizeof(int)); }

//inline void Aloc(BYTE**& adr, int size)				// velikost udna v potu ukazatel BYTE* !
//	{ adr = (BYTE**)_Aloc(adr, size*sizeof(BYTE*)); }

//inline void Aloc(short*& adr, int size)				// velikost udna v potu poloek short !
//	{ adr = (short*)_Aloc(adr, size*sizeof(short)); }
