
#include "stdafx.h"
#include "peter.h"
#include "MainFrm.h"
#include "IconBuf.h"
#include "TextBuf.h"
#include "RealBuf.h"
#include "BoolBuf.h"
#include "MapBuf.h"
#include "SprtBuf.h"
#include "SndBuf.h"
#include "ProgBuf.h"
#include "EditDial.h"
#include "EditSprt.h"
#include "EditMap.h"
#include "EditIcon.h"
#include "EditSnd.h"
#include "Prog.h"
#include "Exec.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////
//          !!!!!!!!!!!!!!!!!!!!!!!!!				//
//   Nastavit zarovnvn pekladae na 4 Bajty,	//
//  aby souhlasilo zarovnvn struktur v souboru	//
//	        !!!!!!!!!!!!!!!!!!!!!!!!!				//
//////////////////////////////////////////////////////


const int SplitSize = 6;							// ka pedlu

#define SELTIMERID 4823

/////////////////////////////////////////////////////////////////////////////
// vnoen sti souboru

#include "ProgInit.cpp"			// inicializace bufferu a programu
#include "ProgFile.cpp"			// obsluha uloen a naten souboru
#include "ProgTrak.cpp"			// obsluha taen pedl oken
#include "ProgDrag.cpp"			// obsluha taen ikon
#include "ProgProp.cpp"			// obsluha vlastnost prvk
#include "ProgNav.cpp"			// obsluha navigace

/////////////////////////////////////////////////////////////////////////////
// konstruktor a destruktor

IMPLEMENT_DYNCREATE(CProg, CFormView)

CProg::CProg()
	: CFormView(CProg::IDD)
{
	//{{AFX_DATA_INIT(CProg)
	//}}AFX_DATA_INIT

	Prog = this;

	ASSERT((sizeof(internalID)/sizeof(internalID[0])) == INTERNALNUM);
	ASSERT(CompComTabSize == INTERNALNUM);
	ASSERT(CompNumTabSize == INTERNALNUM);
	ASSERT(CompBoolTabSize == INTERNALNUM);
	ASSERT (sizeof(importName)/sizeof(importName[0]) == INTERNALNUM);

// vytvoen seznam ikon
//	HIMAGELIST hImg;

	m_Ico16 = new CImageList();
//	hImg = ImageList_Create(16,16,ILC_COLORDDB | ILC_MASK,INTERNALNUM,10);
//	ASSERT(hImg != NULL);
//	m_Ico16->Attach(hImg);

	m_Ico32 = new CImageList();
//	hImg = ImageList_Create(32,32,ILC_COLORDDB | ILC_MASK,INTERNALNUM,10);
///	ASSERT(hImg != NULL);
//	m_Ico32->Attach(hImg);

	m_State16 = new CImageList();
//	hImg = ImageList_Create(8,16,ILC_COLORDDB | ILC_MASK,INTERNALNUM,10);
//	ASSERT(hImg != NULL);
//	m_State16->Attach(hImg);

	m_State32 = new CImageList();
//	hImg = ImageList_Create(12,32,ILC_COLORDDB | ILC_MASK,INTERNALNUM,10);
//	ASSERT(hImg != NULL);
//	m_State32->Attach(hImg);

// inicalizace buffer ikon (pro jin nastaven ne implicitn)
	m_BufState32.m_Width = 12;
	m_BufState32.m_WidthByte = 12;
	m_BufState32.m_ItemSize = 32*12;

// navzn strom na buffery programu
	m_BufObj.m_Tree = &m_Object;	// strom objekt
	m_BufLoc.m_Tree = &m_Local; 	// strom loklnch objekt
	m_BufStr.m_Tree = &m_Struc; 	// strom struktur
	m_BufCls.m_Tree = &m_Class; 	// strom td
	m_BufEdi.m_Tree = &m_Edit;		// strom editace

// navzn seznamu text a odkaz na buffery programu
	for (int i = 0; i < PROGBUFNUM; i++)
	{
		m_Buf[i].m_ProgBuf = &(m_Buf[0]); // adresa vech buffer
		m_Buf[i].m_Text = &m_Text;		// seznam text
		m_Buf[i].m_Real = &m_Real;		// seln buffer
		m_Buf[i].m_Bool = &m_Bool;		// logick buffer
		m_Buf[i].m_Icon = &m_Icon;		// buffer obrzk
		m_Buf[i].m_Map = &m_Map;		// buffer map
		m_Buf[i].m_Sprite = &m_Sprite;	// buffer sprajt
		m_Buf[i].m_Sound = &m_Sound;	// buffer zvuk
		m_Buf[i].m_BufID = i;			// identifikace bufferu
	}
//	m_BufInt.m_Text = &m_TextInt;	// texty pro intern funkce

	m_Map.m_ProgBuf = &(m_Buf[0]);	// adresa buffer
	m_Sprite.m_ProgBuf = &(m_Buf[0]);	// adresa buffer

	m_ProgPic.m_Icon = &m_Icon;		// buffer ikon pro editor
	m_ProgMap.m_Map = &m_Map;		// buffer map
	m_ProgMap.m_Icon = &m_Icon;		// buffer map
	m_ProgSprite.m_Sprite = &m_Sprite; // buffer sprajt
	m_ProgSprite.m_Map = &m_Map;		// buffer map
	m_ProgSprite.m_Icon = &m_Icon;		// buffer map
	m_ProgSound.m_Sound = &m_Sound;	// buffer zvuk

	m_Dragging = FALSE; 			// nen taen
	m_Tracking = FALSE;				// nen taen pedl
	m_TrackDisp = FALSE;			// nen zobrazen pedl taen

	m_ReDispCount = 0;				// nen poadovno pekreslen

	m_Saving = FALSE;				// nen ukldn/natn

	m_AktBufID = BufEdiID;			// aktivn buffer
//	m_AktTree = &m_Edit;			// aktivn strom
	m_FilName = FALSE;				// neprobh plnn jmna poloky
	m_Editing = FALSE;				// neprobh editace jmna poloky
	m_OldRef = -2;					// ta nen zobrazen
//	m_FindDialog = NULL;			// nen hledac okno
//	m_FindDisp = FALSE;				// nen zobrazeno hledac okno
//	m_AktDef = 2;					// aktuln stav pepnae "implicitn text"
	m_EditBufN = BufEdiID;			// aktivn editan buffer
	m_EditItem = 0;					// nen editavn poloka
	m_FilDat = FALSE;				// nen plnn dat
	m_SelChange = FALSE;			// nen zmna aktivnho prvku programem
	m_SelTimer = 0;					// nen asova
	m_SelItem = -1;					// nen prvek

	m_EditHistBuf = NULL;			// nen buffer historie sel editovanch buffer
	m_EditHistItem = NULL;			// nen buffer historie sel editovanch prvk
	m_EditHistNum = 0;				// poet prvk v bufferu historie editace
	m_EditHistAkt = 0;				// aktivn prvek v bufferu historie editace
	m_EditHistMax = 0;				// velikost buffer historie editace
	m_EditHistFil = FALSE;			// nen navracen historie
	m_EditHistSpriteIndex = NULL;	// nen buffer index editovanch sprajt
	m_EditHistSpriteX = NULL;		// nen buffer souadnic X editovanch sprajt
	m_EditHistSpriteY = NULL;		// nen buffer souadnic Y editovanch sprajt
	m_EditHistProg = NULL;			// nen buffer kurzoru v programu

	m_OldEditX = -2;
	m_OldEditY = -2;
	m_OldEditMapX = -2;
	m_OldEditMapY = -2;
	
}

CProg::~CProg()
{
// zruen seznamu ikon
	m_Ico16->DeleteImageList();
	delete m_Ico16;
	m_Ico32->DeleteImageList();
	delete m_Ico32;
	m_State16->DeleteImageList();
	delete m_State16;
	m_State32->DeleteImageList();
	delete m_State32;
	Aloc(m_EditHistBuf, 0);				// zruen bufferu historie sel editovanch buffer
	Aloc(m_EditHistItem, 0);			// zruen bufferu historie sel editovanch poloek
	Aloc(m_EditHistSpriteIndex, 0);		// zruen bufferu index editovanch sprajt
	Aloc(m_EditHistSpriteX, 0);			// zruen bufferu souadnic X editovanch sprajt
	Aloc(m_EditHistSpriteY, 0);			// zruen bufferu souadnic Y editovanch sprajt
	Aloc(m_EditHistProg, 0);			// zruen bufferu aktivnho kurzoru programu
}

void CProg::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProg)
	DDX_Control(pDX, IDC_PROG_BACKGROUND, m_ProgBack);
	DDX_Control(pDX, IDC_PROG_LOGIC, m_ProgLogic);
	DDX_Control(pDX, IDC_PROG_MUSIC, m_ProgMusic);
	DDX_Control(pDX, IDC_PROG_TEXT, m_ProgText);
	DDX_Control(pDX, IDC_PROG_REAL, m_ProgReal);
	DDX_Control(pDX, IDC_STATIC1, m_Nadpis1);
	DDX_Control(pDX, IDC_STATIC2, m_Nadpis2);
	DDX_Control(pDX, IDC_STATIC3, m_Nadpis3);
	DDX_Control(pDX, IDC_STATIC4, m_Nadpis4);
	DDX_Control(pDX, IDC_PROG_OBJECT, m_Object);
	DDX_Control(pDX, IDC_PROG_LOCAL, m_Local);
	DDX_Control(pDX, IDC_PROG_STRUC, m_Struc);
	DDX_Control(pDX, IDC_PROG_CLASS, m_Class);
	DDX_Control(pDX, IDC_PROG, m_Edit);
	DDX_Control(pDX, IDC_PROG_SPLIT1, m_Split1);
	DDX_Control(pDX, IDC_PROG_SPLIT2, m_Split2);
	DDX_Control(pDX, IDC_PROG_SPLIT3, m_Split3);
	DDX_Control(pDX, IDC_PROG_SPLIT4, m_Split4);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProg, CFormView)
	//{{AFX_MSG_MAP(CProg)
	ON_WM_SIZE()
	ON_NOTIFY(TVN_BEGINDRAG, IDC_PROG_OBJECT, OnBeginDragProgObj)
	ON_NOTIFY(TVN_BEGINDRAG, IDC_PROG_LOCAL, OnBeginDragProgLoc)
	ON_NOTIFY(TVN_BEGINDRAG, IDC_PROG_STRUC, OnBeginDragProgStr)
	ON_NOTIFY(TVN_BEGINDRAG, IDC_PROG_CLASS, OnBeginDragProgCls)
	ON_NOTIFY(TVN_BEGINDRAG, IDC_PROG, OnBeginDragProgEdi)
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_NOTIFY(TVN_ITEMEXPANDED, IDC_PROG_OBJECT, OnItemExpandedProgObj)
	ON_NOTIFY(TVN_ITEMEXPANDED, IDC_PROG_LOCAL, OnItemExpandedProgLoc)
	ON_NOTIFY(TVN_ITEMEXPANDED, IDC_PROG_STRUC, OnItemExpandedProgStr)
	ON_NOTIFY(TVN_ITEMEXPANDED, IDC_PROG_CLASS, OnItemExpandedProgCls)
	ON_NOTIFY(TVN_ITEMEXPANDED, IDC_PROG, OnItemExpandedProgEdi)
	ON_NOTIFY(NM_SETFOCUS, IDC_PROG_OBJECT, OnSetFocusObject)
	ON_NOTIFY(NM_SETFOCUS, IDC_PROG_LOCAL, OnSetFocusLocal)
	ON_NOTIFY(NM_SETFOCUS, IDC_PROG_STRUC, OnSetFocusStruc)
	ON_NOTIFY(NM_SETFOCUS, IDC_PROG_CLASS, OnSetFocusClass)
	ON_NOTIFY(NM_SETFOCUS, IDC_PROG, OnSetFocusProg)
	ON_NOTIFY(TVN_SELCHANGED, IDC_PROG_OBJECT, OnSelChangedObject)
	ON_NOTIFY(TVN_SELCHANGED, IDC_PROG_LOCAL, OnSelChangedLocal)
	ON_NOTIFY(TVN_SELCHANGED, IDC_PROG_STRUC, OnSelChangedStruc)
	ON_NOTIFY(TVN_SELCHANGED, IDC_PROG_CLASS, OnSelChangedClass)
	ON_NOTIFY(TVN_SELCHANGED, IDC_PROG, OnSelChangedEdit)
	ON_NOTIFY(NM_DBLCLK, IDC_PROG_OBJECT, OnDblclkProgObject)
	ON_NOTIFY(NM_DBLCLK, IDC_PROG_LOCAL, OnDblclkProgLocal)
	ON_COMMAND(ID_FILE_SAVE2, OnFileSave)
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_TIMER()
	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_PROG_OBJECT, OnBeginLabelEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT, IDC_PROG_OBJECT, OnEndLabelEdit)
	ON_COMMAND(IDC_PROG_LOCK, OnProgLock)
	ON_UPDATE_COMMAND_UI(IDC_PROG_LOCK, OnUpdateProgLock)
	ON_COMMAND(IDC_PROG_OFF, OnProgOff)
	ON_UPDATE_COMMAND_UI(IDC_PROG_OFF, OnUpdateProgOff)
	ON_COMMAND(IDC_PROG_ICON, OnProgIcon)
	ON_COMMAND(IDC_PROG_CLIP, OnProgClip)
	ON_COMMAND(IDC_PROG_DEL, OnProgDel)
	ON_UPDATE_COMMAND_UI(IDC_PROG_REFER, OnUpdateProgRefer)
	ON_UPDATE_COMMAND_UI(IDC_PROG_DEF, OnUpdateProgDef)
	ON_COMMAND(IDC_PROG_DEF, OnProgDef)
	ON_EN_CHANGE(IDC_PROG_EDIT, OnChangeName)
	ON_NOTIFY(TVN_KEYDOWN, IDC_PROG, OnKeyDownProg)
	ON_COMMAND(IDC_PROG_REDO, OnProgRedo)
	ON_COMMAND(IDC_PROG_UNDO, OnProgUndo)
	ON_COMMAND(IDC_REF_DEF, OnRefDef)
	ON_COMMAND(IDC_REF_NEXT, OnRefNext)
	ON_COMMAND(IDC_REF_PREV, OnRefPrev)
	ON_EN_CHANGE(IDC_PROG_FIND, OnChangeFind)
	ON_COMMAND(IDC_PROG_NEXT, OnFindNext)
	ON_COMMAND(IDC_PROG_PREV, OnFindPrev)
	ON_COMMAND(IDC_PROG_EDIT2, OnProgEdit)
	ON_EN_CHANGE(IDC_PROG_TEXT, OnChangeProgText)
	ON_EN_CHANGE(IDC_PROG_REAL, OnChangeProgReal)
	ON_BN_CLICKED(IDC_PROG_LOGIC, OnProgLogic)
	ON_UPDATE_COMMAND_UI(IDC_PROG_UNDO, OnUpdateProgUndo)
	ON_UPDATE_COMMAND_UI(IDC_PROG_REDO, OnUpdateProgRedo)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_XY, OnUpdateEditiconXy)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_XY, OnUpdateEditmapXy)
	ON_COMMAND(IDC_EDITMAP_ARROW, OnEditmapArrow)
	ON_COMMAND(IDC_EDITMAP_BLOK, OnEditmapBlok)
	ON_COMMAND(IDC_EDITMAP_SWCX, OnEditmapSwcx)
	ON_COMMAND(IDC_EDITMAP_SWC1, OnEditmapSwc1)
	ON_COMMAND(IDC_EDITMAP_SWC2, OnEditmapSwc2)
	ON_COMMAND(IDC_EDITMAP_SWC3, OnEditmapSwc3)
	ON_COMMAND(IDC_EDITMAP_SWC4, OnEditmapSwc4)
	ON_COMMAND(IDC_EDITMAP_SWC5, OnEditmapSwc5)
	ON_COMMAND(IDC_EDITMAP_SWCN1, OnEditmapSwcn1)
	ON_COMMAND(IDC_EDITMAP_SWCN2, OnEditmapSwcn2)
	ON_COMMAND(IDC_EDITMAP_SWCN3, OnEditmapSwcn3)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWC1, OnUpdateEditmapSwc1)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWC2, OnUpdateEditmapSwc2)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWC3, OnUpdateEditmapSwc3)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWC4, OnUpdateEditmapSwc4)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWC5, OnUpdateEditmapSwc5)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWCN1, OnUpdateEditmapSwcn1)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWCN2, OnUpdateEditmapSwcn2)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWCN3, OnUpdateEditmapSwcn3)
	ON_UPDATE_COMMAND_UI(IDC_EDITMAP_SWCX, OnUpdateEditmapSwcx)
	ON_COMMAND(ID_PROGSTART, OnProgstart)
	ON_COMMAND(IDC_SPRITE_TEST, OnSpriteTest)
	ON_UPDATE_COMMAND_UI(IDC_EDITSPRITE_XY, OnUpdateEditspriteXy)
	ON_EN_CHANGE(IDC_EDITSPRITE_DELAY_EDIT, OnChangeSpriteDelay)
	ON_EN_CHANGE(IDC_EDITSPRITE_KROK_EDIT, OnChangeSpriteKrok)
	ON_UPDATE_COMMAND_UI(IDC_SPRITE_TEST, OnUpdateSpriteTest)
	ON_UPDATE_COMMAND_UI(IDC_HISTORY_NEXT, OnUpdateHistoryNext)
	ON_UPDATE_COMMAND_UI(IDC_HISTORY_PREV, OnUpdateHistoryPrev)
	ON_COMMAND(IDC_HISTORY_PREV, OnHistoryPrev)
	ON_COMMAND(IDC_HISTORY_NEXT, OnHistoryNext)
	ON_NOTIFY(NM_DBLCLK, IDC_PROG, OnDblclkProg)
	ON_WM_CLOSE()
	ON_COMMAND(IDC_EDITSOUND_PLAY, OnEditsoundPlay)
	ON_COMMAND(IDC_EDITSOUND_STOP, OnEditsoundStop)
	ON_COMMAND(IDC_EDITSOUND_RECORD, OnEditsoundRecord)
	ON_NOTIFY(TVN_BEGINRDRAG, IDC_PROG_OBJECT, OnBeginDragProgObj)
	ON_NOTIFY(TVN_BEGINRDRAG, IDC_PROG_LOCAL, OnBeginDragProgLoc)
	ON_NOTIFY(TVN_BEGINRDRAG, IDC_PROG_STRUC, OnBeginDragProgStr)
	ON_NOTIFY(TVN_BEGINRDRAG, IDC_PROG_CLASS, OnBeginDragProgCls)
	ON_NOTIFY(TVN_BEGINRDRAG, IDC_PROG, OnBeginDragProgEdi)
	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_PROG_LOCAL, OnBeginLabelEdit)
	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_PROG_CLASS, OnBeginLabelEdit)
	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_PROG, OnBeginLabelEdit)
	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_PROG_STRUC, OnBeginLabelEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT, IDC_PROG_STRUC, OnEndLabelEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT, IDC_PROG_LOCAL, OnEndLabelEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT, IDC_PROG_CLASS, OnEndLabelEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT, IDC_PROG, OnEndLabelEdit)
	ON_NOTIFY(TVN_KEYDOWN, IDC_PROG_CLASS, OnKeyDownProg)
	ON_NOTIFY(TVN_KEYDOWN, IDC_PROG_LOCAL, OnKeyDownProg)
	ON_NOTIFY(TVN_KEYDOWN, IDC_PROG_OBJECT, OnKeyDownProg)
	ON_NOTIFY(TVN_KEYDOWN, IDC_PROG_STRUC, OnKeyDownProg)
	ON_UPDATE_COMMAND_UI(IDC_EDITSOUND_PLAY, OnUpdateEditsoundPlay)
	ON_UPDATE_COMMAND_UI(IDC_EDITSOUND_RECORD, OnUpdateEditsoundRecord)
	ON_UPDATE_COMMAND_UI(IDC_EDITSOUND_STOP, OnUpdateEditsoundStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// diagnostika

#ifdef _DEBUG
void CProg::AssertValid() const
{
	CFormView::AssertValid();
}

void CProg::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////
// zmna velikosti okna

void CProg::OnSize(UINT nType, int cx, int cy) 
{
	ValidateRect(NULL);
	CFormView::OnSize(nType, cx, cy);

	ReSize();
	Invalidate(FALSE);		// zneplatnn celho okna
}

void CProg::ReSize()
{
	CRect rect;			// klientsk oblast celho okna
	CRect rect1;		// lev vertikln rozdlova
	CRect rect2;		// lev horizontln rozdlova
	CRect rect3;		// prav horizontln rozdlova
	CRect rect4;		// prav vertikln rozdlova
	CRect rectProg;		// pole editace a ikony
	CRect rectLocal;	// lokln objekty, nadpis
	CRect rectObject;	// globln objekty, nadpis
	CRect rectClass;	// struktury, nadpis
	CRect rectInter;	// tdy, nadpis

	GetClientRect(&rect);

// lev vertikln rozdlova
	rect1 = rect;
	rect1.left = (rect.right*LeftWidth+Scale/2)/Scale;
	if (rect1.left > rect.right - 2*SplitSize)
		rect1.left = rect.right - 2*SplitSize;
	if (rect1.left < 0) 
		rect1.left = 0;

	rect1.right = rect1.left + SplitSize;

	if (m_Split1.m_hWnd != NULL)
	{
		m_Split1.MoveWindow(&rect1,FALSE);
	}

// prav vertikln rozdlova
	rect4 = rect;
	rect4.left = rect.right - (rect.right*RightWidth+Scale/2)/Scale;
	if (rect4.left < rect1.right)
		rect4.left = rect1.right;
	if (rect4.left > rect.right - SplitSize) 
		rect4.left = rect.right - SplitSize;

	rect4.right = rect4.left + SplitSize;

	if (m_Split3.m_hWnd != NULL)
	{
		m_Split3.MoveWindow(&rect4,FALSE);
	}

// pole editace
	rectProg = rect;
	rectProg.top = 0;
	rectProg.left = rect1.right;
	rectProg.right = rect4.left;
	
	if (m_Edit.m_hWnd != NULL)
	{
		m_Edit.MoveWindow(&rectProg,FALSE);
	}

//	rectProg.bottom = rectProg.top + 30;
	if (m_ProgReal.m_hWnd != NULL)
	{
		m_ProgReal.MoveWindow(&rectProg,FALSE);
	}

	if (m_ProgText.m_hWnd != NULL)
	{
		m_ProgText.MoveWindow(&rectProg,FALSE);
	}

	if (m_ProgPic.m_hWnd != NULL)
	{
		m_ProgPic.MoveWindow(&rectProg,FALSE);
//		m_ProgPic.Invalidate(FALSE);
	}

	if (m_ProgMap.m_hWnd != NULL)
	{
		m_ProgMap.MoveWindow(&rectProg,FALSE);
//		m_ProgPic.Invalidate(FALSE);
	}

	if (m_ProgSound.m_hWnd != NULL)
	{
		m_ProgSound.MoveWindow(&rectProg,FALSE);
	}

	if (m_ProgMusic.m_hWnd != NULL)
	{
		m_ProgMusic.MoveWindow(&rectProg,FALSE);
	}

	if (m_ProgLogic.m_hWnd != NULL)
	{
		m_ProgLogic.MoveWindow(&rectProg,FALSE);
	}

	if (m_ProgDialog.m_hWnd != NULL)
	{
		m_ProgDialog.MoveWindow(&rectProg,FALSE);
	}

	if (m_ProgSprite.m_hWnd != NULL)
	{
		m_ProgSprite.MoveWindow(&rectProg,FALSE);
	}


// lev horizontln rozdlova
	rect2.left = 0;
	rect2.right = rect1.left;
	rect2.top = (rect.bottom*LeftHeight+Scale/2)/Scale;
	if (rect2.top > rect.bottom - SplitSize)
		rect2.top = rect.bottom - SplitSize;
	rect2.bottom = rect2.top + SplitSize;

	if (m_Split2.m_hWnd != NULL)
	{
		m_Split2.MoveWindow(&rect2,FALSE);
	}

// pole objekt
	rectObject.left = 0;
	rectObject.top = 15;
	rectObject.right = rect2.right;
	rectObject.bottom = rect2.top;
	if (m_Object.m_hWnd != NULL)
	{
		m_Object.MoveWindow(&rectObject,FALSE);
	}

	rectObject.bottom = rectObject.top;
	rectObject.top = 0;
	if (m_Nadpis1.m_hWnd != NULL)
	{
		m_Nadpis1.MoveWindow(&rectObject,FALSE);
	}

// pole loklnch objekt
	rectLocal = rect;
	rectLocal.right = rect2.right;
	rectLocal.top = rect2.bottom + 15;

	if (m_Local.m_hWnd != NULL)
	{
		m_Local.MoveWindow(&rectLocal,FALSE);
	}

	rectLocal.bottom = rectLocal.top;
	rectLocal.top = rect2.bottom;
	if (m_Nadpis2.m_hWnd != NULL)
	{
		m_Nadpis2.MoveWindow(&rectLocal,FALSE);
	}

// prav horizontln rozdlova
	rect3 = rect;
	rect3.left = rect4.right;
	rect3.top =	(rect.bottom*RightHeight+Scale/2)/Scale;
	if (rect3.top > rect.bottom - SplitSize)
		rect3.top = rect.bottom - SplitSize;
	rect3.bottom = rect3.top + SplitSize;

	if (m_Split4.m_hWnd != NULL)
	{
		m_Split4.MoveWindow(&rect3,FALSE);
	}

// pole struktur
	rectInter = rect;
	rectInter.bottom = rect3.top;
	rectInter.left = rect3.left;
	rectInter.top = 15;
	if (m_Struc.m_hWnd != NULL)
	{
		m_Struc.MoveWindow(&rectInter,FALSE);
	}

	rectInter.bottom = rectInter.top;
	rectInter.top = 0;
	if (m_Nadpis3.m_hWnd != NULL)
	{
		m_Nadpis3.MoveWindow(&rectInter,FALSE);
	}

// pole td
	rectClass = rect;
	rectClass.left = rect3.left;
	rectClass.top = rect3.bottom + 15;

	if (m_Class.m_hWnd != NULL)
	{
		m_Class.MoveWindow(&rectClass,FALSE);
	}

	rectClass.bottom = rectClass.top;
	rectClass.top = rect3.bottom;
	if (m_Nadpis4.m_hWnd != NULL)
	{
		m_Nadpis4.MoveWindow(&rectClass,FALSE);
	}

// oprava Z poad oken
	if (m_Nadpis1.m_hWnd != NULL && m_Nadpis2.m_hWnd != NULL && m_Split2.m_hWnd != NULL)
	{
		m_Nadpis2.SetWindowPos(&m_Nadpis1,0,0,0,0,
			SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOREDRAW | SWP_NOSIZE);
		m_Split2.SetWindowPos(&m_Nadpis2,0,0,0,0,
			SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOREDRAW | SWP_NOSIZE);
	}

	if (m_Nadpis3.m_hWnd != NULL && m_Nadpis4.m_hWnd != NULL && m_Split4.m_hWnd != NULL)
	{
		m_Nadpis4.SetWindowPos(&m_Nadpis3,0,0,0,0,
			SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOREDRAW | SWP_NOSIZE);
		m_Split4.SetWindowPos(&m_Nadpis4,0,0,0,0,
			SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOREDRAW | SWP_NOSIZE);
	}
}

/////////////////////////////////////////////////////////////////////////////
// aktualizace palet pi pekreslen okna

void CProg::OnDraw(CDC* pDC) 
{
	HPALETTE OldPal = ::SelectPalette(pDC->m_hDC, StdPalette, FALSE);
	::RealizePalette(pDC->m_hDC);
	::SelectPalette(pDC->m_hDC,OldPal,TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// zaznamenn zmny v rozvinut struktury stromu

void CProg::OnItemExpandedProgObj(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnItemExpandedProg(pNMHDR, pResult, BufObjID);
}

void CProg::OnItemExpandedProgLoc(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnItemExpandedProg(pNMHDR, pResult, BufLocID);
}

void CProg::OnItemExpandedProgStr(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnItemExpandedProg(pNMHDR, pResult, BufStrID);
}

void CProg::OnItemExpandedProgCls(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnItemExpandedProg(pNMHDR, pResult, BufClsID);
}

void CProg::OnItemExpandedProgEdi(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnItemExpandedProg(pNMHDR, pResult, BufEdiID);
}

void CProg::OnItemExpandedProg(NMHDR* pNMHDR, LRESULT* pResult, int buff) 
{
	NM_TREEVIEW* pnm = (NM_TREEVIEW*)pNMHDR;
	int index;

	if ((pnm->itemNew.mask & TVIF_STATE) != 0)
	{	
		index = m_Buf[buff].SrcItem(pnm->itemNew.hItem);
		if (index != -1)
		{
			if ((pnm->itemNew.state & TVIS_EXPANDED) != 0)
				m_Buf[buff].m_Items[index].param |= PR_EXP;
			else
				m_Buf[buff].m_Items[index].param &= ~PR_EXP;
		}
	}
	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////
// zmna aktivn poloky nebo zmna okna

void CProg::OnSelChangedObject(NMHDR* pNMHDR, LRESULT* pResult) 
{
	DispName();
	RefSelChange(BufObjID, BufClsID);
	RefSelChange(BufObjID, BufStrID);
	*pResult = 0;
}

void CProg::OnSelChangedLocal(NMHDR* pNMHDR, LRESULT* pResult) 
{
	DispName();
	RefSelChange(BufLocID, BufClsID);
	RefSelChange(BufLocID, BufStrID);
	*pResult = 0;
}

void CProg::OnSelChangedStruc(NMHDR* pNMHDR, LRESULT* pResult) 
{
	DispName();
	*pResult = 0;
}

void CProg::OnSelChangedClass(NMHDR* pNMHDR, LRESULT* pResult) 
{
	DispName();
	RefSelChange(BufClsID, BufStrID);
	*pResult = 0;
}

void CProg::OnSelChangedEdit(NMHDR* pNMHDR, LRESULT* pResult) 
{
	DispName();
	RefSelChange(BufEdiID, BufObjID);
	RefSelChange(BufEdiID, BufLocID);
	RefSelChange(BufEdiID, BufStrID);
	*pResult = 0;
}

void CProg::RefSelChange(int AktBuf, int RefBuf)
{
// probh zmna aktivnho prvku programem - nic neprovdt
	if (m_SelChange)
		return;

// lokln promnn
	CProgBuf* buf = &(m_Buf[AktBuf]);				// adresa aktivnho bufferu
	PROGITEM* item;									// adresa aktivn poloky

// nalezen aktivn poloky
	int itemN = m_Buf[AktBuf].GetAkt();			// nalezen aktivn poloky

// je njak poloka aktivn ?
	if (itemN != -1)								// je vybran poloka ?
	{
		item = &(buf->m_Items[itemN]);				// adresa aktivn poloky

// je odkaz na referenn buffer ?
		if ((item->typ == RefBuf) && (item->refer != -1)) // je odkaz na buffer ?

// je platn odkaz - nastaven aktivn poloky
			m_Buf[RefBuf].SetAkt(item->refer);		// nastaven aktivn poloky

// jinak vypnut kurzoru
		else
			if (RefBuf != BufStrID)
				m_Buf[RefBuf].SetAkt(-1);			// vypnut kurzoru
	}
}


void CProg::OnSetFocusObject(NMHDR* pNMHDR, LRESULT* pResult) 
{
	m_AktBufID = BufObjID;
//	m_AktTree = &m_Object;
	DispName();
}

void CProg::OnSetFocusLocal(NMHDR* pNMHDR, LRESULT* pResult) 
{
	m_AktBufID = BufLocID;
//	m_AktTree = &m_Local;
	DispName();
}


void CProg::OnSetFocusStruc(NMHDR* pNMHDR, LRESULT* pResult) 
{
	m_AktBufID = BufStrID;
//	m_AktTree = &m_Struc;
	DispName();
}

void CProg::OnSetFocusClass(NMHDR* pNMHDR, LRESULT* pResult) 
{
	m_AktBufID = BufClsID;
//	m_AktTree = &m_Class;
	DispName();
}

void CProg::OnSetFocusProg(NMHDR* pNMHDR, LRESULT* pResult) 
{
	m_AktBufID = BufEdiID;
//	m_AktTree = &m_Edit;
	DispName();
}

BOOL CProg::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN)
		{
			CWnd* wnd = GetFocus();
			if (wnd != NULL)
			{
				if (m_Editing)
				{
					::SendMessage(m_Buf[m_AktBufID].m_Tree->m_hWnd, TVM_ENDEDITLABELNOW, FALSE, 0);
					return TRUE;
				}
				else
				{
					if (wnd->m_hWnd == m_Object.m_hWnd)
					{
						DblclkObject(m_BufObj.SrcItem(m_Object.GetSelectedItem()));
						return TRUE;
					}

					if (wnd->m_hWnd == m_Local.m_hWnd)
					{
						DblclkLocal(m_BufLoc.SrcItem(m_Local.GetSelectedItem()));
						return TRUE;
					}

					if (wnd->m_hWnd == m_Edit.m_hWnd)
					{
						DblclkProg(m_BufEdi.SrcItem(m_Edit.GetSelectedItem()));
						return TRUE;
					}
				}
			}
		}

		if (m_Editing)
			if ((pMsg->wParam == VK_UP) || 
				(pMsg->wParam == VK_DOWN) || 
				(pMsg->wParam == VK_PRIOR) || 
				(pMsg->wParam == VK_NEXT) ||
				(pMsg->wParam == VK_ESCAPE))
			{
				CWnd* wnd = GetFocus();
				if (wnd != NULL)
				{
					::SendMessage(m_Buf[m_AktBufID].m_Tree->m_hWnd, TVM_ENDEDITLABELNOW, FALSE, 0);
					if (pMsg->wParam != VK_ESCAPE)
					{
						::SendMessage(m_Buf[m_AktBufID].m_Tree->m_hWnd, WM_KEYDOWN, pMsg->wParam, pMsg->lParam);
						::PostMessage(m_Buf[m_AktBufID].m_Tree->m_hWnd, TVM_EDITLABEL, 0, (LPARAM)m_Buf[m_AktBufID].m_Tree->GetSelectedItem());
					}
					return TRUE;
				}
			}
	}
	
	return CFormView::PreTranslateMessage(pMsg);
}

/////////////////////////////////////////////////////////////////////////////
// dvojklik my

void CProg::OnDblclkProgObject(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UINT		nFlags;
	HTREEITEM	hItem;
	int 		item;
	CPoint		pt;
	
	::GetCursorPos(&pt);
	m_Object.ScreenToClient(&pt);
	hItem = m_Object.HitTest(pt, &nFlags);
	item = m_BufObj.SrcItem(hItem); 

	DblclkObject(item);

//	m_AktBufID = BufEdiID;

	*pResult = 0;
}


void CProg::DblclkObject(int item)
{
	int 		i;
	int item2 = item;

	if ((item < 0) || (item >= m_BufObj.m_Num))
		return;


	m_SelChange = TRUE;					// probh nastavovn poloky programem

	if (m_EditBufN == BufEdiID)
	{
		m_EditItem = m_BufEdi.m_First - 1;
	}

	PushEditHist();							// schova historie editace

	m_Object.SelectItem(m_BufObj.m_Items[item].htree);
	CProgBuf* buf = &(m_BufLoc);

	if ((item < m_BufObj.m_Num) &&
		(m_BufObj.m_Items[item].data == BufLocID))
	{
		i = m_BufObj.m_Items[item].index;
	}
	else
	{
		i = buf->m_Num;
	}

	buf->SetFirst(i);

	item = i;
	buf = &(m_BufEdi);
	if ((item >= 0) && (item < m_BufLoc.m_Num))
	{
		i = m_BufLoc.m_Items[item].index;
		buf->SetFirst(i);
	}
	else
	{
		buf->SetFirst(buf->m_Num);
	}

	if (item2 < m_BufObj.m_Num)
	{
		m_EditItem = m_BufObj.m_Items[item2].index;
		SetEditMode(m_BufObj.m_Items[item2].model);
	}

	AktAllDef();								// aktualizace defininch ukazatel

	if (m_EditBufN == BufEdiID)
	{
		m_EditItem = m_BufEdi.m_First - 1;
	}

	if ((m_EditHistNum == 1) &&
		(m_EditHistBuf[0] == m_EditBufN) &&
		(m_EditHistBuf[0] == BufEdiID) &&
		(m_EditHistItem[0] == m_EditItem) &&
		(m_EditHistItem[0] == 0))
	{
		m_EditHistNum = 0;
		m_EditHistAkt = 0;
	}

	m_SelChange = FALSE;
}

void CProg::OnDblclkProg(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UINT		nFlags;
	HTREEITEM	hItem;
	int 		item;
	CPoint		pt;
	
	::GetCursorPos(&pt);
	m_Edit.ScreenToClient(&pt);
	hItem = m_Edit.HitTest(pt, &nFlags);
	item = m_BufEdi.SrcItem(hItem); 

	m_SelItem = item;

	if (m_SelTimer == 0)
	{
		m_SelTimer = SetTimer(SELTIMERID, 70,NULL); // sputn asovae
	}
	
	*pResult = 0;
}

void CProg::DblclkProg(int item)
{
	if ((item < 0) || (item >= m_BufEdi.m_Num))
		return;

	int buf = m_BufEdi.m_Items[item].typ;
	item = m_BufEdi.m_Items[item].refer;

	if (buf == BufObjID)
	{
		DblclkObject(item);
	}

	if (buf == BufLocID)
	{
		DblclkLocal(item);
	}
}

void CProg::OnDblclkProgLocal(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UINT		nFlags;
	HTREEITEM	hItem;
	int 		item;
	CPoint		pt;
	
	::GetCursorPos(&pt);
	m_Local.ScreenToClient(&pt);
	hItem = m_Local.HitTest(pt, &nFlags);
	item = m_BufLoc.SrcItem(hItem); 

	DblclkLocal(item);
	
	*pResult = 0;
}

void CProg::DblclkLocal(int item)
{
	int 		i;
	if ((item < 0) || (item >= m_BufLoc.m_Num))
		return;

	m_SelChange = TRUE;					// probh nastavovn poloky programem

	if (m_EditBufN == BufEdiID)
	{
		m_EditItem = m_BufEdi.m_First - 1;
	}

	PushEditHist();								// schova historie editace

	m_Local.SelectItem(m_BufLoc.m_Items[item].htree);
	CProgBuf*	buf = &(m_BufEdi);
	i = m_BufLoc.m_Items[item].index;
	buf->SetFirst(i);
	m_Local.SelectItem(m_BufLoc.m_Items[item].htree);
//	m_EditItem = item;

	m_EditItem = m_BufLoc.m_Items[item].index;
	SetEditMode(m_BufLoc.m_Items[item].model);

	AktAllDef();								// aktualizace defininch ukazatel

	if (m_EditBufN == BufEdiID)
	{
		m_EditItem = m_BufEdi.m_First - 1;
	}

	m_SelChange = FALSE;
}


void CProg::SetEditMode(int model)
{
	CString txt;

	m_FilDat = TRUE;							// pznak plnn dat

	m_ProgSprite.EndTest();

	switch (model)
	{
	case TYP_FUNC:
		m_EditBufN = BufEdiID;
		m_Edit.ShowWindow(SW_SHOW);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	case TYP_REAL:
	case TYP_LIST_INDEX:
	case TYP_LIST_AUTO:
//	case TYP_SPR_REAL:
		m_EditBufN = BufNumID;
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_SHOW);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		txt.Format(_T("%.12lG"),m_Real.Get(m_EditItem));
		m_ProgReal.SetWindowText(txt);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	case TYP_BOOL:
//	case TYP_SPR_BOOL:
		m_EditBufN = BufLogID;
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_SHOW);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		m_ProgLogic.SetCheck(m_Bool.Get(m_EditItem) ? 1 : 0);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	case TYP_TEXT:
		m_EditBufN = BufTxtID;
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_SHOW);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		m_ProgText.SetWindowText(m_Text.Get(m_EditItem));
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	case TYP_PIC:
	case TYP_NONE:
		m_EditBufN = BufPicID;
		m_ProgPic.BegEdit(m_EditItem);
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_SHOW);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),TRUE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_SHOW);
		break;
	case TYP_SND:
		m_EditBufN = BufSndID;
		m_ProgSound.BegEdit(m_EditItem);
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_SHOW);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),TRUE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	case TYP_MUS:
		m_EditBufN = BufEdiID;
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_SHOW);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	case TYP_MAP:
		m_EditBufN = BufMapID;
		m_ProgMap.BegEdit(m_EditItem);
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_SHOW);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),TRUE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	case TYP_DIALOG:
		m_EditBufN = BufEdiID;
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_SHOW);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	case TYP_SPRITE:
		m_EditBufN = BufSprID;
		m_ProgSprite.BegEdit(m_EditItem);
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_SHOW);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),TRUE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
		break;
	default:
		m_EditBufN = BufEdiID;
		m_Edit.ShowWindow(SW_HIDE);
		m_ProgPic.ShowWindow(SW_HIDE);
		m_ProgReal.ShowWindow(SW_HIDE);
		m_ProgLogic.ShowWindow(SW_HIDE);
		m_ProgText.ShowWindow(SW_HIDE);
		m_ProgSound.ShowWindow(SW_HIDE);
		m_ProgMusic.ShowWindow(SW_HIDE);
		m_ProgMap.ShowWindow(SW_HIDE);
		m_ProgBack.ShowWindow(SW_HIDE);
		m_ProgDialog.ShowWindow(SW_HIDE);
		m_ProgSprite.ShowWindow(SW_HIDE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndIconBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndMapBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSpriteBar),FALSE,TRUE);
		MainFrame->ShowControlBar(&(MainFrame->m_wndSoundBar),FALSE,TRUE);
//		MainFrame->m_wndIconBar.ShowWindow(SW_HIDE);
	}
	MainFrame->RecalcLayout();

	m_FilDat = FALSE;							// konec plnn dat
}

void CProg::OnChangeProgText() 
{
	if (m_FilDat) return;			// je plnn dat

	CString txt;

	m_ProgText.GetWindowText(txt);
	if ((m_EditItem >= 0) && (m_EditBufN == BufTxtID))
		m_Text.Set(m_EditItem, txt);
}

void CProg::OnChangeProgReal() 
{
	if (m_FilDat) return;			// je plnn dat

	CString txt;
	double num;
	int pocet;

	m_ProgReal.GetWindowText(txt);
	if ((m_EditItem >= 0) && (m_EditBufN == BufNumID))
	{
#ifdef _UNICODE
		pocet = swscanf(txt,_T("%lG"),&num);
#else
		pocet = sscanf(txt,_T("%lG"),&num);
#endif
		if (pocet)
			m_Real.Set(m_EditItem, num);
	}
}

void CProg::OnProgLogic() 
{
	if (m_FilDat) return;			// je plnn dat
	
	if ((m_EditItem >= 0) && (m_EditBufN == BufLogID))
	{
		m_Bool.Set(m_EditItem, m_ProgLogic.GetCheck());
	}
}

void CProg::OnProgRedo() 
{
	if (m_EditBufN == BufPicID)
//		(m_AktBufID == BufEdiID))
	{
		m_ProgPic.Redo();
	}
}

void CProg::OnProgUndo() 
{
	if (m_EditBufN == BufPicID)
//		(m_AktBufID == BufEdiID))
	{
		m_ProgPic.Undo();
	}
}


void CProg::OnUpdateProgUndo(CCmdUI* pCmdUI) 
{
	if (((m_ProgPic.m_UndoItem != m_ProgPic.m_Item) &&
		(m_ProgPic.m_UndoItem != -1)) ||
		(m_ProgPic.m_UndoAkt > 0))
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);	
}


void CProg::OnUpdateProgRedo(CCmdUI* pCmdUI) 
{
	if (m_ProgPic.m_UndoAkt < m_ProgPic.m_UndoNum-1)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);	
}


void CProg::OnUpdateEditiconXy(CCmdUI* pCmdUI) 
{
// lokln promnn
	int x,y;					// aktuln souadnice
	TCHAR buff[50];				// buffer k dekdovn textu sla
	CStatic* txt;				// prvek zobrazenho textu

// pprava aktulnch souadnic
	x = m_ProgPic.m_X;			// aktuln souadnice X
	y = m_ProgPic.m_Y;			// aktuln souadnice Y
	if ((x < 0) || 
		(x >= m_ProgPic.m_Width) ||
		(y < 0) ||
		(y >= m_ProgPic.m_Height))
	{
		x = -1;
		y = -1;
	}

// kontrola, zda se daje zmnily
	if ((x == m_OldEditX) &&
		(y == m_OldEditY))
		return;

// schova novch souadnic
	m_OldEditX = x;
	m_OldEditY = y;

	y = m_ProgPic.m_Height - 1 - y;

// pprava textu
	if (x == -1)
		buff[0] = 0;
	else
		wsprintf(buff, _T("%d,%d"), x, y);

// nalezen handle prvku
	txt = (CStatic*)(MainFrame->		// nalezen okna textu
			m_wndIconBar.GetDlgItem(IDC_EDITICON_XY));

// nastaven textu
	if (txt != NULL)					// bylo okno nalezeno ?
	{
		txt->SetWindowText(buff);		// nastaven textu potu referenc
	}
}


void CProg::OnUpdateEditmapXy(CCmdUI* pCmdUI) 
{
// lokln promnn
	int x,y;					// aktuln souadnice
	TCHAR buff[50];				// buffer k dekdovn textu sla
	CStatic* txt;				// prvek zobrazenho textu

// pprava aktulnch souadnic
	x = m_ProgMap.m_X;			// aktuln souadnice X
	y = m_ProgMap.m_Y;			// aktuln souadnice Y

// kontrola, zda se daje zmnily
	if ((x == m_OldEditMapX) &&
		(y == m_OldEditMapY))
		return;

// schova novch souadnic
	m_OldEditMapX = x;
	m_OldEditMapY = y;

// pprava textu
	if (x == -1)
		buff[0] = 0;
	else
		wsprintf(buff, _T("%d,%d"), x, y);

// nalezen handle prvku
	txt = (CStatic*)(MainFrame->		// nalezen okna textu
			m_wndMapBar.GetDlgItem(IDC_EDITMAP_XY));

// nastaven textu
	if (txt != NULL)					// bylo okno nalezeno ?
	{
		txt->SetWindowText(buff);		// nastaven textu potu referenc
	}
}


void CProg::OnEditmapArrow() 
{
	
}

void CProg::OnEditmapBlok() 
{
	
}

void CProg::OnEditmapSwcx() 
	{ m_ProgMap.SetEditMode(0); }

void CProg::OnEditmapSwc1() 
	{ m_ProgMap.SetEditMode(MAP_FLAG1); }

void CProg::OnEditmapSwc2() 
	{ m_ProgMap.SetEditMode(MAP_FLAG2); }

void CProg::OnEditmapSwc3() 
	{ m_ProgMap.SetEditMode(MAP_FLAG3); }

void CProg::OnEditmapSwc4() 
	{ m_ProgMap.SetEditMode(MAP_FLAG4); }

void CProg::OnEditmapSwc5() 
	{ m_ProgMap.SetEditMode(MAP_FLAG5); }

void CProg::OnEditmapSwcn1() 
	{ m_ProgMap.SetEditMode(MAP_VALUE1_MASK); }

void CProg::OnEditmapSwcn2() 
	{ m_ProgMap.SetEditMode(MAP_VALUE2_MASK); }

void CProg::OnEditmapSwcn3() 
	{ m_ProgMap.SetEditMode(MAP_VALUE3_MASK); }

void CProg::OnUpdateEditmapSwcx(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, 0); }

void CProg::OnUpdateEditmapSwc1(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, MAP_FLAG1); }

void CProg::OnUpdateEditmapSwc2(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, MAP_FLAG2); }

void CProg::OnUpdateEditmapSwc3(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, MAP_FLAG3); }

void CProg::OnUpdateEditmapSwc4(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, MAP_FLAG4); }

void CProg::OnUpdateEditmapSwc5(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, MAP_FLAG5); }

void CProg::OnUpdateEditmapSwcn1(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, MAP_VALUE1_MASK); }

void CProg::OnUpdateEditmapSwcn2(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, MAP_VALUE2_MASK); }

void CProg::OnUpdateEditmapSwcn3(CCmdUI* pCmdUI) 
	{ m_ProgMap.UpdateEditMode(pCmdUI, MAP_VALUE3_MASK); }

void CProg::OnProgstart() 
{
	CExec* exec;

	int i,j;
	j = -1;
	for (i = 0; i < MAXEXEC; i++)
	{
		if (Exec[i] == NULL)
		{
			j = i;
			break;
		}
	}
	if (j == -1) return;

	exec = new CExec(this);
	Exec[j] = exec;

	exec->Create(CExec::IDD, GetDesktopWindow());
	exec->SetIcon(::LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MUSIC)), FALSE);
	exec->CenterWindow(this);
	exec->ShowWindow(SW_SHOW);
}

void CProg::OnSpriteTest() 
{
	if (m_ProgSprite.m_TestMode)			// je testovac md ?
	{
		m_ProgSprite.EndTest();				// ukonen testovacho mdu
	}
	else
	{
		m_ProgSprite.BegTest();				// zahjen testovacho mdu
	}
}

void CProg::OnUpdateSpriteTest(CCmdUI* pCmdUI) 
{
	if (m_ProgSprite.m_TestMode)			// je testovac md ?
	{
		pCmdUI->SetCheck(1);				// je testovac md
	}
	else
	{
		pCmdUI->SetCheck(0);				// nen testovac md
	}	
}

void CProg::OnUpdateEditspriteXy(CCmdUI* pCmdUI) 
{
// lokln promnn
	int x,y;					// aktuln souadnice
	TCHAR buff[50];				// buffer k dekdovn textu sla
	CStatic* txt;				// prvek zobrazenho textu

// pprava aktulnch souadnic
	x = m_ProgSprite.m_X;			// aktuln souadnice X
	y = m_ProgSprite.m_Y;			// aktuln souadnice Y

// kontrola, zda se daje zmnily
	if ((x == m_OldEditSpriteX) &&
		(y == m_OldEditSpriteY))
		return;

// schova novch souadnic
	m_OldEditSpriteX = x;
	m_OldEditSpriteY = y;

// pprava textu
	if (x == -1)
		buff[0] = 0;
	else
		wsprintf(buff, _T("%d,%d"), x, y);

// nalezen handle prvku
	txt = (CStatic*)(MainFrame->		// nalezen okna textu
			m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_XY));

// nastaven textu
	if (txt != NULL)					// bylo okno nalezeno ?
	{
		txt->SetWindowText(buff);		// nastaven textu potu referenc
	}
}

/////////////////////////////////////////////////////////////////////////////
// zmna prodlevy v editoru sprajt

void CProg::OnChangeSpriteDelay() 
{
// test, zda probh plnn editoru jmna programem
	if (m_ProgSprite.m_FilEdit) return;	// probh plnn programem - konec

// lokln promnn, nalezen aktuln poloky
	CString txt = _T("");						// buffer textu
	int num = m_Sprite.Get(m_ProgSprite.m_Index)->delay; // naten daj
	CEdit* edit;								// editor textu

// pprava editoru
	edit = (CEdit*)(MainFrame->
		m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_DELAY_EDIT));

// naten textu z editoru
	if (edit != NULL)
	{
		edit->GetWindowText(txt);			// naten textu do bufferu

// naten zadanho sla
#ifdef	_UNICODE
		swscanf(txt, _T("%d"), &num);
#else
		sscanf(txt, _T("%d"), &num);
#endif
	}

	if (num < 1)
		num = 1;
	if (num > MAXSPRITEDELAY)
		num = MAXSPRITEDELAY;

	m_Sprite.Get(m_ProgSprite.m_Index)->delay = num;

// oprava konstanty asovae
	num = (num + 26)/55;	// konstanta asovae
	if (num <= 0)
		num = 1;
	m_ProgSprite.m_Timer = num;

}


/////////////////////////////////////////////////////////////////////////////
// zmna kroku v editoru sprajt

void CProg::OnChangeSpriteKrok() 
{
// test, zda probh plnn editoru jmna programem
	if (m_ProgSprite.m_FilEdit) return;	// probh plnn programem - konec

// lokln promnn, nalezen aktuln poloky
	CString txt = _T("");						// buffer textu
	int num = m_Sprite.Get(m_ProgSprite.m_Index)->krok;		// naten daj
	CEdit* edit;								// editor textu

// pprava editoru
	edit = (CEdit*)(MainFrame->
		m_wndSpriteBar.GetDlgItem(IDC_EDITSPRITE_KROK_EDIT));

// naten textu z editoru
	if (edit != NULL)
	{
		edit->GetWindowText(txt);			// naten textu do bufferu

// naten zadanho sla
#ifdef	_UNICODE
		swscanf(txt, _T("%d"), &num);
#else
		sscanf(txt, _T("%d"), &num);
#endif
	}

	if (num < 1)
		num = 1;
	if (num > MAXSPRITEKROK)
		num = MAXSPRITEKROK;

	m_Sprite.Get(m_ProgSprite.m_Index)->krok = num;
}

/////////////////////////////////////////////////////////////////////////////
// obnoven ikon ve stromech

void CProg::RefreshIcon()
{
// kontrola platnosti operace
	if (m_Icon.GetSize() == 0)
		return;

// vygenerovn seznam obrzk
	if (ScreenWidth > 700)
	{
		m_Ico32->DeleteImageList();
		delete m_Ico32;
		m_State32->DeleteImageList();
		delete m_State32;
		m_Ico32 = m_Icon.GenerList();
		m_State32 = m_BufState32.GenerList();
	}

	if (ScreenWidth <= 900)
	{
		m_Ico16->DeleteImageList();
		delete m_Ico16;
		m_State16->DeleteImageList();
		delete m_State16;
		m_Ico16 = m_Icon.GenerList16();
		m_State16 = m_BufState32.GenerList16();
	}

// nastaven seznam ikon pro stromy
	if (ScreenWidth > 900)
	{
		m_Object.SetImageList(m_Ico32, TVSIL_NORMAL);
		m_Local.SetImageList(m_Ico32, TVSIL_NORMAL);
		m_Struc.SetImageList(m_Ico32, TVSIL_NORMAL);
		m_Class.SetImageList(m_Ico32, TVSIL_NORMAL);
		m_Edit.SetImageList(m_Ico32, TVSIL_NORMAL);

		m_Object.SetImageList(m_State32, TVSIL_STATE);
		m_Local.SetImageList(m_State32, TVSIL_STATE);
		m_Struc.SetImageList(m_State32, TVSIL_STATE);
		m_Class.SetImageList(m_State32, TVSIL_STATE);
		m_Edit.SetImageList(m_State32, TVSIL_STATE);
	}
	else
	{
		m_Object.SetImageList(m_Ico16, TVSIL_NORMAL);
		m_Local.SetImageList(m_Ico16, TVSIL_NORMAL);
		m_Struc.SetImageList(m_Ico16, TVSIL_NORMAL);
		m_Class.SetImageList(m_Ico16, TVSIL_NORMAL);

		m_Object.SetImageList(m_State16, TVSIL_STATE);
		m_Local.SetImageList(m_State16, TVSIL_STATE);
		m_Struc.SetImageList(m_State16, TVSIL_STATE);
		m_Class.SetImageList(m_State16, TVSIL_STATE);

		if (ScreenWidth > 700)
		{
			m_Edit.SetImageList(m_Ico32, TVSIL_NORMAL);
			m_Edit.SetImageList(m_State32, TVSIL_STATE);
		}
		else
		{
			m_Edit.SetImageList(m_Ico16, TVSIL_NORMAL);
			m_Edit.SetImageList(m_State16, TVSIL_STATE);
		}
	}

// pekreslen oken
	m_Object.Invalidate();
	m_Local.Invalidate();
	m_Struc.Invalidate();
	m_Class.Invalidate();
	m_Edit.Invalidate();
}


//void CProg::OnEditspriteParam() 
//{
//	m_ProgSprite.SetSpriteParam();	
//}



/////////////////////////////////////////////////////////////////////////////
// obsluha historie editace

void CProg::OnUpdateHistoryPrev(CCmdUI* pCmdUI) 
{
	if (m_EditHistAkt > 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);	
}

void CProg::OnUpdateHistoryNext(CCmdUI* pCmdUI) 
{
	if (m_EditHistAkt < m_EditHistNum - 1)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);	
}

void CProg::PushEditHist()
{
// probh navracen historie - neukldat
	if (m_EditHistFil)
		return;

// nen jet nic editovno
	if ((m_EditHistNum == 0) || (m_EditItem == 1))
	{
		m_EditItem = 0;
		m_EditBufN = BufEdiID;
	}

// pokud je to stejn poloka, nic se nedje
	if ((m_EditHistAkt > 0) &&
		(m_EditHistBuf[m_EditHistAkt-1] == m_EditBufN) &&
		(m_EditHistItem[m_EditHistAkt-1] == m_EditItem) &&
		(m_EditItem != -2))
		return;

// zruen poloek za aktivnm ukazatelem
	m_EditHistNum = m_EditHistAkt + 1;

// zvten bufferu
	if (m_EditHistNum > m_EditHistMax)
	{
		m_EditHistMax += 100;
		Aloc(m_EditHistBuf, m_EditHistMax);
		Aloc(m_EditHistItem, m_EditHistMax);
		Aloc(m_EditHistSpriteIndex, m_EditHistMax);
		Aloc(m_EditHistSpriteX, m_EditHistMax);
		Aloc(m_EditHistSpriteY, m_EditHistMax);
		Aloc(m_EditHistProg, m_EditHistMax);
	}

// schova aktivn poloky do bufferu
	m_EditHistBuf[m_EditHistAkt] = m_EditBufN;		// slo bufferu
	m_EditHistItem[m_EditHistAkt] = m_EditItem;		// editovan prvek
	m_EditHistSpriteIndex[m_EditHistAkt] = m_ProgSprite.m_Index;
	m_EditHistSpriteX[m_EditHistAkt] = m_ProgSprite.m_X;
	m_EditHistSpriteY[m_EditHistAkt] = m_ProgSprite.m_Y;
	m_EditHistProg[m_EditHistAkt] = m_BufEdi.GetAkt();

// zven ukazatele
	m_EditHistAkt++;
}

void CProg::PopEditHist()
{
// kontrola, zda je co navracet
	if (m_EditHistAkt >= m_EditHistNum)
		return;

// lokln promnn
	int index = -1;
	int buf = m_EditHistBuf[m_EditHistAkt];
	int item = m_EditHistItem[m_EditHistAkt];

// nalezen editovanho prvku v loklnch objektech
	index = m_BufLoc.SrcDat(buf, item);

// nastaven poloky v loklnm bufferu
	if (index >= 0)
	{
		if (buf == BufEdiID)
		{
			index = m_BufObj.SrcDat(BufLocID, index);
			if (index >= 0)
			{
				m_EditHistFil = TRUE;					// probh navracen historie
				DblclkObject(index);
				m_EditHistFil = FALSE;					// konec navracen historie
				m_BufEdi.SetFocus();
				m_BufEdi.SetAkt(m_EditHistProg[m_EditHistAkt]);
				return;
			}
		}
		else
		{
			m_EditHistFil = TRUE;					// probh navracen historie
			DblclkLocal(index);
			m_EditHistFil = FALSE;					// konec navracen historie
			return;
		}
	}

// nalezen editovanho prvku v globlnch objektech
	index = m_BufObj.SrcDat(buf, item);

// nastaven poloky v globlnm bufferu
	if (index >= 0)
	{
		m_EditHistFil = TRUE;						// probh navracen historie
		DblclkObject(index);
		m_EditHistFil = FALSE;						// konec navracen historie
		m_BufEdi.SetFocus();
		m_BufEdi.SetAkt(m_EditHistProg[m_EditHistAkt]);
		return;
	}

// nastaven ikony v editoru sprajt
	if (item == -2)
	{
		m_ProgSprite.m_Index = m_EditHistSpriteIndex[m_EditHistAkt];
		m_ProgSprite.m_X = m_EditHistSpriteX[m_EditHistAkt];
		m_ProgSprite.m_Y = m_EditHistSpriteY[m_EditHistAkt];
		m_EditItem = -2;
		SetEditMode(TYP_PIC);
		AktAllDef();
	}

// editace ikony
	if (buf == BufPicID)
	{
		m_EditItem = item;
		SetEditMode(TYP_PIC);
	}
}

void CProg::OnHistoryPrev() 
{
// kontrola, zda je co navracet
	if (m_EditHistAkt == 0)
		return;

// schova aktulnho stavu, je-li na konci
	if (m_EditHistAkt == m_EditHistNum)
	{
		int OldAkt = m_EditHistAkt;
		PushEditHist();
		m_EditHistAkt = OldAkt;
	}

// posun ukazatele v bufferu
	m_EditHistAkt--;

// obnoven poloky
	PopEditHist();
}

void CProg::OnHistoryNext() 
{
// kontrola, zda je co navracet
	if (m_EditHistAkt >= m_EditHistNum - 1)
		return;

// posun ukazatele
	m_EditHistAkt++;

// obnoven poloky
	PopEditHist();
}


void CProg::OnClose() 
{
	if (m_SelTimer)						// je asova ?
	{
		KillTimer(m_SelTimer);			// zruen asovae
		m_SelTimer = 0;
	}
	
	CFormView::OnClose();
}

/////////////////////////////////////////////////////////////////////////////
// obsluha asovae (nap. pro pekreslen okna pi taen pedlu)

void CProg::OnTimer(UINT nIDEvent) 
{
// asova taen
	if (nIDEvent == 20)
		OnTrackTimer();

	if (nIDEvent == SELTIMERID)
	{
		KillTimer(m_SelTimer);			// zruen asovae
		m_SelTimer = 0;
		int item = m_SelItem;
		m_SelItem = -1;
		DblclkProg(item);
	}

	CFormView::OnTimer(nIDEvent);			// pokraovn pvodn obsluhou asovae
}


void CProg::OnEditsoundPlay() 
{
	m_ProgSound.Play();	
}

void CProg::OnEditsoundStop() 
{
	m_ProgSound.Stop();
}

void CProg::OnEditsoundRecord() 
{
	m_ProgSound.Record();
}

void CProg::OnUpdateEditsoundPlay(CCmdUI* pCmdUI) 
{
	if ((m_ProgSound.m_Mode != 0) || (m_ProgSound.m_DataNum <= sizeof(WAVFORMAT)))
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}	
}

void CProg::OnUpdateEditsoundRecord(CCmdUI* pCmdUI) 
{
	if (m_ProgSound.m_Mode != 0)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}	
}

void CProg::OnUpdateEditsoundStop(CCmdUI* pCmdUI) 
{
	if (m_ProgSound.m_Mode == 0)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}	
}
