
//////////////////////////////////////////////////////
//          !!!!!!!!!!!!!!!!!!!!!!!!!				//
// Nastavit zarovnvn pekladae na max. 8 bajt, //
//  aby souhlasilo zarovnvn struktur v souboru	//
//	        !!!!!!!!!!!!!!!!!!!!!!!!!				//
//////////////////////////////////////////////////////

// Pi zmn velikosti poloek bude mon nutn zmnit
// zarovnn a na 1 Bajt, proto radji dodret velikosti
// poloek pro vt zarovnn.


/////////////////////////////////////////////////////////////////////////////
// definice indexu datovho bloku (32 B)

typedef struct tagPETINDEX {
	long				delka;		// (4) dlka datovho bloku
	long				pocet;		// (4) poet poloek v datovm bloku
	char				jmeno[8];	// (8) jmno datovho bloku (8 znak)
	long				extra1;		// (4) doplujc informace 1 (= 0)
									//      - potek okna, jazyk text, ikony WIDTH
	long				extra2;		// (4) doplujc informace 2 (= 0)
									//		- kurzor, kd znak text, ikony HEIGHT
	long				extra3;		// (4) doplujc informace 3 (= 0)
	long				extra4;		// (4) doplujc informace 4 (= 0)
} PETINDEX;


/////////////////////////////////////////////////////////////////////////////
// definice zhlav souboru (16 + NUMOFINDEX*32 B)

#define NUMOFINDEX 16

#define SIZEOFPETHEAD 16			// zkladn velikost zhlav (bez index)

typedef struct tagPETHEAD {
	char				ident[3];	// (3) identifikace = "PET"
	BYTE				verze;		// (1) verze = 1
	long				param;		// (4) parametry = 0
	long				data;		// (4) offset zatku dat v souboru (= dlka zhlav)
	long				pocet;		// (4) poet datovch blok
	PETINDEX			pi[NUMOFINDEX];	// tabulka index
#define	piImport		pi[0]		// (32) blok "IMPORT" - import internch prvk (seznam ASCIIZ jmen)
#define	piClass			pi[1]		// (32) blok "CLASS" - tdy
#define	piGlobal		pi[2]		// (32) blok "GLOBAL" - globln objekty
#define	piLocal			pi[3]		// (32) blok "LOCAL" - lokln objekty
#define	piProgram		pi[4]		// (32) blok "PROGRAM" - program (obsah funkc)
#define	piStruc			pi[5]		// (32) blok "STRUC" - zkladn struktury
#define	piReal			pi[6]		// (32) blok "REAL" - obsah selnch promnnch
#define	piText			pi[7]		// (32) blok "TEXT" - texty (text 0 = jmno programu)
#define	piBool			pi[8]		// (32) blok "BOOL" - logick hodnoty (bajty)
#define	piPic32			pi[9]		// (32) blok "PICTURE" - obrzky 32*32 (obrzek 0 = ikona programu)
#define	piMap			pi[10]		// (32) blok "MAP" - mapy ploch
#define	piBack			pi[11]		// (32) blok "BACKGRND" - pozad
#define piSprite		pi[12]		// (32) blok "SPRITE" - sprajty
#define	piSound			pi[13]		// (32) blok "SOUND" - zvuky
#define	piMusic			pi[14]		// (32) blok "MUSIC" - hudba
#define	piPalette		pi[15]		// (32) blok "PALETTE" - palety ve formtu BMP
} PETHEAD;


/////////////////////////////////////////////////////////////////////////////
// definice poloky programu nebo struktury (32 B) - pozor na zarovnn dat programu !!!

#define PETPROG_CHILDS	0x0001		// pznak, e jsou potomci
#define PETPROG_NEXT	0x0002		// pznak, e bude potomek stejn hladiny
#define PETPROG_EXP		0x0004		// pznak rozvinut potomk
#define PETPROG_LOCK	0x0008		// pznak uzamknut (zvraznn)
#define PETPROG_OFF		0x0010		// pznak vypnut (zeednut)
#define PETPROG_NOMOVE	0x0020		// pznak zkazu pesunu poloky
#define PETPROG_INTERN	0x0040		// pznak intern poloky (neruit)

typedef struct tagPETPROG {
	long			param;			// (4) parametry (viz ve)
	long			typ;			// (4) blok s deklarac (-1 = nen)
	long			refer;			// (4) index s deklarac (-1 = nen)
	long			data;			// (4) blok s daty (-1 = nen)
	long			index;			// (4) index s daty (-1 = nen)
	long			icon;			// (4) ikona (-1 = implicitn)
	long			name;			// (4) text jmna (-1 = implicitn)
	long			rez;			// (4) rezerva
} PETPROG;


/////////////////////////////////////////////////////////////////////////////
// inicializan tabulky obsah pol (8 B)

typedef struct tagINITBUF {
	int				refer;		// (4) index reference (-1 = nen)
	int				parent;		// (4) hladina prvku (k uren rodie)
	int				model;		// (4) model (typ) prvku
	long			param;		// (4) parametry (pidat PR_INTERNAL !!!!)
} INITBUF;


////////////////////////////////////////////////////////////////////
// okno programovn

class CProg : public CFormView
{
protected:
	CProg();
	DECLARE_DYNCREATE(CProg)

public:
	//{{AFX_DATA(CProg)
	enum { IDD = IDR_PROG };
	CStatic	m_ProgBack;
	CButton	m_ProgLogic;
	CStatic	m_ProgMusic;
	CEdit	m_ProgText;
	CEdit	m_ProgReal;
	CStatic		m_Nadpis1;		// nadpis nad stromem veejnch objekt
	CStatic		m_Nadpis2;		// nadpis nad stromem loklnch objekt
	CStatic		m_Nadpis3;		// nadpis nad stromem zkladnch prvk
	CStatic		m_Nadpis4;		// nadpis nad stromem td objekt
	CTreeCtrl	m_Object;		// strom veejnch objekt
	CTreeCtrl	m_Local;		// strom loklnch objekt
	CTreeCtrl	m_Struc;		// strom zkladnch prvk a struktur
	CTreeCtrl	m_Class;		// strom td objekt
	CTreeCtrl	m_Edit;			// strom editace
	CStatic		m_Split1;		// lev vertikln rozdlova
	CStatic		m_Split2;		// lev horizontln rozdlova
	CStatic		m_Split3;		// prav vertikln rozdlova
	CStatic		m_Split4;		// prav horizontln rozdlova
	//}}AFX_DATA

// aktivn poloka a aktivn strom
//	int			m_AktItem;		// aktivn poloka (v aktivnm okn) (-1 = nen)
	int			m_AktBufID;		// ID aktivnho bufferu
//	CTreeCtrl*	m_AktTree;		// aktivn strom

	BOOL		m_Checking;		// nastavuje se hodnota tlatka

// editace jmna poloky
	BOOL		m_FilName;		// probh plnn editoru jmna textem
	BOOL		m_Editing;		// probh "inplace" editace jmna poloky
	CString		m_OldName;		// pvodn jmno poloky (ped zahjenm inplace editace)
//	CEdit		m_Label;		// "inplace" editor jmna poloky

//	HWND		m_LabelhWnd;	// handle okna editoru jmna poloky

// aktuln stavy pepna
	int			m_OldRef;		// aktuln zobrazen referenn ta (-1=vymazn, -2=neznm)
//	int			m_AktDef;		// pepna "implicitn text" (0, 1, 2, -1=vyp)

// seznamy ikon k zobrazen pro stromy
	CImageList* m_Ico16;		// mal ikony 16x16
	CImageList* m_Ico32;		// velk ikony 32x32
	CImageList* m_State16;		// stavov ikony 8x16
	CImageList* m_State32;		// stavov ikony 12*32

// seznamy text
	CTextBuf	m_Text;			// uivatelsk texty (identifikace BufTxtID)
//	CTextBuf	m_TextInt;		// texty internch funkc

	CRealBuf	m_Real;			// buffer sel (identifikace BufNumID)
	CBoolBuf	m_Bool;			// buffer logickch hodnot (identifikace BufLogID)
	CMapBuf		m_Map;			// buffer map
	CSpriteBuf	m_Sprite;		// buffer sprajt
	CSoundBuf	m_Sound;		// buffer zvuk

	BOOL		m_FilDat;		// probh plnn dat pi aktivaci editovan poloky

	BOOL		m_SelChange;	// probh zmna aktivnho prvku programem

//	CStringArray m_Text;		// uivatelsk texty
//	CStringArray m_TextInt;		// texty internch funkc

// buffery ikon a obrzk
//	CIconBuf	m_BufIco16Int;	// buffer ikon 16x16 - intern funkce
//	CIconBuf	m_BufIco32Int;	// buffer ikon 32x32 - intern funkce
//	CIconBuf	m_BufIco16;		// buffer ikon 16x16 - uivatelsk ikony

	CIconBuf	m_Icon;			// buffer ikon

//	CIconBuf	m_BufIco32;		// buffer ikon 32x32 - uivatelsk ikony
//	CIconBuf	m_BufState16;	// buffer ikon 8x16 - stavov
	CIconBuf	m_BufState32;	// buffer ikon 16x32 - stavov

// opodn vbr poloky v okn editace programu
	int			m_SelTimer;		// ID asovae
	int			m_SelItem;		// prvek k vbru (-1 = nen)

// ukazatel editovanho prvku
	int			m_EditBufN;		// slo aktivnho editanho bufferu
	int			m_EditItem;		// slo editovan aktivn poloky
	int*		m_EditHistBuf;	// buffer historie sel editanch buffer
	int*		m_EditHistItem;	// buffer historie sel editovanch prvk
	int			m_EditHistNum;	// poet prvk v bufferu historie editace
	int			m_EditHistAkt;	// aktivn ukazatel v bufferu historie editace
	int			m_EditHistMax;	// velikost buffer historie (poloek int)
	BOOL		m_EditHistFil;	// probh navracen historie
	int*		m_EditHistSpriteIndex; // buffer index editovanch sprajt
	int*		m_EditHistSpriteX;	// buffer souadnic X ikon sprajt
	int*		m_EditHistSpriteY;	// buffer souadnic Y ikon sprajt
	int*		m_EditHistProg;	// aktivn kurzor v editoru programu

	CEditDial	m_ProgDialog;	// editor dialogu
	CEditSprite	m_ProgSprite;	// editor sprajt
	CEditIcon	m_ProgPic;		// editor ikon
	CEditMap	m_ProgMap;		// editor map
	CEditSound	m_ProgSound;	// editor zvuku

	int			m_OldEditX;		// aktuln zobrazen souadnice X editoru
	int			m_OldEditY;		// aktuln zobrazen souadnice Y editoru

	int 		m_OldEditMapX;	// aktuln zobrazen souadnice X editoru map
	int			m_OldEditMapY;	// aktuln zobrazen souadnice Y editoru map

	int 		m_OldEditSpriteX;	// aktuln zobrazen souadnice X editoru sprajt
	int			m_OldEditSpriteY;	// aktuln zobrazen souadnice Y editoru sprajt

// buffery struktury programu
	CProgBuf	m_Buf[PROGBUFNUM];	// buffery struktury programu

#define m_BufInt m_Buf[BufIntID]	// buffer internch funkc (nem strom)
#define m_BufCls m_Buf[BufClsID]	// buffer td objekt
#define m_BufObj m_Buf[BufObjID]	// buffer veejnch objekt
#define m_BufLoc m_Buf[BufLocID]	// buffer loklnch objekt
#define m_BufEdi m_Buf[BufEdiID]	// buffer editovan funkce
#define m_BufStr m_Buf[BufStrID]	// buffer zkladnch prvk a struktur

// obsluha taen
	BOOL		m_Dragging;			// pznak probhajciho taen

	CTreeCtrl*	m_TreeSrc;			// ukazatel na strom zdroje taen
	int			m_DragSrc;			// identifiktor ID stromu zdroje taen
	HTREEITEM	m_itemDrag;			// taen prvek
	int			m_itemDragN;		// index taenho prvku
	int			m_itemDragPar;		// parametry taenho prvku
	int			m_itemDragModel;	// model taenho prvku

	CTreeCtrl*	m_TreeDst;			// ukazatel na strom cle taen
	int			m_DragDst;			// identifiktor ID stromu cle taen (-1=neplatn)
	HTREEITEM	m_itemDrop;			// clov prvek (rodi)
	int			m_itemDropN;		// index clovho prvku (rodie, -1=root)
	int			m_itemDropPar;		// parametry clovho prvku (rodie)
	int			m_itemDropModel;	// model clovho prvku (rodie)
	int			m_DropIndex;		// index pozice k uloen (-1 = zkaz uloen)

	CImageList*	m_DragList;			// seznam obrzk pro taen
	CSize		m_HotSpot;			// bod uchycen taenho prvku
	CSize		m_TestSpot;			// bod testu taen prvku
	BOOL		m_DragRight;		// taeno pravm tlatkem (koprovn m pednost)
	BOOL		m_DragLeftInt;		// taen intern prvek levm tlatkem, zakzno stejn okno
	BOOL		m_DragCopy;			// je koprovn nebo pesun (jinak jen ruen)
	BOOL		m_DragDelete;		// je ruen nebo pesun (pi pesunu nebo ruen)
//	HCURSOR		m_OldCursor;		// uschovan kurzor ped taenm
	HCURSOR		m_CurArrow;			// standardn kurzor ipky (IDC_ARROW)
	HCURSOR		m_CurHSize;			// horizontln kurzor (IDC_SIZEWE)
	HCURSOR		m_CurVSize;			// vertikln kurzor (IDC_SIZENS)
	HCURSOR		m_CurCopy;			// kurzor koprovn
	HCURSOR		m_CurMove;			// kurzor pesunu
	HCURSOR		m_CurNoDrag;		// zkaz taen
	HCURSOR		m_CurDelete;		// taen se zruenm
	HCURSOR		m_CurAkt;			// aktivn kurzor pi operaci

// obsluha hledn textu
//	CFindReplaceDialog* m_FindDialog; // hledac dialog
//	BOOL		m_FindDisp;			// pznak zobrazen hledacho okna

// obsluha taen pedl oken
	BOOL		m_Tracking;			// pznak probhajcho taen pedl
	BOOL		m_HTracking;		// pznak taen horizontlnho pedlu
	BOOL		m_TrackDisp;		// pznak, e pedl taen je zobrazen
	CRect		m_TrackRect;		// klientsk souadnice taenho pedlu
	int			m_TrackSpot;		// bod uchycen taenho pedlu
	CStatic*	m_TrackSplit;		// taen rozdlovac okno
	int			m_ReDispCount;		// ta pro pekreslen zobrazen
	UINT		m_TrackTimer;		// handle asovae

// obsluha ukldn/natn souboru
	BOOL		m_Saving;			// probh ukldn/natn souboru
	PETHEAD*	m_Head;				// zhlav souboru
	DWORD		m_Writen;			// poet uloench/natench bajt v jedn operaci
	HANDLE		m_File;				// handle souboru
	BOOL		m_OK;				// pznak operace OK
	CString		m_FileName;			// jmno souboru

//	PETPROG*	m_bufClass;			// buffer prvk td
//	int			m_numClass;			// poet prvk td
	PETPROG*	m_bufObject;		// buffer prvk globlnch objekt
	int			m_numObject;		// poet prvk globlnch objekt
	PETPROG*	m_bufLocal;			// buffer prvk loklnch objekt
	int			m_numLocal;			// poet prvk loklnch objekt
	PETPROG*	m_bufEdit;			// buffer prvk editoru funkc
	int			m_numEdit;			// poet prvk editoru

	int*		m_tabImport;		// konverzn tabulka importovanch funkc
	char*		m_bufImport;		// buffer text importovanch funkc
	int			m_maxImport;		// velikost bufferu importovanch funkc
	int			m_numImport;		// poet importovanch funkc v bufferu
	int			m_sizeImport;		// velikost dat v bufferu importovanch funkc

	char*		m_bufText;			// buffer text
	int			m_maxText;			// velikost bufferu text
	int			m_numText;			// poet text v bufferu text
	int			m_sizeText;			// velikost dat v bufferu text
	int			m_korigText;		// korekce indexu textu (pit se)
	int			m_korigPic;			// korekce indexu obrzk (pit se)

	CRealBuf	m_bufReal;			// buffer sel
	CBoolBuf	m_bufBool;			// buffer logickch hodnot
	CIconBuf	m_bufIcon;			// buffer obrzk
	CMapBuf		m_bufMap;			// buffer ploch
	CSpriteBuf	m_bufSprite;		// buffer sprajt
	CSoundBuf	m_bufSound;			// buffer zvuk

	int*	m_reIcon;				// konverzn tabulka sel ikon pro plochu
	int*	m_typImport;			// konverzn tabulka typ importu
	int*	m_refImport;			// konverzn tabulka referenc importu

public:

	//{{AFX_VIRTUAL(CProg)
	public:
	virtual void OnInitialUpdate();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

protected:
	virtual ~CProg();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	//{{AFX_MSG(CProg)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBeginDragProgObj(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDragProgLoc(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDragProgStr(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDragProgCls(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDragProgEdi(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnItemExpandedProgObj(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpandedProgLoc(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpandedProgStr(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpandedProgCls(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpandedProgEdi(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusObject(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusLocal(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusStruc(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusClass(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetFocusProg(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedObject(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedLocal(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedStruc(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedClass(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangedEdit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkProgObject(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkProgLocal(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFileSave();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBeginLabelEdit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndLabelEdit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnProgLock();
	afx_msg void OnUpdateProgLock(CCmdUI* pCmdUI);
	afx_msg void OnProgOff();
	afx_msg void OnUpdateProgOff(CCmdUI* pCmdUI);
	afx_msg void OnProgIcon();
	afx_msg void OnProgClip();
	afx_msg void OnProgDel();
	afx_msg void OnUpdateProgRefer(CCmdUI* pCmdUI);
	afx_msg void OnUpdateProgDef(CCmdUI* pCmdUI);
	afx_msg void OnProgDef();
	afx_msg void OnChangeName();
	afx_msg void OnKeyDownProg(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnProgRedo();
	afx_msg void OnProgUndo();
	afx_msg void OnRefDef();
	afx_msg void OnRefNext();
	afx_msg void OnRefPrev();
	afx_msg void OnChangeFind();
	afx_msg void OnFindNext();
	afx_msg void OnFindPrev();
	afx_msg void OnProgEdit();
	afx_msg void OnChangeProgText();
	afx_msg void OnChangeProgReal();
	afx_msg void OnProgLogic();
	afx_msg void OnUpdateProgUndo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateProgRedo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditiconXy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapXy(CCmdUI* pCmdUI);
	afx_msg void OnEditmapArrow();
	afx_msg void OnEditmapBlok();
	afx_msg void OnEditmapSwcx();
	afx_msg void OnEditmapSwc1();
	afx_msg void OnEditmapSwc2();
	afx_msg void OnEditmapSwc3();
	afx_msg void OnEditmapSwc4();
	afx_msg void OnEditmapSwc5();
	afx_msg void OnEditmapSwcn1();
	afx_msg void OnEditmapSwcn2();
	afx_msg void OnEditmapSwcn3();
	afx_msg void OnUpdateEditmapSwc1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapSwc2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapSwc3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapSwc4(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapSwc5(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapSwcn1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapSwcn2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapSwcn3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditmapSwcx(CCmdUI* pCmdUI);
	afx_msg void OnProgstart();
	afx_msg void OnSpriteTest();
	afx_msg void OnUpdateEditspriteXy(CCmdUI* pCmdUI);
	afx_msg void OnChangeSpriteDelay();
	afx_msg void OnChangeSpriteKrok();
	afx_msg void OnUpdateSpriteTest(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHistoryNext(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHistoryPrev(CCmdUI* pCmdUI);
	afx_msg void OnHistoryPrev();
	afx_msg void OnHistoryNext();
	afx_msg void OnDblclkProg(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClose();
	afx_msg void OnEditsoundPlay();
	afx_msg void OnEditsoundStop();
	afx_msg void OnEditsoundRecord();
	afx_msg void OnUpdateEditsoundPlay(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditsoundRecord(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditsoundStop(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void OnButtonUp();
	void OnItemExpandedProg(NMHDR* pNMHDR, LRESULT* pResult, int buff);
	void InitPrgBuf(int num, const INITBUF* InitBuf, CProgBuf* ProgBuf);
	BOOL SrcDropWin(CPoint point);
//	BOOL TestDropWin();
	BOOL TestDropItem(int srcModel, int srcPar, int srcBuff, int dstModel, 
		int dstPar, int dstBuff, int srcItem,  int dstItem);
	void OnSetFocus(NMHDR* pNMHDR, LRESULT* pResult);
	void DispName();
	void OnBeginDragProg(NMHDR* pNMHDR, LRESULT* pResult);
//	void AktNameTree(CProgBuf* buff, CString* text, int AktBuf, int AktItem);
	void AktNameTree(int bufID, CString& txt, int bufrefID, int itemref);
	void AktIconTree(int bufID, int icon, int bufrefID, int itemref);
//	void OnSelChanged(NMHDR* pNMHDR, LRESULT* pResult);
	void RefSelChange(int AktBuf, int RefBuf);
	void DblclkObject(int item);
	void DblclkLocal(int item);
	void DblclkProg(int item);
	void DblclkClass(int item);
	void SavePrg(PETPROG* buf, int buffID);
	void SaveWriteFile(LPCVOID buf, DWORD bytes);
	void OnFileLoad();
	void LoadReadFile(LPVOID buf, DWORD bytes);
	int LoadSrcIndex(LPCTSTR jmeno, int beg);
	void FileLoadHead();
	void FileLoadImport();
	void FileLoadReal();
	void FileLoadText();
	void FileLoadBool();
	void FileLoadPic();
	void FileLoadMap();
	void FileLoadSprite();
	void FileLoadSound();
	void FileLoadProg(LPCTSTR jm, PETPROG*& pbuf, int& pnum, CProgBuf* buf);
	void LoadLibPicDir(CString cesta, PROGITEM& item);
	void LoadLibSndDir(CString cesta, PROGITEM& item);
	void FileLoadTab();
	void LoadLibPic();						// naten knihovny obrzk
	void LoadLibSnd();
	BOOL WndHitTest(CWnd& wnd, POINT& pt);
	BOOL BegTrack(CStatic& wnd, POINT& pt, BOOL HTrack);
	void InvertTrack();
	void EndTrack();
	void MoveTrack(CPoint pt);
	void ReSize();
	int DragItem(int srcID, int src, int dstID, int dst, int parent, int mode);
//	void ItemDepLock(int bufID, int itemN);
//	void ItemDepOff(int bufID, int itemN);
	void UpdateLock();
	void UpdateLockBuf(int bufID);
	void UpdateLockItem(CTreeCtrl* tree, PROGITEM* item, int state);
	void OnFind(int inc);
	void DispItem(int bufID, int itemN);
	void OnRefNextPrev(int smer);
	BOOL AktRef(int bufID, int bufref, int itemref, int smer);
	void AktAllDef();
	void SetEditMode(int model);
	void RefreshIcon();
	void PushEditHist();
	void PopEditHist();
	void OnTrackTimer();
};
