
#define	PROGBUFNUM 6				// poet buffer

// nemnit poad - muselo by se zmnit t pi ukldn souboru !
#define BufIntID 0					// buffer internch funkc (nem strom)
#define BufClsID 1					// buffer td objekt
#define BufObjID 2					// buffer veejnch objekt
#define BufLocID 3					// buffer loklnch objekt
#define BufEdiID 4					// buffer editace
#define BufStrID 5					// buffer zkladnch prvk a struktur

// datov buffery
#define BufNumID PROGBUFNUM			// seln buffer
#define	BufTxtID PROGBUFNUM+1		// textov buffer
#define BufLogID PROGBUFNUM+2		// logick buffer
#define BufPicID PROGBUFNUM+3		// buffer s ikonami
#define BufMapID PROGBUFNUM+4		// buffer map
#define BufSprID PROGBUFNUM+5		// buffer sprajt
#define BufSndID PROGBUFNUM+6		// buffer zvuk

////////////////////////////////////////////////////////////////////
// zsady pro pouit poloek programu:
//
// - ROOT poloky LOCAL a EDIT nesm referovat na dnou deklaraci,
//   definice LOCAL ukazuje do EDIT nebo do datovch buffer
// - vstupn parametry lokln definice mus bt jako prvn potomek
//   (vyaduje funkce CProgBuf::Copy)
// - vstupn parametr lokln definice mus bt jako druh potomek
//	 (potebn pi testovn taen lokln funkce)
// - parametry funkc a vlastnosti objekt nelze lenit do skupin !
//	 (pro monost rozlien, zda se jedn o parametr nebo o promnnou)
// - obrzky maj vdy ikonu shodnou s daty
// - przdn polko m charakter obrzku s ikonou 0, v souboru
//   se ikona 0 ukld vdy a je vdy jako prvn ikona v souboru

////////////////////////////////////////////////////////////////////
// deklaran ukazatele REFERENCE:
// -------------------------------
//
//    +--------------------------------------------->
//    |       +------------------------------------->
//    |       |        +---------------------------->
//    |       |        |         +------------------>
//	  |		  |		   |		 |		  +--------->
//  EDIT -> LOCAL -> GLOBAL -> CLASS -> STRUC -> INTERNAL
//    |       +-----------------> 
//    |       |        +------------------>
//    |       +--------------------------->
//    +----------------------------------->

////////////////////////////////////////////////////////////////////
// definin ukazatele DATA (ukazuj na ROOT poloky):
// ---------------------------------------------------
//
//			   +--------------> data
//			   |
// GLOBAL -> LOCAL -> EDIT
// CLASS ------>

////////////////////////////////////////////////////////////////////
// definice poloky programu (56 bajt, 4 bajty asi pidv)

typedef struct tagPROGITEM {
	int			param;		// parametry
	int			model;		// model (typ) prvku

	int			typ;		// blok s deklarac (-1 = nen)
	int 		refer;		// index deklarace (-1 = nen)

	int			data;		// blok s definic (-1 = nen)
	int			index;		// index definice (-1 = nen)

	int			parent;		// index rodie (-1 = nen)
	int			childs;		// poet pmch potomk v podvtvi (0 = nejsou)
	int			items;		// poet prvk v podvtvi vetn tohoto prvku
	int			icon;		// index ikony poloky (-1 = implicitn)
	int			name;		// index textu jmna poloky (-1 = implicitn)
	HTREEITEM	htree;		// handle poloky ve stromu (NULL = nen)
	int			counter;	// ta odkaz pouit na tento prvek
} PROGITEM;

// parametry poloky programu
#define PR_EXP			0x0001	// parametr - pznak rozvinut potomk
#define PR_LOCK			0x0002	// parametr - uzameno (zvraznno)
#define PR_OFF			0x0004	// parametr - vypnuto (zeednuto)
#define PR_LOCK_DEP		0x0008	// parametr - uzameno s odvozenm
#define PR_OFF_DEP		0x0010	// parametr - vypnuto s odvozenm
#define PR_ONE			0x0020  // prvek me mt maximln 1 potomka
#define PR_INTERNAL		0x0040	// zkaz ruen a pesunu - vchoz prvek (po kopii se nuluje)
#define PR_NOMOVE		0x0080	// zkaz ruen, koprovn a pesouvn prvku
#define PR_GROUP		0x0100	// prvek je skupina - mus bt prchoz pro parametry
#define PR_LIST			0x0200	// prvek je seznam
#define PR_GET_COMMAND	0x0400	// pijm pkazy
#define PR_AS_COMMAND	0x0800	// me bt pouito jako pkaz
#define PR_GET_EXPRES	0x1000	// pijm vrazy
#define PR_AS_EXPRES	0x2000	// me bt pouito jako vraz
#define PR_GET_BOOL		0x4000	// pijm logick vraz
#define PR_AS_BOOL		0x8000	// me bt pouito jako logick vraz

// modely (typy) prvk
#define	TYP_NONE		0			// 
#define TYP_IGROUP		TYP_NONE+1	// intern skupina (nelze koprovat)
#define	TYP_GROUP		TYP_NONE+2	// skupina
#define	TYP_LIST		TYP_NONE+3	// seznam
#define TYP_LIST_SIZE	TYP_NONE+4	// velikost seznamu
#define TYP_LIST_INDEX	TYP_NONE+5	// index seznamu
#define TYP_LIST_AUTO	TYP_NONE+6	// automatick index
#define TYP_ROOT		TYP_NONE+7	// fiktivn ROOT prvek okna
#define TYP_IPARAM		TYP_NONE+8	// vstupn parametr
#define TYP_OPARAM		TYP_NONE+9	// vstupn parametr
#define TYP_PROPERTIES	TYP_NONE+10	// vlastnosti
#define TYP_PROP_WRITE	TYP_NONE+11	// zpis do vlastnosti
#define TYP_PROP_READ	TYP_NONE+12	// ten z vlastnosti
#define TYP_SOUND_PLAY	TYP_NONE+13	// pehrt zvuku
#define	TYP_NONE_		TYP_NONE+14

#define	TYP_IF			TYP_NONE_	// konstrukce IF
#define	TYP_IF_TEST		TYP_IF+1	// test podmnky IF
#define	TYP_IF_YES		TYP_IF+2	// podmnka IF splnna
#define	TYP_IF_NO		TYP_IF+3	// podmnka IF nesplnna
#define	TYP_IF_			TYP_IF+4

#define	TYP_WHILE		TYP_IF_		// konstrukce WHILE
#define	TYP_WHILE_TEST	TYP_WHILE+1	// test podmnky WHILE
#define	TYP_WHILE_BODY	TYP_WHILE+2	// tlo WHILE
#define	TYP_WHILE_BREAK	TYP_WHILE+3	// peruen WHILE
#define TYP_REPEAT		TYP_WHILE+4	// konstrukce REPEAT
#define TYP_REPEAT_N	TYP_WHILE+5	// poet opakovn REPEAT
#define	TYP_WHILE_		TYP_WHILE+6

#define	TYP_CASE		TYP_WHILE_	// konstrukce CASE
#define	TYP_CASE_EXPR	TYP_CASE+1	// vraz pro CASE
#define	TYP_CASE_ON		TYP_CASE+2	// vtev CASE
#define	TYP_CASE_TEST	TYP_CASE+3	// test vtve CASE
#define	TYP_CASE_DEF	TYP_CASE+4	// implicitn vtev CASE
#define	TYP_CASE_		TYP_CASE+5

#define	TYP_NUM			TYP_CASE_	// seln konstanta
#define	TYP_CIS			TYP_NUM+1	// slice
#define	TYP_TECKA		TYP_NUM+2	// desetinn teka
#define	TYP_MINUS		TYP_NUM+3	// znamnko v sle
#define	TYP_EXPONENT	TYP_NUM+4	// exponent sla
#define TYP_TXT			TYP_NUM+5	// textov konstanta
#define	TYP_NUM_		TYP_NUM+6

#define	TYP_OPER		TYP_NUM_	// matematick opertor
#define	TYP_COMP		TYP_OPER+1	// porovnvac opertor
#define	TYP_ANDOR		TYP_OPER+2	// logick opertor
#define TYP_EQU_TEXT	TYP_OPER+3	// shodnost text
#define TYP_EQU_PIC		TYP_OPER+4	// shodnost obrzk
#define	TYP_OPER_		TYP_OPER+5

// hodnoty TYP_FUNC a TYP_FUNC_ se pouvaj jako interval
// k testu zobrazen pznaku nastavovn hodnoty prvku u ikony
#define	TYP_FUNC		TYP_OPER_	// uivatelsk funkce (!!!!)
#define	TYP_REAL		TYP_FUNC+1	// seln promnn
#define	TYP_BOOL		TYP_FUNC+2	// logick promnn
#define	TYP_TEXT		TYP_FUNC+3	// textov promnn
#define	TYP_PIC			TYP_FUNC+4	// promnn s obrzkem
#define TYP_MAP			TYP_FUNC+5	// promnn s mapou
#define TYP_BACK		TYP_FUNC+6	// promnn pozad
#define	TYP_SND			TYP_FUNC+7	// promnn se zvukem
#define	TYP_MUS			TYP_FUNC+8	// promnn s hudbou
#define	TYP_SPRITE		TYP_FUNC+9	// promnn se sprajtem
#define	TYP_DIALOG		TYP_FUNC+10	// promnn s dialogem
#define TYP_EVENT		TYP_FUNC+11	// promnn s udlost
#define	TYP_CLASS		TYP_FUNC+12	// uivatelsk tda (!!!!)
#define	TYP_OKRAJ		TYP_FUNC+13	// okraj plochy
#define	TYP_FUNC_		TYP_FUNC+14

// parametry sprajtu
#define TYP_SPR			TYP_FUNC_	//		(nevyuito)
#define	TYP_SPR_REAL	TYP_SPR+1	// souadnice X, Y, smr
#define TYP_SPR_BOOL	TYP_SPR+2	// pznak viditelnosti
#define TYP_SPR_BL		TYP_SPR+3	// pznak pohybu
#define TYP_SPR_		TYP_SPR+4

// textov funkce
#define TYP_TX			TYP_SPR_
#define TYP_TXT_LEN		TYP_TX+1	// dlka textu
#define TYP_TXT_POS		TYP_TX+2	// pozice textu
#define TYP_TXT_SUB		TYP_TX+3	// podetzec k hledn
#define TYP_TXT_TXT		TYP_TX+4	// text ke zpracovn
#define TYP_TX_			TYP_TX+5

#define	TYP_F			TYP_TX_		// intern funkce - jen jako pkaz bez parametr
#define	TYP_FN			TYP_F+1		// intern funkce - vrac slo
#define	TYP_FNN			TYP_F+2		// intern funkce - vrac i pijm slo
#define	TYP_FNT			TYP_F+3		// intern funkce - vrac slo, pijm text
#define	TYP_F0N			TYP_F+4		// intern funkce - pijm slo
#define	TYP_FT			TYP_F+5		// intern funkce - vrac text
#define	TYP_FTN			TYP_F+6		// intern funkce - vrac text, pijm slo
#define	TYP_FTT			TYP_F+7		// intern funkce - vrac text, pijm text
#define	TYP_FTNT		TYP_F+8		// intern funkce - vrac text, pijm slo a text
#define	TYP_FB			TYP_F+9		// intern funkce - vrac logickou hodnotu
#define	TYP_FBN			TYP_F+10	// intern funkce - vrac logickou hodnotu, pijm slo
#define	TYP_FBB			TYP_F+11	// intern funkce - vrac i pijm logickou hodnotu
//#define	TYP_F0T			TYP_F+12	// intern funkce - pijm text
#define	TYP_F_			TYP_F+12

#define	TYP_			TYP_F_		// poet typ celkem (ponechat posledn !!!!!)


/////////////////////////////////////////////////////////////////////////////
// indexy stavovch ikon

#define STATE_NONE		0			// nen stav
#define STATE_SELECT	1			// vybran poloka
#define STATE_SET		2			// nastaven hodnoty poloky

/////////////////////////////////////////////////////////////////////////////
// indexy internch funkc (pro referenci do seznamu vnitnch funkc)

enum FncTyp
{
	FncNone = 0,	// 
	FncGroup,		// skupina
	FncIf,			// IDI_IF
	FncIfCond,		// IDI_IF_COND
	FncIfYes,		// IDI_IF_YES
	FncIfNo,		// IDI_IF_NO
	FncWhile,		// IDI_WHILE
	FncWhileCond,	// IDI_WHILE_COND
	FncWhileBody,	// IDI_WHILE_BODY
	FncWhileBreak,	// IDI_WHILE_BREAK
	FncMinus,		// IDI_MINUS
	FncCase,		// IDI_CASE
	FncCaseSum, 	// IDI_CASE_SUM
	FncCaseOn,		// IDI_CASE_ON
	FncCaseEqu, 	// IDI_CASE_EQU
	FncCaseDef, 	// IDI_CASE_DEF
	FncNum, 		// IDI_NUM
	FncNum0,		// IDI_0
	FncNum1,		// IDI_1
	FncNum2,		// IDI_2
	FncNum3,		// IDI_3
	FncNum4,		// IDI_4
	FncNum5,		// IDI_5
	FncNum6,		// IDI_6
	FncNum7,		// IDI_7
	FncNum8,		// IDI_8
	FncNum9,		// IDI_9
	FncDot, 		// IDI_DOT
	FncExp, 		// IDI_EXP
	FncEqu, 		// IDI_EQU
	FncNEqu,		// IDI_NEQU
	FncEqGr,		// IDI_EQGR
	FncEqLt,		// IDI_EQLT
	FncGr,			// IDI_GR
	FncLt,			// IDI_LT
	FncAnd, 		// IDI_AND
	FncOr,			// IDI_OR
	FncXor, 		// IDI_XOR
	FncNot, 		// IDI_NOT
	FncAdd, 		// IDI_ADD
	FncSub, 		// IDI_SUB
	FncMul, 		// IDI_MUL
	FncDiv, 		// IDI_DIV
	FncInt, 		// IDI_INT
	FncPic, 		// IDI_PIC
	FncSnd, 		// IDI_SND
	FncMus, 		// IDI_MUS
	FncFnc, 		// IDI_FNC
	FncMap, 		// IDI_MAP
	FncSprite,		// IDI_SPRITE
	FncClass,		// IDI_CLASS
	FncText,		// IDI_TEXT
	FncDialog,		// IDI_DIALOG
	FncPar, 		// IDI_PAR
	FncOut, 		// IDI_OUT
	FncEvent,		// IDI_EVENT
	FncList,		// IDI_LIST
	FncOper,		// IDI_OPER
	FncKrok,		// IDI_KROK
	FncVlevo,		// IDI_VLEVO
	FncVpravo,		// IDI_VPRAVO
	FncVzad,		// IDI_VZAD
	FncPetrik,		// IDI_PETRIK
	FncBool,		// IDI_LOGIC
	FncTextConst,	// IDI_TEXT_CONST
	FncTrue,		// IDI_TRUE
	FncFalse,		// IDI_FALSE
	FncPetra,		// IDI_PETRA
	FncPetraKrok,	// IDI_PETRA_KROK
	FncPetraVlevo,	// IDI_PETRA_VLEVO
	FncPetraVpravo, // IDI_PETRA_VPRAVO
	FncPetraVzad,	// IDI_PETRA_VZAD
	FncRychle,		// IDI_RYCHLE
	FncExit,		// IDI_EXIT
	FncPetraRychle, // IDI_PETRA_RYCHLE
	FncPetraPomalu, // IDI_PETRA_POMALU  // zrueno !!!!!!!!!!
	FncPredmet, 	// IDI_PREDMET
	FncSmer,		// IDI_SMER
	FncPoziceX, 	// IDI_POZICEX
	FncPoziceY, 	// IDI_POZICEY
	FncPetraPredmet,	// IDI_PETRA_PREDMET
	FncPetraSmer,		// IDI_PETRA_SMER
	FncPetraPoziceX,	// IDI_PETRA_POZICEX
	FncPetraPoziceY,	// IDI_PETRA_POZICEY
	FncConst,		// IDI_CONST
	FncVypoc,		// IDI_VYPOC
	FncFunc,		// IDI_FUNC
	FncPorovnani,	// IDI_POROVNANI
	FncLogOper, 	// IDI_LOG_OPER
	FncMod, 		// IDI_MOD
	FncSin, 		// IDI_SIN
	FncCos, 		// IDI_COS
	FncTg,			// IDI_TG
	FncCoTg,		// IDI_COTG
	FncArcSin,		// IDI_ARCSIN
	FncArcCos,		// IDI_ARCCOS
	FncArcTg,		// IDI_ARCTG
	FncArcCoTg, 	// IDI_ARCCOTG
	FncPi,			// IDI_PI
	FncInteger, 	// IDI_INTEGER
	FncFrac,		// IDI_FRAC
	FncAbs, 		// IDI_ABS
	FncSqrt,		// IDI_SQRT
	FncFact,		// IDI_FACT
	FncRand,		// IDI_RAND
	FncEul, 		// IDI_EUL
	FncDegRad,		// IDI_DEGRAD
	FncRadDeg,		// IDI_RADDEG
	FncLogar,		// IDI_LOG
	FncLn,			// IDI_LN
	FncPExp,		// IDI_PEXP
	FncMocn,		// IDI_MOCN
	FncUhel,		// IDI_UHEL
	FncUhel0,		// IDI_UHEL0
	FncUhel45,		// IDI_UHEL45
	FncUhel90,		// IDI_UHEL90
	FncUhel135, 	// IDI_UHEL135,
	FncUhel180, 	// IDI_UHEL180
	FncUhel225, 	// IDI_UHEL225
	FncUhel270, 	// IDI_UHEL270
	FncUhel315, 	// IDI_UHEL315
	FncCommand, 	// IDI_COMMAND
	FncWait,		// IDI_WAIT
	FncKlav,		// IDI_KLAV
	FncKlavTest,	// IDI_KLAV_TEST
	FncKlavVKey,	// IDI_KLAV_VKEY
	FncKlavChar,	// IDI_KLAV_CHAR
	FncKlavVK,		// IDI_KLAV_VK
	FncKlavFX,		// IDI_KLAV_FX
	FncKlavPism,	// IDI_KLAV_PISM
	FncKlavNum, 	// IDI_KLAV_NUM
	FncKlavRuzne,	// IDI_KLAV_RUZNE
	FncKlavRid, 	// IDI_KLAV_RID
	FncKlavShift,	// IDI_KLAV_SHIFT  (zrueno)
	FncF1,			// IDI_F1
	FncF2,			// IDI_F2
	FncF3,			// IDI_F3
	FncF4,			// IDI_F4
	FncF5,			// IDI_F5
	FncF6,			// IDI_F6
	FncF7,			// IDI_F7
	FncF8,			// IDI_F8
	FncF9,			// IDI_F9
	FncF10, 		// IDI_F10
	FncF11, 		// IDI_F11
	FncF12, 		// IDI_F12
	FncA,			// IDI_A
	FncB,			// IDI_B
	FncC,			// IDI_C
	FncD,			// IDI_D
	FncE,			// IDI_E
	FncF,			// IDI_F
	FncG,			// IDI_G
	FncH,			// IDI_H
	FncI,			// IDI_I
	FncJ,			// IDI_J
	FncK,			// IDI_K
	FncL,			// IDI_L
	FncM,			// IDI_M
	FncN,			// IDI_N
	FncO,			// IDI_O
	FncP,			// IDI_P
	FncQ,			// IDI_Q
	FncR,			// IDI_R
	FncS,			// IDI_S
	FncT,			// IDI_T
	FncU,			// IDI_U
	FncV,			// IDI_V
	FncW,			// IDI_W
	FncX,			// IDI_X
	FncY,			// IDI_Y
	FncZ,			// IDI_Z
	FncVKNum0,		// IDI_VK_NUM0
	FncVKNum1,		// IDI_VK_NUM1
	FncVKNum2,		// IDI_VK_NUM2
	FncVKNum3,		// IDI_VK_NUM3
	FncVKNum4,		// IDI_VK_NUM4
	FncVKNum5,		// IDI_VK_NUM5
	FncVKNum6,		// IDI_VK_NUM6
	FncVKNum7,		// IDI_VK_NUM7
	FncVKNum8,		// IDI_VK_NUM8
	FncVKNum9,		// IDI_VK_NUM9
	FncVKNumTecka,	// IDI_VK_NUMTECKA
	FncVKNumPlus,	// IDI_VK_NUMPLUS
	FncVKNumMinus,	// IDI_VK_NUMMINUS
	FncVKNumKrat,	// IDI_VK_NUMKRAT
	FncVKNumDeleno, // IDI_VK_NUMDELENO
	FncVKNumEnter,	// IDI_VK_NUMENTER
	FncVKNumLock,	// IDI_VK_NUMLOCK
	FncVK1, 		// IDI_VK_1
	FncVK2, 		// IDI_VK_2
	FncVK3, 		// IDI_VK_3
	FncVK4, 		// IDI_VK_4
	FncVK5, 		// IDI_VK_5
	FncVK6, 		// IDI_VK_6
	FncVK7, 		// IDI_VK_7
	FncVK8, 		// IDI_VK_8
	FncVK9, 		// IDI_VK_9
	FncVK0, 		// IDI_VK_0
	FncVKLCarka,	// IDI_VK_LCARKA
	FncVKPomlcka,	// IDI_VK_POMLCKA
	FncVKRovnitko,	// IDI_VK_ROVNITKO
	FncVKZLomitko,	// IDI_VK_ZLOMITKO
	FncVKLLomena,	// IDI_VK_LLOMENA
	FncVKRLomena,	// IDI_VK_RLOMENA
	FncVKStrednik,	// IDI_VK_STREDNIK
	FncVKRCarka,	// IDI_VK_RCARKA
	FncVKCarka, 	// IDI_VK_CARKA
	FncVKTecka, 	// IDI_VK_TECKA
	FncVKLomitko,	// IDI_VK_LOMITKO
	FncVKEsc,		// IDI_VK_ESC
	FncVKTab,		// IDI_VK_TAB
	FncVKCapsLock,	// IDI_VK_CAPSLOCK
	FncVKWin,		// IDI_VK_WIN
	FncVKBS,		// IDI_VK_BS
	FncVKEnter, 	// IDI_VK_ENTER
	FncVKMenu,		// IDI_VK_MENU
	FncVKLeft,		// IDI_VK_LEFT
	FncVKRight, 	// IDI_VK_RIGHT
	FncVKUp,		// IDI_VK_UP
	FncVKDown,		// IDI_VK_DOWN
	FncVKInsert,	// IDI_VK_INSERT
	FncVKDelete,	// IDI_VK_DELETE
	FncVKHome,		// IDI_VK_HOME
	FncVKEnd,		// IDI_VK_END
	FncVKPageUp,	// IDI_VK_PAGEUP
	FncVKPageDown,	// IDI_VK_PAGEDOWN
	FncVKPrint, 	// IDI_VK_PRINT
	FncVKScroll,	// IDI_VK_SCROLL
	FncVKPause, 	// IDI_VK_PAUSE
	FncVKShift, 	// IDI_VK_SHIFT
	FncVKCtrl,		// IDI_VK_CTRL
	FncVKAlt,		// IDI_VK_ALT
	FncVKSpace, 	// IDI_VK_SPACE
	FncMouse,		// IDI_MOUSE
	FncMouseL,		// IDI_MOUSE_L
	FncMouseR,		// IDI_MOUSE_R
	FncMouseX,		// IDI_MOUSE_X
	FncMouseY,		// IDI_MOUSE_Y
	FncEquText,		// IDI_EQU_TEXT
	FncEquPic,		// IDI_EQU_PIC
	FncPropWrite,	// IDI_PROP_WRITE
	FncPropRead,	// IDI_PROP_READ
	FncProperties,	// IDI_PROPERTIES
	FncCommandLine,	// IDI_COMMAND_LINE
	FncReturnCode,	// IDI_RETURN_CODE
	FncBack,		// IDI_BACK
	FncRepeat,		// IDI_REPEAT
	FncRepeatN,		// IDI_REPEAT_N
	FncOkraj,		// IDI_OKRAJ
	FncSpriteX,		// IDI_SPRITE_X
	FncSpriteY,		// IDI_SPRITE_Y
	FncSpriteSmer,	// IDI_SPRITE_SMER
	FncSpriteMove,	// IDI_SPRITE_MOVE
	FncSpriteVisible, // IDI_SPRITE_VISIBLE
	FncListSize,	// IDI_LIST_SIZE
	FncListIndex,	// IDI_LIST_INDEX
	FncListAuto,	// IDI_LIST_AUTO
	FncPeterExtra,	// IDI_PETER_EXTRA,
	FncPetraExtra,	// IDI_PETRA_EXTRA,
	FncPeterSwcN1,	// IDI_PETER_SWCN1,
	FncPetraSwcN1,	// IDI_PETRA_SWCN1,
	FncPeterSwcN2,	// IDI_PETER_SWCN2,
	FncPetraSwcN2,	// IDI_PETRA_SWCN2,
	FncPeterSwcN3,	// IDI_PETER_SWCN3,
	FncPetraSwcN3,	// IDI_PETRA_SWCN3,
	FncPeterSwc1,	// IDI_PETER_SWC1,
	FncPetraSwc1,	// IDI_PETRA_SWC1,
	FncPeterSwc2,	// IDI_PETER_SWC2,
	FncPetraSwc2,	// IDI_PETRA_SWC2,
	FncPeterSwc3,	// IDI_PETER_SWC3,
	FncPetraSwc3,	// IDI_PETRA_SWC3,
	FncPeterSwc4,	// IDI_PETER_SWC4,
	FncPetraSwc4,	// IDI_PETRA_SWC4,
	FncPeterSwc5,	// IDI_PETER_SWC5,
	FncPetraSwc5,	// IDI_PETRA_SWC5,
	FncTextGroup,	// IDI_TEXT_GROUP,
	FncTextLeft,	// IDI_TEXT_LEFT,
	FncTextLeftLen,	// IDI_TEXT_LEFT_LEN,
	FncTextRight,	// IDI_TEXT_RIGHT,
	FncTextRightPos, // IDI_TEXT_RIGHT_POS,
	FncTextMid,		// IDI_TEXT_MID,
	FncTextMidPos,	// IDI_TEXT_MID_POS,
	FncTextMidLen,	// IDI_TEXT_MID_LEN,
	FncTextLen,		// IDI_TEXT_LEN,
	FncTextAdd,		// IDI_TEXT_ADD,
	FncTextScan,	// IDI_TEXT_SCAN,
	FncTextFormat,	// IDI_TEXT_FORMAT,
	FncTextGt,		// IDI_TEXT_GT,
	FncTextLower,	// IDI_TEXT_LOWER,
	FncTextUpper,	// IDI_TEXT_UPPER,
	FncTextFind,	// IDI_TEXT_FIND,
	FncTextInput,	// IDI_TEXT_INPUT,
	FncTextFindSub,	// IDI_TEXT_FIND_SUB,
	FncStatusLine,	// IDI_STATUS_LINE
	FncCaption,		// IDI_CAPTION
	FncOrd,			// IDI_ORD
	FncChar,		// IDI_CHAR
	FncSoundGroup,	// IDI_SOUND_GROUP
	FncSoundPlay,	// IDI_SOUND_PLAY
	FncSoundStop,	// IDI_SOUND_STOP

	_FncLast_		// posledn typ - udv poet
};


////////////////////////////////////////////////////////////////////
// tda bufferu programu

class CProgBuf : public CObject
{
public:
	CProgBuf();					// konstruktor
	virtual ~CProgBuf();		// destruktor

	int			m_BufID;		// ID tohoto bufferu (= index bufferu v seznamu)
	PROGITEM*	m_Items;		// buffer poloek
	int			m_Num;			// poet poloek v bufferu
	int			m_Max;			// maximln poloek v bufferu
	int			m_First;		// prvn zobrazen poloka bufferu ve stromu
	int			m_Next;			// nsledujc (nezobrazen) poloka bufferu
								//												(m_Next = -1 zabrn zobrazovn poloek .... zrueno ?)
	int			m_AktDef;		// aktivn definovan poloka (-1 = nen)
	CTreeCtrl*	m_Tree;			// odkaz na zobrazen strom (NULL = nen)
	CProgBuf*	m_ProgBuf;		// mapa vech buffer programu
	CRealBuf*	m_Real;			// seln buffer BufNumID
	CBoolBuf*	m_Bool;			// logick buffer BufLogID
	CTextBuf*	m_Text;			// seznam text (sdlen) - krom BufIntID je to
								//   buffer uivatelskch text BufTxtID
	CIconBuf*	m_Icon;			// buffer obrzk
	CMapBuf*	m_Map;			// buffer map
	CSpriteBuf*	m_Sprite;		// buffer sprajt
	CSoundBuf*	m_Sound;		// buffer zvuk

	BOOL		m_ReIcon;		// poadavek aktualizace zobrazen ikon a strom

// vloen poloky do bufferu (vrac opraven skuten index nebo -1=chyba)
// poadovan platn poloky v PROGITEM:
//		parent - index rodie, ktermu poloka pat (-1 = bude v ROOT)
//				 Parametr Index udv msto, kam m bt poloka vloena.
//				 Index me bt libovoln, je opravovn aby skuten
//				 patil do podvtve poadovanho rodie.
// nepouit poloky v PROGITEM (jsou doplnny):
//		childs - poet pmch potomk (je aktualizovno automaticky)
//		items - poet prvk ve vtvi (je aktualizovno automaticky)
//		htree - identifiktor poloky stromu (je doplnno automaticky)
//		counter - ta odkaz na poloku (je aktualizovno automaticky)
		
	int Insert(PROGITEM* item, int Index = -1);

// zruen poloky z bufferu (rekurzivn, se zruenm potomk!)
// na ruen poloky se nesm nic odkazovat (counter = 0 !)
	void Delete(int Index);

////////////////////////////////////////////////////////////////////
// zruen vtve stromu (vetn zvislch prvk a dat)
//
// - zru referenn poloky, kter referuj na nkter prvek ve vtvi
// - zru datov buffery, na kter ukazuj poloky ve vtvi
	void DeleteTre(int Index);

// nalezen poloky podle handle (vrac index, -1 = nenalezeno)
	int SrcItem(HTREEITEM hItem);

// pekreslen (aktualizace) stromu
	void ReDisp();

/////////////////////////////////////////////////////////////////////////////
// kopie vtve prvk
//
// provd korekce:
//		- nulovn pznaku PR_INTERNAL
//		- zajitn koprovn nkterch poloek bez potomk
//		- zmna reference na zdrojov okno
//		- rozvinut vtve pi kopii ze stromu struktur
//		  nebo pi kopii do nerozvinut poloky
//
// vstupn promnn:
//		dst		- index clov poloky
//		parent	- index rodie clov poloky
//		bufID	- ID zdrojovho bufferu
//		src		- index zdrojov poloky
//
// vrac opraven index clov poloky
	int Copy(int dst, int parent, int bufID, int src);
	int Copy2(int& dst, int parent, int bufID, int& src);

/////////////////////////////////////////////////////////////////////////////
// nastaven prvn zobrazen poloky s ppadnm pekreslenm,
// poadovan index me bt ve vtvi (nemus bt ROOT)
	BOOL SetFirst(int First);

/////////////////////////////////////////////////////////////////////////////
// nalezen textu k poloce
	CString GetName(int Index);

/////////////////////////////////////////////////////////////////////////////
// nalezen ikony k poloce
	int GetIcon(int Index);

/////////////////////////////////////////////////////////////////////////////
// nalezen poloky odkazujc se na poadovan data (-1 = nenalezeno)
	int SrcDat(int bufID, int Index);

/////////////////////////////////////////////////////////////////////////////
// hledn referenn poloky v bufferu od aktuln poloky (-1 = nenalezeno)
//
// vstup:
//	bufID - slo bufferu hledan reference
//	Index - index hledan reference
//	Smer  - poadovan smr (od aktuln poloky) 1 nebo -1
	int SrcRef(int bufID, int Index, int Smer);

/////////////////////////////////////////////////////////////////////////////
// nalezen aktivn poloky (-1 = nen dn poloka)
	int GetAkt();

/////////////////////////////////////////////////////////////////////////////
// nastaven aktivn poloky (-1 = vypnuta)
	void SetAkt(int Index);

/////////////////////////////////////////////////////////////////////////////
// nastaven zamen na okno
	void SetFocus();

/////////////////////////////////////////////////////////////////////////////
// oznaen definovan poloky (-1 = odznaen)
	void SetDef(int Index);

/////////////////////////////////////////////////////////////////////////////
// pesun vtve stromu uvnit bufferu (vetn zmn referenc), vrac clov index
//
// - pesmruje reference na poloky ve vtvi
// - pid nebo ubere parametry funkc v programu
// - pid nebo ubere vlastnosti td 
	int MoveTre(int dst, int parent, int src);

/////////////////////////////////////////////////////////////////////////////
// vytvoen dat poloky (nejsou-li vytvoena)
	void InitDat(int Index);

};

inline void Aloc(PROGITEM*& adr, int size)
	{ adr = (PROGITEM*)_Aloc(adr, size); }

