
/////////////////////////////////////////////////////////////////////////////
//																		   //
//						obsluha vlastnost prvk						   //
//																		   //
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// pepnut stavu LOCK prvku pod kurzorem pomoc tlatka LOCK

void CProg::OnProgLock() 
{
// lokln promnn, nalezen aktulnho prvku
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	CTreeCtrl* tree = buf->m_Tree;				// strom v aktulnm bufferu
	HTREEITEM htree = tree->GetSelectedItem();	// nalezen aktivnho prvku
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivnho prvku
	int* param;						// ukazatel na parametry prvku

// zmna pznaku uzamknut
	if (itemN != -1)							// pokud je vybrn njak prvek
	{
		param = &(buf->m_Items[itemN].param);	// ukazatel na parametry prvku
		*param ^= PR_LOCK;						// zmna piznaku uzamen

// aktualizace zobrazen prvku ve stromu
		if (*param & (PR_LOCK | PR_LOCK_DEP))	// je prvek uzamen ?
			tree->SetItemState(htree, TVIS_BOLD, TVIS_BOLD); // zapnut zvraznn
		else
			tree->SetItemState(htree, 0, TVIS_BOLD);	// vypnut zvraznn

// aktualizace prvk v bufferech
		UpdateLock();							// aktualizace buffer
	}
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace stavu pepnacho tlatka LOCK (prvek uzamen)

void CProg::OnUpdateProgLock(CCmdUI* pCmdUI) 
{
// lokln promnn, nalezen aktulnho prvku
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivnho prvku
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivnho prvku
	int* param;						// ukazatel na parametry prvku

// test, zda byl prvek nalezen
	if (itemN != -1)							// pokud je vybrn njak prvek
	{
		param = &(buf->m_Items[itemN].param);	// ukazatel na parametry prvku

// zkaz tlatka, je-li prvek zvisle uzamen
		if (*param & PR_LOCK_DEP)				// je prvek zvisle uzamen ?
			pCmdUI->Enable(FALSE);				// prvek uzamen - zkaz tlatka
		else
			pCmdUI->Enable(TRUE);				// prvek odemknut - povolen tlatka

// nastaven stavu tlatka
		if (*param & PR_LOCK)					// je prvek uzamen ?
			pCmdUI->SetCheck(1);				// prvek uzamen - tlatko stisknuto
		else
			pCmdUI->SetCheck(0);				// prvek odemknut - tlatko nestisknuto
	}

// nen vybrn prvek - tlatko nedefinovan, ale povolen
	else
	{
		pCmdUI->Enable(TRUE);					// tlatko povoleno
		pCmdUI->SetCheck(2);					// tlatko nedefinovan
	}
}


/////////////////////////////////////////////////////////////////////////////
// pepnut stavu OFF prvku pod kurzorem pomoc tlatka OFF

void CProg::OnProgOff() 
{
// lokln promnn, nalezen aktulnho prvku
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	CTreeCtrl* tree = buf->m_Tree;				// strom v aktulnm bufferu
	HTREEITEM htree = tree->GetSelectedItem();	// nalezen aktivnho prvku
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivnho prvku
	int* param;						// ukazatel na parametry prvku

// zmna pznaku vypnut
	if (itemN != -1)							// pokud je vybrn njak prvek
	{
		param = &(buf->m_Items[itemN].param);	// ukazatel na parametry prvku
		*param ^= PR_OFF;						// zmna pznaku vypnut

// aktualizace zobrazen prvku ve stromu
		if (*param & (PR_OFF | PR_OFF_DEP))		// je prvek vypnut ?
			tree->SetItemState(htree, TVIS_CUT, TVIS_CUT); // zapnut zeednut
		else
			tree->SetItemState(htree, 0, TVIS_CUT);		// vypnut zeednut

// aktualizace prvk v bufferech
		UpdateLock();							// aktualizace buffer
	}
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace stavu pepnacho tlatka OFF (prvek vypnut)

void CProg::OnUpdateProgOff(CCmdUI* pCmdUI) 
{
// lokln promnn, nalezen aktulnho prvku
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivnho prvku
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivnho prvku
	int* param;						// ukazatel na parametry prvku

// test, zda byl prvek nalezen
	if (itemN != -1)							// pokud je vybrn njak prvek
	{
		param = &(buf->m_Items[itemN].param);	// ukazatel na parametry prvku

// zkaz tlatka, je-li prvek uzamen
		if (*param & (PR_LOCK | PR_LOCK_DEP))	// je prvek uzamen ?
			pCmdUI->Enable(FALSE);				// prvek uzamen - zkaz tlatka
		else
			pCmdUI->Enable(TRUE);				// prvek odemknut - povolen tlatka

// nastaven stavu tlatka
		if (*param & PR_OFF)					// je prvek vypnut ?
			pCmdUI->SetCheck(1);				// prvek vypnut - tlatko stisknuto
		else
			pCmdUI->SetCheck(0);				// prvek nen vypnut - tlatko nestisknuto
	}

// nen vybrn prvek - tlatko nedefinovan, ale povolen
	else
	{
		pCmdUI->Enable(TRUE);					// tlatko povoleno
		pCmdUI->SetCheck(2);					// tlatko nedefinovan
	}
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace pznak LOCK a OFF buffer
// Pozor - stav prvk stromu mus souhlasit se stavem v seznamu !!!

void CProg::UpdateLock()
{
// prvn prchod
// buffery LOCALL a EDIT jsou aktualizovny z OBJECT a CLASS
	UpdateLockBuf(BufStrID);			// buffer struktur
	UpdateLockBuf(BufClsID);			// buffer td
	UpdateLockBuf(BufObjID);			// buffer globlnch objekt

// druh prchod - nkter buffery jsou aktualizovny kov
	UpdateLockBuf(BufClsID);			// buffer td
	UpdateLockBuf(BufObjID);			// buffer globlnch objekt

// tet prchod - lokln buffer je dvojnsobn kov zvisl
	UpdateLockBuf(BufClsID);			// buffer td
	UpdateLockBuf(BufObjID);			// buffer globlnch objekt
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace pznak LOCK a OFF pro jeden buffer

void CProg::UpdateLockBuf(int bufID)
{
// lokln promnn
	CProgBuf* buf = &(m_Buf[bufID]);	// adresa bufferu
	CTreeCtrl* tree = buf->m_Tree;		// adresa stromu bufferu
	int num = buf->m_Num;				// poet poloek v bufferu
	int index;						// pracovn index poloky

// cyklus pes vechny poloky
	for (index = 0; index < num; index += buf->m_Items[index].items)
		UpdateLockItem(tree, &(buf->m_Items[index]), 0);
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace pznak LOCK a OFF pro jednu poloku
// - nesm realokovat buffer poloek, uchovvaj se ukazatele na poloky

void CProg::UpdateLockItem(CTreeCtrl* tree, PROGITEM* item, int state)
{
// lokln promnn
	int* param;			// adresa parametr poloky
	int oldstate;					// star stav poloky
	int childs;					// ta potomk

// oprava novho stavu podle deklaran poloky
	if (item->refer != -1)
	{
		param = &(m_Buf[item->typ].m_Items[item->refer].param);
		if (*param & (PR_LOCK | PR_LOCK_DEP)) state |= TVIS_BOLD;
		if (*param & (PR_OFF | PR_OFF_DEP)) state |= TVIS_CUT;		
	}

// pprava starho stavu poloky
	param = &(item->param);			// adresa parametr aktuln poloky
	oldstate = 0;
	if (*param & (PR_LOCK | PR_LOCK_DEP)) oldstate = TVIS_BOLD;
	if (*param & (PR_OFF | PR_OFF_DEP)) oldstate |= TVIS_CUT;

// nastaven zvislch pznak (pro ROOT definici se nenuluje, je ji nastaveno)
	*param &= ~(PR_LOCK_DEP | PR_OFF_DEP);
	if (state & TVIS_BOLD) *param |= PR_LOCK_DEP;
	if (state & TVIS_CUT) *param |= PR_OFF_DEP;

// oprava stavu poloky stromu
	if (*param & (PR_LOCK | PR_LOCK_DEP)) state |= TVIS_BOLD;
	if (*param & (PR_OFF | PR_OFF_DEP)) state |= TVIS_CUT;

// oprava stavu zobrazen poloky stromu
	if ((item->htree != NULL) && (state != oldstate))
		tree->SetItemState(item->htree, state, TVIS_CUT | TVIS_BOLD);

// nastaven parametr definin poloky
	if ((item->index != -1) && ((item->data == BufLocID) || (item->data == BufEdiID)))
		UpdateLockItem(m_Buf[item->data].m_Tree, 
			&(m_Buf[item->data].m_Items[item->index]), state);

// nastaven potomk
	childs = item->childs;			// poet potomk poloky
	item++;							// adresa prvnho potomka
	for (; childs > 0; childs--)
	{
		UpdateLockItem(tree, item, state);
		item += item->items;		// adresa dalho potomka
	}
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace stavu pepnacho tlatka DEF (implicitn jmno)

void CProg::OnUpdateProgDef(CCmdUI* pCmdUI) 
{
// lokln promnn, nalezen aktulnho prvku
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivnho prvku
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivnho prvku
	PROGITEM* item;								// ukazatel na prvek

// test, zda byl prvek nalezen
	if (itemN != -1)							// pokud je vybrn njak prvek
	{
		item = &(buf->m_Items[itemN]);			// ukazatel na prvek

// zkaz tlatka, je-li prvek uzamen
		if (item->param & (PR_LOCK | PR_LOCK_DEP))	// je prvek uzamen ?
			pCmdUI->Enable(FALSE);				// prvek uzamen - zkaz tlatka
		else
			pCmdUI->Enable(TRUE);				// prvek odemknut - povolen tlatka

// nastaven stavu tlatka
		if (item->name == -1)					// je implicitn jmno ?
			pCmdUI->SetCheck(1);				// implicitn jmno - tlatko stisknuto
		else
			pCmdUI->SetCheck(0);				// nen implicitn jmno - tlatko nestisknuto
	}

// nen vybrn prvek - tlatko nedefinovan, ale povolen
	else
	{
		pCmdUI->Enable(TRUE);					// tlatko povoleno
		pCmdUI->SetCheck(2);					// tlatko nedefinovan
	}
}


/////////////////////////////////////////////////////////////////////////////
// pepna DEF (implicitn jmno prvku)

void CProg::OnProgDef() 
{
// lokln promnn, nalezen aktuln poloky
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivn poloky
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivn poloky
	PROGITEM* item;								// ukazatel na poloku
	CString txt = _T("");						// buffer textu
	CEdit* name;								// editor jmna prvku

// test, zda byl prvek nalezen
	if (itemN != -1)							// pokud je vybrn njak prvek
	{
		item = &(buf->m_Items[itemN]);			// ukazatel na prvek

// test, zda je text implicitn
		if (item->name == -1)					// je text implicitn ?
		{

// naten textu k poloce
			txt = buf->GetName(itemN);			// naten jmna k poloce

// pidn textu do bufferu text
			item->name = buf->m_Text->Add(txt);		// pidn textu do bufferu
		}

// jinak uvolnn starho textu poloky
		else
		{
			buf->m_Text->ElementAt(item->name).Empty(); // zruen starho textu
			item->name = -1;					// zruen pznaku platnosti poloky
		}

// aktualizace zobrazen textu v editoru jmna poloky
		DispName();								// aktualizace zobrazen jmna

// pprava editoru jmna
		name = (CEdit*)(MainFrame->m_wndPropBar.GetDlgItem(IDC_PROG_EDIT));

// naten textu z editoru
		if (name != NULL)
			name->GetWindowText(txt);			// naten textu do bufferu

// nastaven textu do stromu
		buf->m_Tree->SetItemText(item->htree,txt); // nastaven textu

// aktualizace zobrazen zvislch buffer
		if (item->counter)						// jsou reference z jinch buffer ?
		{
			AktNameTree(BufObjID, txt, m_AktBufID, itemN);
			AktNameTree(BufLocID, txt, m_AktBufID, itemN);
			AktNameTree(BufClsID, txt, m_AktBufID, itemN);
			AktNameTree(BufEdiID, txt, m_AktBufID, itemN);
		}

	}
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace zobrazen jmna poloky v editoru jmna

void CProg::DispName() 
{
// lokln promnn, nalezen aktuln poloky
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivn poloky
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivn poloky
	CEdit* name;								// editor jmna poloky
	CString txt;								// nov text k nastaven
	CString txtold;								// pvodn text v okn

// naten jmna poloky
	txt = buf->GetName(itemN);				// naten jmna poloky

// okno editoru jmna
	name = (CEdit*)(MainFrame->m_wndPropBar.GetDlgItem(IDC_PROG_EDIT));

// nastaven novho textu do editoru jmna
	if (name != NULL)							// je okno editoru jmna platn ?
	{
		name->GetWindowText(txtold);			// naten starho textu v editoru
		if (txt.Compare(txtold))				// byl text zmnn ?
		{
			m_FilName = TRUE;					// pznak plnn editoru jmna
			name->SetWindowText(txt);			// nastaven novho textu editoru jmna
			m_FilName = FALSE;					// ukonen plnn editoru jmna
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// zmna jmna v editoru jmna poloky

void CProg::OnChangeName() 
{
// test, zda probh plnn editoru jmna programem
	if (m_FilName) return;						// probh plnn programem - konec

// lokln promnn, nalezen aktuln poloky
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivn poloky
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivn poloky
	PROGITEM* item;								// ukazatel na poloku
	CString txt = _T("");						// buffer textu
	CEdit* name;								// editor jmna prvku

// test, zda byl prvek nalezen
	if (itemN != -1)							// pokud je vybrn njak prvek
	{
		item = &(buf->m_Items[itemN]);			// ukazatel na prvek

// pprava editoru jmna
		name = (CEdit*)(MainFrame->m_wndPropBar.GetDlgItem(IDC_PROG_EDIT));

// naten textu z editoru
		if (name != NULL)
			name->GetWindowText(txt);			// naten textu do bufferu

// vytvoen novho textu nebo zmna aktulnho textu
		if (item->name == -1)					// byl text dosud implicitn ?
			item->name = buf->m_Text->Add(txt);	// vytvoen novho textu
		else
			buf->m_Text->Set(item->name, txt);	// zmna aktulnho textu

// nastaven textu do stromu
		buf->m_Tree->SetItemText(item->htree,txt); // nastaven textu

// aktualizace zobrazen zvislch buffer
		if (item->counter)						// jsou reference z jinch buffer ?
		{
			AktNameTree(BufObjID, txt, m_AktBufID, itemN);
			AktNameTree(BufLocID, txt, m_AktBufID, itemN);
			AktNameTree(BufClsID, txt, m_AktBufID, itemN);
			AktNameTree(BufEdiID, txt, m_AktBufID, itemN);
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace zobrazen jmna zvislch poloek

void CProg::AktNameTree(int bufID, CString& txt, int bufrefID, int itemref)
{
// lokln promnn
	CProgBuf* buf = &(m_Buf[bufID]);			// adresa bufferu
	int num = buf->m_Num;						// poet poloek v bufferu
	PROGITEM* item;								// ukazatel poloek
	int i;									// ukazatel sla poloky

// cyklus pes vechny poloky
	for (i = num-1; i >= 0; i--)
	{
		item = &(buf->m_Items[i]);				// adresa poloky

// test, zda je to poloka s hledanou referenc
		if (item->refer == itemref)				// je to hledan reference ?
		{

// kontrola ostatnch parametr, zda je implicitn text
			if ((item->typ == bufrefID) &&		// je to hledan buffer ?
				(item->name == -1))				// je implicitn jmno ?
			{

// oprava textu poloky ve stromu
				if (item->htree != NULL)		// je platn poloka stromu ?
					buf->m_Tree->SetItemText(item->htree,txt);

// aktualizace zobrazen v zvislm bufferu OBJECT -> EDIT
				if (bufID == BufObjID)
					AktNameTree(BufEdiID, txt, BufObjID, i);

// aktualizace zobrazen v zvislm bufferu LOCAL -> EDIT
				if (bufID == BufLocID)
					AktNameTree(BufEdiID, txt, BufLocID, i);

// aktualizace zobrazen v zvislm bufferu CLASS -> OBJECT, LOCAL
				if (bufID == BufClsID)
				{
					AktNameTree(BufObjID, txt, BufClsID, i);
					AktNameTree(BufLocID, txt, BufClsID, i);
				}
			}
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// zahjen editace jmna ve stromu

void CProg::OnBeginLabelEdit(NMHDR* pNMHDR, LRESULT* pResult) 
{
// lokln promnn, nalezen poloky pod kurzorem
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// adresa bufferu
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // identifiktor poloky
	int itemN = buf->SrcItem(htree);			// islo poloky
	CEdit* inplace;							// okno inplace editoru jmna

// zkaz editace poloky
	*pResult = TRUE;							// je peruen operace
	if (itemN != -1)							// je platn aktivn poloka ?
		if (!(buf->m_Items[itemN].param & (PR_LOCK | PR_LOCK_DEP))) // je zkaz ?
		{

// pznak zahjen editace
			m_Editing = TRUE;					// pznak editace
			*pResult = FALSE;					// nen peruen operace

// schova pvodnho textu
			inplace = m_Buf[m_AktBufID].m_Tree->GetEditControl();
			if (inplace != NULL)				// je editor platn ?
				inplace->GetWindowText(m_OldName);	// schova textu
		}
}


/////////////////////////////////////////////////////////////////////////////
// konec editace jmna ve stromu

void CProg::OnEndLabelEdit(NMHDR* pNMHDR, LRESULT* pResult) 
{
// lokln promnn
	CEdit* name;							// okno editoru jmna
	CEdit* inplace;							// okno inplace editoru jmna
	CString txt;							// buffer k naten textu

// okno editoru jmna
	name = (CEdit*)(MainFrame->m_wndPropBar.GetDlgItem(IDC_PROG_EDIT));

// okno inplace editoru jmna
	inplace = m_Buf[m_AktBufID].m_Tree->GetEditControl();

// kontrola, zda jsou editory platn
	if ((name != NULL) && (inplace != NULL))
	{

// naten textu z inplace editoru
		inplace->GetWindowText(txt);		// naten textu z editoru

// je-li text nezmnn, nemn se pznak implicitnho textu
		if (txt.Compare(m_OldName))			// je text zmnn ?
		{

// uloen textu do editoru jmna (provede se aktualizace)
			name->SetWindowText(txt);		// uloen textu do editoru

// pro przdn text se zapne implicitn jmno
			if (!(txt.GetLength()))			// je text przdn ?
				OnProgDef();				// zapnut implicitnho textu
		}

// zruen pznaku editace
		m_Editing = FALSE;					// zruen pznaku editace
	}

// nvratov kd - ve OK
	*pResult = FALSE;			// nen peruen
}


/////////////////////////////////////////////////////////////////////////////
// zahjen editace jmna stiskem Alt+Enter

void CProg::OnKeyDownProg(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_KEYDOWN* pTVKeyDown = (TV_KEYDOWN*)pNMHDR;
	
	if (pTVKeyDown->wVKey == VK_RETURN)
	{
		if (GetKeyState(VK_MENU) < 0)
			::PostMessage(m_Buf[m_AktBufID].m_Tree->m_hWnd, 
				TVM_EDITLABEL, 0, (LPARAM)m_Buf[m_AktBufID].m_Tree->GetSelectedItem());
	}
	*pResult = 0;
}


/////////////////////////////////////////////////////////////////////////////
// editace ikony

void CProg::OnProgIcon() 
{
// lokln promnn
	CProgBuf* buf = &(m_Buf[m_AktBufID]);		// aktuln buffer
	HTREEITEM htree = buf->m_Tree->GetSelectedItem(); // nalezen aktivn poloky
	int itemN = buf->SrcItem(htree);			// nalezen indexu aktivn poloky
	PROGITEM* item;								// ukazatel na poloku
	int icon;									// editovan ikona

	if (itemN == -1) return;
	
	item = &(buf->m_Items[itemN]);			// ukazatel na prvek

	icon = item->icon;

	if (icon == -1)
	{
		icon = m_Icon.Duplik(buf->GetIcon(itemN));
		item->icon = icon;
		buf->m_Tree->SetItemImage(item->htree,icon,icon);

		RefreshIcon();			// aktualizace ikon ve stromech

		if (item->counter)						// jsou reference z jinch buffer ?
		{
			AktIconTree(BufObjID, icon, m_AktBufID, itemN);
			AktIconTree(BufLocID, icon, m_AktBufID, itemN);
			AktIconTree(BufClsID, icon, m_AktBufID, itemN);
			AktIconTree(BufEdiID, icon, m_AktBufID, itemN);
		}
	}

	PushEditHist();							// schova historie editace
	m_EditItem = icon;
	SetEditMode(TYP_PIC);
}


/////////////////////////////////////////////////////////////////////////////
// aktualizace zobrazen ikony zvislch poloek

void CProg::AktIconTree(int bufID, int icon, int bufrefID, int itemref)
{
// lokln promnn
	CProgBuf* buf = &(m_Buf[bufID]);			// adresa bufferu
	int num = buf->m_Num;						// poet poloek v bufferu
	PROGITEM* item;								// ukazatel poloek
	int i;									// ukazatel sla poloky

// cyklus pes vechny poloky
	for (i = num-1; i >= 0; i--)
	{
		item = &(buf->m_Items[i]);				// adresa poloky

// test, zda je to poloka s hledanou referenc
		if (item->refer == itemref)				// je to hledan reference ?
		{

// kontrola ostatnch parametr, zda je implicitn ikona
			if ((item->typ == bufrefID) &&		// je to hledan buffer ?
				(item->icon == -1))				// je implicitn ikona ?
			{

// oprava ikony poloky ve stromu
				if (item->htree != NULL)		// je platn poloka stromu ?
					buf->m_Tree->SetItemImage(item->htree,icon,icon);

// aktualizace zobrazen v zvislm bufferu OBJECT -> EDIT
				if (bufID == BufObjID)
					AktIconTree(BufEdiID, icon, BufObjID, i);

// aktualizace zobrazen v zvislm bufferu LOCAL -> EDIT
				if (bufID == BufLocID)
					AktIconTree(BufEdiID, icon, BufLocID, i);

// aktualizace zobrazen v zvislm bufferu CLASS -> OBJECT, LOCAL
				if (bufID == BufClsID)
				{
					AktIconTree(BufObjID, icon, BufClsID, i);
					AktIconTree(BufLocID, icon, BufClsID, i);
				}
			}
		}
	}
}



/////////////////////////////////////////////////////////////////////////////
// zruen poloky pod kurzorem

void CProg::OnProgDel() 
{
}


/////////////////////////////////////////////////////////////////////////////
// schova poloky

void CProg::OnProgClip() 
{
}

