
/******************************************************************\
*                                                                  *
*                        Buffer zvuku                              *
*                                                                  *
\******************************************************************/

#include "stdafx.h"
#include "peter.h"
#include "MainFrm.h"
#include "IconBuf.h"
#include "TextBuf.h"
#include "RealBuf.h"
#include "BoolBuf.h"
#include "MapBuf.h"
#include "SndBuf.h"
#include "SprtBuf.h"
#include "ProgBuf.h"
#include "EditDial.h"
#include "EditSprt.h"
#include "EditIcon.h"
#include "EditMap.h"
#include "EditSnd.h"
#include "Prog.h"
#include "Exec.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////
// konstruktor a destruktor

CSoundBuf::CSoundBuf()
{
	m_Data = NULL;			// nen tabulka adres
	m_Num = 0;				// nen dn poloka
	m_Max = 0;				// nen buffer
}

CSoundBuf::~CSoundBuf()
{
	RemoveAll();			// zruen dat
	Aloc(m_Data,0);			// zruen tabulky adres
}

////////////////////////////////////////////////////////////////////
// pidn nov poloky - data se nesm ruit ! (vrac index nov poloky)

int CSoundBuf::Add(WAVFORMAT* data)
{
// zvten buffer index
	if (m_Num >= m_Max)				// je maximum ?
	{
		m_Max += 20;				// zven hranice
		Aloc(m_Data, m_Max);		// zvten bufferu adres
	}

// nastaven nov poloky
	m_Data[m_Num] = data;			// nastaven novch dat
	m_Num++;						// zven potu poloek

// navrcen indexu nov poloky
	return m_Num - 1;				// navrcen indexu nov poloky
}

////////////////////////////////////////////////////////////////////
// vytvoen nov poloky (vrac index)

int CSoundBuf::New()
{
// vytvoen novho (przdnho) zvuku
	WAVFORMAT* head = NULL;			// buffer pro zhlav
	Aloc(head, sizeof(WAVFORMAT));
	*head = wavstd;						// nastaven standardnho zhlav

// pidn do bufferu
	return Add(head);
}

////////////////////////////////////////////////////////////////////
// duplikace poloky (vrac index)

int CSoundBuf::Duplik(int index)
{
// zjitn daj o zdrojovm zvuku
	WAVFORMAT* src = Get(index);
	int size = SoundSize(src);

// vytvoen kopie dat
	WAVFORMAT* dst = NULL;
	Aloc(dst, size);
	memcpy(dst, src, size);

// pidn novch dat do bufferu
	return Add(dst);
}


////////////////////////////////////////////////////////////////////
// kopie dat z jinho bufferu do poloky se zadanm indexem
void CSoundBuf::CopyDat(int index, WAVFORMAT* data)
{
// zjitn velikosti zdrojovho zvuku
	int size = SoundSize(data);

// nastaven nov velikosti bufferu se zvukem
	ASSERT((index >= 0) && (index < m_Num));
	Aloc(m_Data[index], size);

// kopie dat
	memcpy(m_Data[index], data, size);
}

////////////////////////////////////////////////////////////////////
// pidn kopie dat do bufferu (vrt index nov poloky)
int CSoundBuf::CopyAdd(WAVFORMAT* data)
{
// zjitn velikosti zdrojovho zvuku
	int size = SoundSize(data);

// vytvoen bufferu
	WAVFORMAT* buff = NULL;
	Aloc(buff, size);

// kopie dat
	memcpy(buff, data, size);

// pidn poloky do bufferu
	return Add(buff);
}

////////////////////////////////////////////////////////////////////
// naten zvuku ze souboru (vrac index, -1=chyba)
int CSoundBuf::LoadFile(CString name)
{
// lokln promnn
	HANDLE hFile;						// handle souboru
	DWORD read;							// poet natench bajt
	DWORD size;							// velikost souboru
	WAVFORMAT* buffer = NULL;			// buffer k naten dat

// oteven souboru
	hFile = ::CreateFile(name, GENERIC_READ, 
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL, NULL);

// test, zda byl soubor oteven OK
	if (hFile != INVALID_HANDLE_VALUE)
	{

// zjitn velikosti souboru
		size = ::SetFilePointer(hFile, 0, NULL, FILE_END);

// nastaven ukazatele na zatek souboru
		::SetFilePointer(hFile, 0, NULL, FILE_BEGIN);

// vytvoen bufferu k naten souboru
		Aloc(buffer, size);				// vytvoen bufferu

// naten souboru
		::ReadFile(hFile, buffer, size, &read, NULL);

// uzaven souboru
		::CloseHandle(hFile);		// uzaven souboru

// kontrola souboru
		if ((buffer->tWavIdent[0] != 'R') ||
			(buffer->tWavIdent[1] != 'I') ||
			(buffer->tWavIdent[2] != 'F') ||
			(buffer->tWavIdent[3] != 'F') ||
			(buffer->nFileSize + 8 > size))
		{
			Aloc(buffer, 0);
			return -1;
		}

// uloen bufferu do seznamu
		return Add(buffer);
	}

// chyba oteven souboru
	return -1;
}
