
/////////////////////////////////////////////////////////////////////////////
// zhlav WAV souboru

typedef struct tagWAVFORMAT
{
// popisova souboru
	char	tWavIdent[4];		// (4) identifikace souboru (= "RIFF")
	DWORD	nFileSize;			// (4) velikost souboru bez 8 bajt (na toto zhlav)

// popisova formtu
	char	tFormatIdent[8];	// (8) identifikace zhlav formtu (= "WAVEfmt")
	DWORD	nFormatSize;		// (4) velikost nsledujcch dat popisovae formtu (= 0x10)
	WORD	wFormatTag;			// (2) formt dat (1 = PCM)
	WORD	nChannels;			// (2) poet kanl (1 = mono, 2 = stereo)
	DWORD	nSamplesPerSec;		// (4) vzorkovac kmitoet (vzork za sekundu)
	DWORD	nAvgBytesPerSec;	// (4) penosov rychlost (bajt za sekundu)
	WORD	nBlockAlign;		// (2) zarovnvn dat (bity*kanly/8)
	WORD	wBitsPerSample;		// (2) poet bit na jeden vzorek

// popisova dat
	char	tDataIdent[4];		// (4) identifikace dat "data"
	DWORD	nDataSize;			// (4) velikost nsledujcch dat (v bajtech)
} WAVFORMAT;


extern const WAVFORMAT wavstd;		// zhlav przdnho souboru WAV


inline void Aloc(WAVFORMAT*& adr, int size)			// zadv se v potu bajt !
	{ adr = (WAVFORMAT*)_Aloc(adr, size); }

inline void Aloc(WAVFORMAT**& adr, int size)		// zadv se v potu poloek ukazatel !
	{ adr = (WAVFORMAT**)_Aloc(adr, size*sizeof(WAVFORMAT*)); }



#define SOUNDDEFRATE		22050		// implicitn vzorkovac kmitoet zvuku
#define SOUNDDEFCHANNELS	1			// implicitn poet kanl
#define SOUNDDEFBITS		8			// implicitn poet bit na vzorek
#define SOUNDMAXLENGTH		30			// maximln dlka zznamu (sekund)

#define SOUNDDEFBYTES		(SOUNDDEFRATE*SOUNDDEFCHANNELS*(SOUNDDEFBITS/8))	// poet bajt za sekundu


////////////////////////////////////////////////////////////////////
// tda bufferu zvuku
// Kad zvuk obsahuje na offsetu 4 velikost dat - 8

class CSoundBuf : public CObject
{
public:
	CSoundBuf();				// konstruktor
	virtual ~CSoundBuf();		// destruktor

	WAVFORMAT**	m_Data;			// adresy buffer se zvuky
	int			m_Num;			// poet poloek v bufferu
	int			m_Max;			// velikost bufferu adres

// vyprzdnn bufferu
	inline void RemoveAll()
	{
		Delete(m_Num);
	}

// zjitn adresy poloky
	inline WAVFORMAT* Get(int index) const
	{
		ASSERT((index >= 0) && (index < m_Num));
		return m_Data[index];
	}

// zjitn dlky zvuku v bajtech
	inline int SoundSize(WAVFORMAT* data) const
	{
		return data->nFileSize + 8;
	}

// nastaven daje dlky zvuku
	inline void SetSoundSize(WAVFORMAT* data, int size)
	{
		data->nFileSize = size - 8;
	}

// nastaven nov poloky (star data zru)
	inline void Set(int index, WAVFORMAT* data)
	{
		ASSERT((index >= 0) && (index < m_Num));
		Aloc(m_Data[index], 0);
		m_Data[index] = data;
	}

// zruen poloek z konce (zadv se poet poloek)
	inline void Delete(int pocet)
	{
		ASSERT((pocet >= 0) && (pocet <= m_Num));

		int index = m_Num-1;
		m_Num -= pocet;
		
		for (; pocet > 0; pocet--)
		{
			Aloc(m_Data[index], 0);
			index--;
		}
	}

// kopie dat z jinho bufferu do poloky se zadanm indexem
	void CopyDat(int index, WAVFORMAT* data);

// navrcen potu poloek v bufferu
	inline int GetSize() const
		{ return m_Num; }

// pidn nov poloky do bufferu (vrac index poloky)
	int Add(WAVFORMAT* data);

// vytvoen nov poloky (vrac index)
	int New();

// duplikace poloky
	int Duplik(int Index);

// pidn kopie dat do bufferu (vrt index nov poloky)
	int CopyAdd(WAVFORMAT* data);

// naten zvuku ze souboru (vrac index)
	int LoadFile(CString name);
};

