
/******************************************************************\
*                                                                  *
*                        Buffer sprajt                            *
*                                                                  *
\******************************************************************/

#include "stdafx.h"
#include "peter.h"
#include "MainFrm.h"
#include "IconBuf.h"
#include "TextBuf.h"
#include "RealBuf.h"
#include "BoolBuf.h"
#include "MapBuf.h"
#include "SprtBuf.h"
#include "SndBuf.h"
#include "ProgBuf.h"
#include "EditDial.h"
#include "EditSprt.h"
#include "EditIcon.h"
#include "EditMap.h"
#include "EditSnd.h"
#include "Prog.h"
#include "Exec.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DATAREZERVA		0x1000	// rezerva pi zvtovn bufferu dat (bajt)
#define INDEXREZERVA	100		// rezerva pi zvtovn bufferu index (poloek)

////////////////////////////////////////////////////////////////////
// konstruktor a destruktor

CSpriteBuf::CSpriteBuf()
{
	m_Data = NULL;			// nejsou data sprajt
	m_Index = NULL;			// nejsou indexy sprajt
	m_Num = 0;				// nen dn poloka v bufferu
	m_IndexMax = 0;			// velikost bufferu index sprajt (poloek)
	m_DataNum = 0;			// poet bajt v bufferu dat sprajt
	m_DataMax = 0;			// velikost bufferu dat sprajt
	m_ProgBuf = NULL;		// nen buffer programu
	m_GenPal = FALSE;		// nejsou palety
}

CSpriteBuf::~CSpriteBuf()
{
	Aloc(m_Data,0);			// zruen bufferu dat
	Aloc(m_Index,0);		// zruen bufferu index
}


////////////////////////////////////////////////////////////////////
// pidn poloky do bufferu (vrac index)

int CSpriteBuf::Add(SPRITE* sprite)
{
// velikost pidvan poloky v bajtech
	int size = SpriteSize(sprite);

// zvten bufferu index
	if (m_Num >= m_IndexMax)
	{
		m_IndexMax = m_Num + INDEXREZERVA;
		Aloc(m_Index, m_IndexMax);
	}

// zvten bufferu dat
	if (m_DataNum+size > m_DataMax)
	{
		m_DataMax = m_DataNum + size + DATAREZERVA;
		Aloc(m_Data, m_DataMax);
	}

// kopie dat poloky
	memcpy(m_Data + m_DataNum, sprite, size);

// nastaven indexu na poloku
	m_Index[m_Num] = m_DataNum;

// zven tae poloek
	m_Num++;

// zven ukazatele velikosti dat v bufferu
	m_DataNum += size;

// navrcen indexu nov poloky
	return m_Num-1;
}


////////////////////////////////////////////////////////////////////
// vytvoen nov mapy danch rozmr (vrac index, omez velikost)

int CSpriteBuf::New(int faze, int smer)
{
// omezen velikosti mapy
	if (faze > MAXSPRITEFAZE)
		faze = MAXSPRITEFAZE;

	if (smer > MAXSPRITESMER)
		smer = MAXSPRITESMER;

	if (faze < 1)
		faze = 1;

	if (smer < 1)
		smer = 1;

// velikost nov poloky v bajtech
	int size = faze*smer*SPRITEDEFWIDTH*SPRITEDEFHEIGHT - 1 + sizeof(SPRITE);

// zvten bufferu index
	if (m_Num >= m_IndexMax)
	{
		m_IndexMax = m_Num + INDEXREZERVA;
		Aloc(m_Index, m_IndexMax);
	}

// zvten bufferu dat
	if (m_DataNum+size > m_DataMax)
	{
		m_DataMax = m_DataNum + size + DATAREZERVA;
		Aloc(m_Data, m_DataMax);
	}

// adresa nov poloky
	SPRITE* sprite = (SPRITE*)(m_Data + m_DataNum);

// inicializace dat poloky
	sprite->faze = faze;
	sprite->smer = smer;
	sprite->delay = SPRITEDEFDELAY;
	sprite->krok = SPRITEDEFKROK;
//	sprite->width = SPRITEDEFWIDTH;
//	sprite->height = SPRITEDEFHEIGHT;
	memset(&sprite->item[0], 0, faze*smer*SPRITEDEFWIDTH*SPRITEDEFHEIGHT);

// nastaven indexu na poloku
	m_Index[m_Num] = m_DataNum;

// zven tae poloek
	m_Num++;

// zven ukazatele velikosti dat v bufferu
	m_DataNum += size;

// navrcen indexu nov poloky
	return m_Num-1;
}


////////////////////////////////////////////////////////////////////
// nastaven nov velikosti sprajtu (omez velikost)

void CSpriteBuf::SetSize(int Index, int faze, int smer)
{
// lokln promnn
	int size;							// nov velikost poloky
	int oldsize;						// pvodn velikost poloky
	int difsize;						// rozdl velikost (zven)
	int oldfaze;						// pvodn poet fz poloky
	int oldsmer;						// pvodn poet smr poloky
	int i;								// pracovn ta
	BYTE* src;							// ukazatele pi operacch pesunu
	BYTE* dst;
	int iconsize;						// velikost ikony (bajt)
	SPRITE* sprite;						// adresa sprajtu

// kontrola indexu
	if ((Index < 0) || (Index >= m_Num))
		return;

// omezen velikosti sprajtu
	if (faze > MAXSPRITEFAZE)
		faze = MAXSPRITEFAZE;

	if (smer > MAXSPRITESMER)
		smer = MAXSPRITESMER;

	if (faze < 1)
		faze = 1;

	if (smer < 1)
		smer = 1;

// pvodn velikost poloky v bajtech
	sprite = Get(Index);					// adresa sprajtu
	oldsize = SpriteSize(sprite);			// pvodn velikost

// schova rozmr ikony
	iconsize = SPRITEDEFWIDTH*SPRITEDEFHEIGHT; //sprite->width*sprite->height;

// nov velikost poloky v bajtech, rozdl velikost
	size = faze*smer*iconsize - 1 + sizeof(SPRITE);
	difsize = size - oldsize;			// rozdl velikost

// zvten bufferu dat, je-li poteba
	if (m_DataNum + difsize > m_DataMax)
	{
		m_DataMax = m_DataNum + difsize + DATAREZERVA;
		Aloc(m_Data, m_DataMax);
		sprite = Get(Index);			// nov adresa po realokaci
	}

// schova pvodnch parametr poloky
	oldfaze = sprite->faze;				// pvodn poet fz poloky
	oldsmer = sprite->smer;				// pvodn poet smr poloky

// oprava potu smr
	if (smer != oldsmer)
	{
		src = (BYTE*)sprite + oldfaze*oldsmer*iconsize - 1 + sizeof(SPRITE);
		dst = (BYTE*)sprite + oldfaze*smer*iconsize - 1 + sizeof(SPRITE);

		if (Index < m_Num-1)
		{
			memmove(dst, src, m_DataNum - m_Index[Index+1]); // psun/odsun zbylch sprajt
		}

		m_DataNum += (smer-oldsmer)*oldfaze*iconsize;	// zmna velikosti dat
		sprite->smer = smer;				// nov poet smr poloky

		if (smer > oldsmer)
		{
			memset(src, 0, (smer - oldsmer)*oldfaze*iconsize); // inicializace novch ikon
		}
	}

// oprava dlky dk
	if (faze != oldfaze)
	{
		src = (BYTE*)sprite + oldfaze*iconsize - 1 + sizeof(SPRITE);
		dst = (BYTE*)sprite + faze*iconsize - 1 + sizeof(SPRITE);

		for (i = 0; i < smer; i++)
		{
			memmove(dst, src, m_DataNum - (m_Index[Index] + (i*faze+oldfaze)*iconsize - 1 + sizeof(SPRITE)));

			if (faze > oldfaze)
			{
				memset(src, 0, (faze-oldfaze)*iconsize);
			}

			src += faze*iconsize;
			dst += faze*iconsize;
			m_DataNum += (faze - oldfaze)*iconsize;
		}
		sprite->faze = faze;					// nov ka poloky
	}

// korekce index na ostatn poloky
	for (i = Index+1; i < m_Num; i++)
	{
		m_Index[i] += difsize;
	}
}


////////////////////////////////////////////////////////////////////
// zruen poloky

void CSpriteBuf::Delete(int Index)
{
// lokln promnn
	int i, b;					// pracovn tae
	int	size;					// velikost ruench dat
	CProgBuf* buf;				// ukazatel na programov buffer
	PROGITEM* item;				// ukazatel na poloku programu

// kontrola indexu
	if ((Index < 0) || (Index >= m_Num))
		return;

// poet bajt ke zruen
	size = SpriteSize(Index);

// zruen dat poloky (psun zbylch poloek)
	if (Index < m_Num-1)
		memmove(&(m_Data[m_Index[Index]]), &(m_Data[m_Index[Index+1]]), 
			m_DataNum - m_Index[Index+1]);

// snen tae dat v bufferu
	m_DataNum -= size;

// zruen indexu a korekce zbylch index
	for (i = Index; i < m_Num-1; i++)
	{
		m_Index[i] = m_Index[i+1] - size;
	}

// snen tae poloek
	m_Num--;

// korekce referenc v programovch bufferech
	if (m_ProgBuf != NULL)
	{
		for (b = 0; b < PROGBUFNUM; b++) // ukazatel sla bufferu
		{
			buf = &m_ProgBuf[b]; // adresa bufferu

			for (i = buf->m_Num-1; i >= 0; i--) // tn indexu poloky dol
			{
				item = &(buf->m_Items[i]);		// schova adresy poloky
	
				if ((item->data == BufSprID) &&	// odkaz na buffer sprajt
					(item->index >= Index))		// index, kter bude ovlivnn
				{
					if (item->index == Index)	// je to ruen index ?
					{
						item->index = -1;		// zruen odkazu
						item->data = -1;
					}
					else
						item->index--;			// jinak korekce indexu
				}
			}
		}
	}
}


////////////////////////////////////////////////////////////////////
// duplikace poloky

int CSpriteBuf::Duplik(int Index)
{
// korekce indexu
	if ((Index < 0) || (Index >= m_Num))
		Index = 0;

// velikost pidvan poloky v bajtech
	int size = SpriteSize(Index);

// zvten bufferu index
	if (m_Num >= m_IndexMax)
	{
		m_IndexMax = m_Num + INDEXREZERVA;
		Aloc(m_Index, m_IndexMax);
	}

// zvten bufferu dat
	if (m_DataNum+size > m_DataMax)
	{
		m_DataMax = m_DataNum + size + DATAREZERVA;
		Aloc(m_Data, m_DataMax);
	}

// kopie dat poloky
	memcpy(m_Data + m_DataNum, Get(Index), size);

// nastaven indexu na poloku
	m_Index[m_Num] = m_DataNum;

// zven tae poloek
	m_Num++;

// zven ukazatele velikosti dat v bufferu
	m_DataNum += size;

// navrcen indexu nov poloky
	return m_Num-1;
}


/////////////////////////////////////////////////////////////////////////////
// naten sprajtu z resource

void CSpriteBuf::LoadRes(int id)
{
// lokln promnn
	HRSRC res;						// resource identifiktor bitmapy
	HGLOBAL data;					// globln buffer dat bitmapy
	BITMAPINFO* bmp;				// ukazatel na data bitmapy
	int faze;						// poet fz v bitmap
	int smer;						// poet smr v bitmap
	BYTE* src;						// ukazatel zdrojov adresy
	BYTE* dst;						// ukazatel clov adresy
	int srcinc;						// prustek zdrojov adresy = dlka linky
	int i,j,l;						// pracovn tae

// nalezen resource bitmapy
	res = ::FindResource(AfxGetResourceHandle(),
		MAKEINTRESOURCE(id), RT_BITMAP);
	ASSERT(res != NULL);

// naten bitmapy do pamti
	data = ::LoadResource(AfxGetResourceHandle(), res);
	ASSERT(data != NULL);

// ukazatel na data bitmapy
	bmp = (BITMAPINFO*) ::LockResource(data);

// pprava konverzn tabulky palet
	if (!m_GenPal)
	{
		GenKonvPal(bmp);
		m_GenPal = TRUE;
	}

// pprava potu fz a smr v bitmap
	faze = bmp->bmiHeader.biWidth / SPRITEDEFWIDTH;
	smer = bmp->bmiHeader.biHeight / SPRITEDEFHEIGHT;

// pprava prustku zdrojov adresy
	srcinc = (bmp->bmiHeader.biWidth + 3) & ~0x3;

// pprava zdrojov adresy
	src = (BYTE*) &(bmp->bmiColors[256]) + (smer-1)*SPRITEDEFHEIGHT*srcinc;

// pprava ukldac adresy
	dst = &(Get(New(faze, smer))->item[0]);

// cyklus pes vechny smry
	for (l = smer-1; l >= 0; l--)
	{

// cyklus pes vechny fze
		for (i = faze-1; i >= 0; i--)
		{

// cyklus pes vechny linky jedn ikony
			for (j = SPRITEDEFHEIGHT-1; j >= 0; j--)
			{

// kopie jedn linky ikony
				KonvCopy(dst, src, SPRITEDEFWIDTH);

// zven ukldac a tec adresy
				dst += SPRITEDEFWIDTH;	// ukldac adresa
				src += srcinc;			// tec adresa
			}

// posun tec adresy na dal fzi (ukldac adresa je OK)
			src -= SPRITEDEFHEIGHT*srcinc - SPRITEDEFWIDTH;
		}

// posun tec adresy na dal smr (ukldac adresa je OK)
		src -= SPRITEDEFHEIGHT*srcinc + faze*SPRITEDEFWIDTH;
	}
}

