
////////////////////////////////////////////////////////////////////
// definice zobrazen poloky sprajtu
//
// Ikony jsou ve sprajtu ukldny s prioritou: fze, smry

#define MAXSPRITEFAZE	32		// maximln poet fz sprajtu
#define	MAXSPRITESMER	32		// maximln poet smr sprajtu
#define MAXSPRITEDELAY	3600000	// maximln prodleva fz
#define MAXSPRITEKROK	1000	// maximln poet fz na krok

#define SPRITEDEFFAZE	5		// implicitn poet fz sprajtu
#define SPRITEDEFSMER	4		// implicitn poet smr sprajtu
#define SPRITEDEFKROK	4		// implicitn poet fz na krok
#define SPRITEDEFWIDTH	32		// implicitn ka sprajtu
#define SPRITEDEFHEIGHT	32		// implicitn vka sprajtu
#define SPRITEDEFDELAY	55		// implicitn prodleva mezi fzemi v [ms]

typedef struct tagSPRITE {
	long		faze;			// poet fz
	long		smer;			// poet smr
	long		delay;			// prodleva mezi dvma fzemi v [ms]
	long		krok;			// poet fz na krok
//	double		krok;			// poet fz na krok
//	long		hladina;		// hladina k zobrazen
	BYTE		item[1];		// obrzky sprajtu (poad: fze, smry)
} SPRITE;

////////////////////////////////////////////////////////////////////
// tda bufferu mapy

class CSpriteBuf : public CObject
{
public:
	CSpriteBuf();				// konstruktor
	virtual ~CSpriteBuf();		// destruktor

	BYTE*		m_Data;			// data sprajt
	int*		m_Index;		// indexy sprajt

	int			m_Num;			// poet poloek v bufferu
	int			m_IndexMax;		// velikost bufferu index map (poloek)

	int			m_DataNum;		// poet bajt v bufferu dat sprajt
	int			m_DataMax;		// velikost bufferu dat sprajt (bajt)

	BOOL		m_GenPal;		// pznak vygenerovn palet

	CProgBuf*	m_ProgBuf;		// adresa tabulky buffer

// vyprzdnn bufferu
	inline void RemoveAll()
	{
		m_Num = 0;
		m_DataNum = 0;
	}

// zjitn adresy poloky
	inline SPRITE* Get(int Index)
	{
		if ((Index <= 0) || (Index >= m_Num))
			return (SPRITE*) m_Data;
		else
			return (SPRITE*) &(m_Data[m_Index[Index]]);
	}

// navrcen potu poloek v bufferu
	inline int GetSize() const
		{ return m_Num; }

// pidn nov poloky do bufferu
	int Add(SPRITE* sprite);

// duplikace poloky
	int Duplik(int Index);

// nastaven prodlevy fz
	inline void SetDelay(int Index, int delay)
		{ 
			if ((Index >= 0) && (Index < m_Num))
				((SPRITE*)&(m_Data[m_Index[Index]]))->delay = delay; 
		}

// vytvoen novho sprajtu danch rozmr (vrac index, omez velikost)
	int New(int faze, int smer);

// vpoet velikosti sprajtu v bajtech
	inline int SpriteSize(SPRITE* sprite)
		{ return sprite->faze*sprite->smer*SPRITEDEFWIDTH*SPRITEDEFHEIGHT /*sprite->width*sprite->height*/ - 1 + sizeof(SPRITE); }

	inline int SpriteSize(int Index)
		{ return SpriteSize(Get(Index)); }

// zruen poloky z bufferu
	void Delete(int Index);

// nastaven nov velikosti sprajtu (omez velikost)
	void SetSize(int Index, int faze, int smer);

// naten sprajtu z resource
	void CSpriteBuf::LoadRes(int id);
};

